/* player.c generated by valac 0.56.18, the Vala compiler
 * generated from player.vala, do not modify */

/* Copyright 2023-2024 Vladimir Vaskov
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gst/gst.h>
#include <gee.h>
#include <gio/gio.h>

#define CASSETTE_CLIENT_PLAYER_PLAYER_PLAY_CALLBACK_STEP 1.0
#define CASSETTE_CLIENT_YA_MAPI_ROTOR_FEEDBACK_TYPE_TRACK_FINISHED "trackFinished"
#define CASSETTE_CLIENT_YA_MAPI_ROTOR_FEEDBACK_TYPE_SKIP "skip"
#define CASSETTE_CLIENT_YA_MAPI_ROTOR_FEEDBACK_TYPE_TRACK_STARTED "trackStarted"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	CASSETTE_CLIENT_PLAYER_STATE_NONE,
	CASSETTE_CLIENT_PLAYER_STATE_PLAYING,
	CASSETTE_CLIENT_PLAYER_STATE_PAUSED
} CassetteClientPlayerState;

#define CASSETTE_CLIENT_PLAYER_TYPE_STATE (cassette_client_player_state_get_type ())
typedef enum  {
	CASSETTE_CLIENT_PLAYER_REPEAT_MODE_OFF,
	CASSETTE_CLIENT_PLAYER_REPEAT_MODE_ONE,
	CASSETTE_CLIENT_PLAYER_REPEAT_MODE_QUEUE
} CassetteClientPlayerRepeatMode;

#define CASSETTE_CLIENT_PLAYER_TYPE_REPEAT_MODE (cassette_client_player_repeat_mode_get_type ())
typedef enum  {
	CASSETTE_CLIENT_PLAYER_SHUFFLE_MODE_OFF,
	CASSETTE_CLIENT_PLAYER_SHUFFLE_MODE_ON
} CassetteClientPlayerShuffleMode;

#define CASSETTE_CLIENT_PLAYER_TYPE_SHUFFLE_MODE (cassette_client_player_shuffle_mode_get_type ())

#define CASSETTE_CLIENT_PLAYER_TYPE_PLAYER (cassette_client_player_player_get_type ())
#define CASSETTE_CLIENT_PLAYER_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_CLIENT_PLAYER_TYPE_PLAYER, CassetteClientPlayerPlayer))
#define CASSETTE_CLIENT_PLAYER_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_CLIENT_PLAYER_TYPE_PLAYER, CassetteClientPlayerPlayerClass))
#define CASSETTE_CLIENT_PLAYER_IS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_CLIENT_PLAYER_TYPE_PLAYER))
#define CASSETTE_CLIENT_PLAYER_IS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_CLIENT_PLAYER_TYPE_PLAYER))
#define CASSETTE_CLIENT_PLAYER_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_CLIENT_PLAYER_TYPE_PLAYER, CassetteClientPlayerPlayerClass))

typedef struct _CassetteClientPlayerPlayer CassetteClientPlayerPlayer;
typedef struct _CassetteClientPlayerPlayerClass CassetteClientPlayerPlayerClass;
typedef struct _CassetteClientPlayerPlayerPrivate CassetteClientPlayerPlayerPrivate;

#define CASSETTE_CLIENT_PLAYER_TYPE_MODE (cassette_client_player_mode_get_type ())
#define CASSETTE_CLIENT_PLAYER_MODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_CLIENT_PLAYER_TYPE_MODE, CassetteClientPlayerMode))
#define CASSETTE_CLIENT_PLAYER_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_CLIENT_PLAYER_TYPE_MODE, CassetteClientPlayerModeClass))
#define CASSETTE_CLIENT_PLAYER_IS_MODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_CLIENT_PLAYER_TYPE_MODE))
#define CASSETTE_CLIENT_PLAYER_IS_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_CLIENT_PLAYER_TYPE_MODE))
#define CASSETTE_CLIENT_PLAYER_MODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_CLIENT_PLAYER_TYPE_MODE, CassetteClientPlayerModeClass))

typedef struct _CassetteClientPlayerMode CassetteClientPlayerMode;
typedef struct _CassetteClientPlayerModeClass CassetteClientPlayerModeClass;
enum  {
	CASSETTE_CLIENT_PLAYER_PLAYER_0_PROPERTY,
	CASSETTE_CLIENT_PLAYER_PLAYER_STATE_PROPERTY,
	CASSETTE_CLIENT_PLAYER_PLAYER_REPEAT_MODE_PROPERTY,
	CASSETTE_CLIENT_PLAYER_PLAYER_SHUFFLE_MODE_PROPERTY,
	CASSETTE_CLIENT_PLAYER_PLAYER_PLAYBACK_POS_SEC_PROPERTY,
	CASSETTE_CLIENT_PLAYER_PLAYER_TOTAL_PLAYED_SECONDS_PROPERTY,
	CASSETTE_CLIENT_PLAYER_PLAYER_PLAYBACK_POS_MS_PROPERTY,
	CASSETTE_CLIENT_PLAYER_PLAYER_CAN_GO_FORCE_PREV_PROPERTY,
	CASSETTE_CLIENT_PLAYER_PLAYER_VOLUME_PROPERTY,
	CASSETTE_CLIENT_PLAYER_PLAYER_MUTE_PROPERTY,
	CASSETTE_CLIENT_PLAYER_PLAYER_CAN_GO_PREV_PROPERTY,
	CASSETTE_CLIENT_PLAYER_PLAYER_CAN_GO_NEXT_PROPERTY,
	CASSETTE_CLIENT_PLAYER_PLAYER_CURRENT_TRACK_LOADING_PROPERTY,
	CASSETTE_CLIENT_PLAYER_PLAYER_MODE_PROPERTY,
	CASSETTE_CLIENT_PLAYER_PLAYER_NUM_PROPERTIES
};
static GParamSpec* cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define CASSETTE_CLIENT_TYPE_YA_MOBJECT (cassette_client_ya_mobject_get_type ())
#define CASSETTE_CLIENT_YA_MOBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_CLIENT_TYPE_YA_MOBJECT, CassetteClientYaMObject))
#define CASSETTE_CLIENT_YA_MOBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_CLIENT_TYPE_YA_MOBJECT, CassetteClientYaMObjectClass))
#define CASSETTE_CLIENT_IS_YA_MOBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_CLIENT_TYPE_YA_MOBJECT))
#define CASSETTE_CLIENT_IS_YA_MOBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_CLIENT_TYPE_YA_MOBJECT))
#define CASSETTE_CLIENT_YA_MOBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_CLIENT_TYPE_YA_MOBJECT, CassetteClientYaMObjectClass))

typedef struct _CassetteClientYaMObject CassetteClientYaMObject;
typedef struct _CassetteClientYaMObjectClass CassetteClientYaMObjectClass;

#define CASSETTE_CLIENT_YA_MAPI_TYPE_TRACK (cassette_client_ya_mapi_track_get_type ())
#define CASSETTE_CLIENT_YA_MAPI_TRACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_CLIENT_YA_MAPI_TYPE_TRACK, CassetteClientYaMAPITrack))
#define CASSETTE_CLIENT_YA_MAPI_TRACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_CLIENT_YA_MAPI_TYPE_TRACK, CassetteClientYaMAPITrackClass))
#define CASSETTE_CLIENT_YA_MAPI_IS_TRACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_CLIENT_YA_MAPI_TYPE_TRACK))
#define CASSETTE_CLIENT_YA_MAPI_IS_TRACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_CLIENT_YA_MAPI_TYPE_TRACK))
#define CASSETTE_CLIENT_YA_MAPI_TRACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_CLIENT_YA_MAPI_TYPE_TRACK, CassetteClientYaMAPITrackClass))

typedef struct _CassetteClientYaMAPITrack CassetteClientYaMAPITrack;
typedef struct _CassetteClientYaMAPITrackClass CassetteClientYaMAPITrackClass;

#define CASSETTE_CLIENT_PLAYER_TYPE_FLOW (cassette_client_player_flow_get_type ())
#define CASSETTE_CLIENT_PLAYER_FLOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_CLIENT_PLAYER_TYPE_FLOW, CassetteClientPlayerFlow))
#define CASSETTE_CLIENT_PLAYER_FLOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_CLIENT_PLAYER_TYPE_FLOW, CassetteClientPlayerFlowClass))
#define CASSETTE_CLIENT_PLAYER_IS_FLOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_CLIENT_PLAYER_TYPE_FLOW))
#define CASSETTE_CLIENT_PLAYER_IS_FLOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_CLIENT_PLAYER_TYPE_FLOW))
#define CASSETTE_CLIENT_PLAYER_FLOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_CLIENT_PLAYER_TYPE_FLOW, CassetteClientPlayerFlowClass))

typedef struct _CassetteClientPlayerFlow CassetteClientPlayerFlow;
typedef struct _CassetteClientPlayerFlowClass CassetteClientPlayerFlowClass;
typedef struct _Block39Data Block39Data;

#define CASSETTE_CLIENT_PLAYER_TYPE_SHUFFLABLE (cassette_client_player_shufflable_get_type ())
#define CASSETTE_CLIENT_PLAYER_SHUFFLABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_CLIENT_PLAYER_TYPE_SHUFFLABLE, CassetteClientPlayerShufflable))
#define CASSETTE_CLIENT_PLAYER_SHUFFLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_CLIENT_PLAYER_TYPE_SHUFFLABLE, CassetteClientPlayerShufflableClass))
#define CASSETTE_CLIENT_PLAYER_IS_SHUFFLABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_CLIENT_PLAYER_TYPE_SHUFFLABLE))
#define CASSETTE_CLIENT_PLAYER_IS_SHUFFLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_CLIENT_PLAYER_TYPE_SHUFFLABLE))
#define CASSETTE_CLIENT_PLAYER_SHUFFLABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_CLIENT_PLAYER_TYPE_SHUFFLABLE, CassetteClientPlayerShufflableClass))

typedef struct _CassetteClientPlayerShufflable CassetteClientPlayerShufflable;
typedef struct _CassetteClientPlayerShufflableClass CassetteClientPlayerShufflableClass;

#define CASSETTE_CLIENT_PLAYER_TYPE_TRACK_LIST (cassette_client_player_track_list_get_type ())
#define CASSETTE_CLIENT_PLAYER_TRACK_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_CLIENT_PLAYER_TYPE_TRACK_LIST, CassetteClientPlayerTrackList))
#define CASSETTE_CLIENT_PLAYER_TRACK_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_CLIENT_PLAYER_TYPE_TRACK_LIST, CassetteClientPlayerTrackListClass))
#define CASSETTE_CLIENT_PLAYER_IS_TRACK_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_CLIENT_PLAYER_TYPE_TRACK_LIST))
#define CASSETTE_CLIENT_PLAYER_IS_TRACK_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_CLIENT_PLAYER_TYPE_TRACK_LIST))
#define CASSETTE_CLIENT_PLAYER_TRACK_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_CLIENT_PLAYER_TYPE_TRACK_LIST, CassetteClientPlayerTrackListClass))

typedef struct _CassetteClientPlayerTrackList CassetteClientPlayerTrackList;
typedef struct _CassetteClientPlayerTrackListClass CassetteClientPlayerTrackListClass;

#define CASSETTE_CLIENT_PLAYER_TYPE_EMPTY (cassette_client_player_empty_get_type ())
#define CASSETTE_CLIENT_PLAYER_EMPTY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_CLIENT_PLAYER_TYPE_EMPTY, CassetteClientPlayerEmpty))
#define CASSETTE_CLIENT_PLAYER_EMPTY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_CLIENT_PLAYER_TYPE_EMPTY, CassetteClientPlayerEmptyClass))
#define CASSETTE_CLIENT_PLAYER_IS_EMPTY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_CLIENT_PLAYER_TYPE_EMPTY))
#define CASSETTE_CLIENT_PLAYER_IS_EMPTY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_CLIENT_PLAYER_TYPE_EMPTY))
#define CASSETTE_CLIENT_PLAYER_EMPTY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_CLIENT_PLAYER_TYPE_EMPTY, CassetteClientPlayerEmptyClass))

typedef struct _CassetteClientPlayerEmpty CassetteClientPlayerEmpty;
typedef struct _CassetteClientPlayerEmptyClass CassetteClientPlayerEmptyClass;

#define CASSETTE_CLIENT_CACHIER_TYPE_STORAGER (cassette_client_cachier_storager_get_type ())
#define CASSETTE_CLIENT_CACHIER_STORAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_CLIENT_CACHIER_TYPE_STORAGER, CassetteClientCachierStorager))
#define CASSETTE_CLIENT_CACHIER_STORAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_CLIENT_CACHIER_TYPE_STORAGER, CassetteClientCachierStoragerClass))
#define CASSETTE_CLIENT_CACHIER_IS_STORAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_CLIENT_CACHIER_TYPE_STORAGER))
#define CASSETTE_CLIENT_CACHIER_IS_STORAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_CLIENT_CACHIER_TYPE_STORAGER))
#define CASSETTE_CLIENT_CACHIER_STORAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_CLIENT_CACHIER_TYPE_STORAGER, CassetteClientCachierStoragerClass))

typedef struct _CassetteClientCachierStorager CassetteClientCachierStorager;
typedef struct _CassetteClientCachierStoragerClass CassetteClientCachierStoragerClass;
typedef struct _CassetteClientPlayerPlayerStartCurrentTrackData CassetteClientPlayerPlayerStartCurrentTrackData;
enum  {
	CASSETTE_CLIENT_PLAYER_PLAYER_QUEUE_CHANGED_SIGNAL,
	CASSETTE_CLIENT_PLAYER_PLAYER_PAUSED_SIGNAL,
	CASSETTE_CLIENT_PLAYER_PLAYER_PLAYED_SIGNAL,
	CASSETTE_CLIENT_PLAYER_PLAYER_STOPPED_SIGNAL,
	CASSETTE_CLIENT_PLAYER_PLAYER_TRACK_STOPPED_SIGNAL,
	CASSETTE_CLIENT_PLAYER_PLAYER_READY_PLAY_NEXT_SIGNAL,
	CASSETTE_CLIENT_PLAYER_PLAYER_READY_PLAY_PREV_SIGNAL,
	CASSETTE_CLIENT_PLAYER_PLAYER_NEXT_TRACK_LOADED_SIGNAL,
	CASSETTE_CLIENT_PLAYER_PLAYER_CURRENT_TRACK_START_LOADING_SIGNAL,
	CASSETTE_CLIENT_PLAYER_PLAYER_CURRENT_TRACK_FINISH_LOADING_SIGNAL,
	CASSETTE_CLIENT_PLAYER_PLAYER_PLAYBACK_CALLBACK_SIGNAL,
	CASSETTE_CLIENT_PLAYER_PLAYER_MODE_INITED_SIGNAL,
	CASSETTE_CLIENT_PLAYER_PLAYER_NUM_SIGNALS
};
static guint cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_NUM_SIGNALS] = {0};

struct _CassetteClientPlayerPlayer {
	GObject parent_instance;
	CassetteClientPlayerPlayerPrivate * priv;
};

struct _CassetteClientPlayerPlayerClass {
	GObjectClass parent_class;
};

struct _CassetteClientPlayerPlayerPrivate {
	CassetteClientPlayerState _state;
	CassetteClientPlayerRepeatMode _repeat_mode;
	CassetteClientPlayerShuffleMode _shuffle_mode;
	gdouble _total_played_seconds;
	gdouble _volume;
	gboolean _mute;
	gboolean _can_go_prev;
	gboolean _can_go_next;
	gboolean _current_track_loading;
	CassetteClientPlayerMode* _mode;
	gchar* _play_id;
	GstElement* playbin;
};

struct _Block39Data {
	int _ref_count_;
	CassetteClientPlayerPlayer* self;
	CassetteClientPlayerFlow* flow;
};

struct _CassetteClientPlayerPlayerStartCurrentTrackData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	CassetteClientPlayerPlayer* self;
	CassetteClientYaMAPITrack* current_track;
	CassetteClientPlayerMode* _tmp0_;
	CassetteClientYaMAPITrack* _tmp1_;
	CassetteClientYaMAPITrack* _tmp2_;
	CassetteClientPlayerMode* _tmp3_;
	const gchar* _tmp4_;
	CassetteClientPlayerMode* _tmp5_;
	CassetteClientPlayerMode* _tmp6_;
	CassetteClientYaMAPITrack* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* track_uri;
	CassetteClientYaMAPITrack* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	GstElement* _tmp15_;
	GValue _tmp16_;
	GValue _tmp17_;
	GstElement* _tmp18_;
	const gchar* _tmp19_;
	GValue _tmp20_;
	CassetteClientCachierStorager* _tmp21_;
	CassetteClientYaMAPITrack* _tmp22_;
	GSettings* _tmp23_;
	CassetteClientPlayerMode* _tmp24_;
	CassetteClientPlayerFlow* _tmp25_;
	CassetteClientPlayerMode* _tmp26_;
};

static gint CassetteClientPlayerPlayer_private_offset;
static gpointer cassette_client_player_player_parent_class = NULL;
VALA_EXTERN CassetteClientCachierStorager* cassette_client_storager;
VALA_EXTERN GSettings* cassette_client_settings;

VALA_EXTERN GType cassette_client_player_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType cassette_client_player_repeat_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType cassette_client_player_shuffle_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType cassette_client_player_player_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteClientPlayerPlayer, g_object_unref)
VALA_EXTERN GType cassette_client_player_mode_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteClientPlayerMode, g_object_unref)
static void cassette_client_player_player_send_callback (CassetteClientPlayerPlayer* self);
VALA_EXTERN gdouble cassette_client_player_player_get_playback_pos_sec (CassetteClientPlayerPlayer* self);
VALA_EXTERN CassetteClientPlayerState cassette_client_player_player_get_state (CassetteClientPlayerPlayer* self);
static void cassette_client_player_player_update_player (CassetteClientPlayerPlayer* self);
VALA_EXTERN CassetteClientPlayerMode* cassette_client_player_player_get_mode (CassetteClientPlayerPlayer* self);
VALA_EXTERN gint cassette_client_player_mode_get_next_index (CassetteClientPlayerMode* self,
                                                 gboolean consider_repeat_mode);
VALA_EXTERN gboolean cassette_client_player_player_get_current_track_loading (CassetteClientPlayerPlayer* self);
VALA_EXTERN gint cassette_client_player_mode_get_prev_index (CassetteClientPlayerMode* self);
VALA_EXTERN gboolean cassette_client_player_player_get_can_go_next (CassetteClientPlayerPlayer* self);
static void cassette_client_player_player_set_can_go_next (CassetteClientPlayerPlayer* self,
                                                    gboolean value);
VALA_EXTERN gboolean cassette_client_player_player_get_can_go_prev (CassetteClientPlayerPlayer* self);
static void cassette_client_player_player_set_can_go_prev (CassetteClientPlayerPlayer* self,
                                                    gboolean value);
static void cassette_client_player_player_reset_play (CassetteClientPlayerPlayer* self);
static void cassette_client_player_player_set_play_id (CassetteClientPlayerPlayer* self,
                                                const gchar* value);
VALA_EXTERN void cassette_client_player_player_set_total_played_seconds (CassetteClientPlayerPlayer* self,
                                                             gdouble value);
static void cassette_client_player_player_init (CassetteClientPlayerPlayer* self,
                                         gchar** args,
                                         gint args_length1);
VALA_EXTERN void cassette_client_player_player_seek (CassetteClientPlayerPlayer* self,
                                         gint64 ms);
VALA_EXTERN GType cassette_client_ya_mobject_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteClientYaMObject, g_object_unref)
VALA_EXTERN GType cassette_client_ya_mapi_track_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteClientYaMAPITrack, g_object_unref)
VALA_EXTERN void cassette_client_player_player_start_flow (CassetteClientPlayerPlayer* self,
                                               const gchar* station_id,
                                               GeeArrayList* queue);
VALA_EXTERN GType cassette_client_player_flow_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteClientPlayerFlow, g_object_unref)
static Block39Data* block39_data_ref (Block39Data* _data39_);
static void block39_data_unref (void * _userdata_);
VALA_EXTERN void cassette_client_player_player_stop (CassetteClientPlayerPlayer* self);
VALA_EXTERN CassetteClientPlayerRepeatMode cassette_client_player_player_get_repeat_mode (CassetteClientPlayerPlayer* self);
VALA_EXTERN void cassette_client_player_player_set_repeat_mode (CassetteClientPlayerPlayer* self,
                                                    CassetteClientPlayerRepeatMode value);
VALA_EXTERN gboolean cassette_client_ya_mapi_track_get_is_ugc (CassetteClientYaMAPITrack* self);
VALA_EXTERN CassetteClientPlayerFlow* cassette_client_player_flow_new (CassetteClientPlayerPlayer* player,
                                                           const gchar* station_id,
                                                           GeeArrayList* queue);
VALA_EXTERN CassetteClientPlayerFlow* cassette_client_player_flow_construct (GType object_type,
                                                                 CassetteClientPlayerPlayer* player,
                                                                 const gchar* station_id,
                                                                 GeeArrayList* queue);
static void cassette_client_player_player_set_mode (CassetteClientPlayerPlayer* self,
                                             CassetteClientPlayerMode* value);
VALA_EXTERN void cassette_client_player_flow_init_async (CassetteClientPlayerFlow* self,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
VALA_EXTERN gboolean cassette_client_player_flow_init_finish (CassetteClientPlayerFlow* self,
                                                  GAsyncResult* _res_);
static void __lambda103_ (Block39Data* _data39_,
                   GObject* obj,
                   GAsyncResult* res);
VALA_EXTERN CassetteClientYaMAPITrack* cassette_client_player_mode_get_current_track_info (CassetteClientPlayerMode* self);
VALA_EXTERN void cassette_client_player_player_start_current_track (CassetteClientPlayerPlayer* self,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_);
VALA_EXTERN void cassette_client_player_player_start_current_track_finish (CassetteClientPlayerPlayer* self,
                                                               GAsyncResult* _res_);
static void ___lambda103__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
VALA_EXTERN void cassette_client_player_player_start_track_list (CassetteClientPlayerPlayer* self,
                                                     GeeArrayList* queue,
                                                     const gchar* context_type,
                                                     const gchar* context_id,
                                                     gint current_index,
                                                     const gchar* context_description);
VALA_EXTERN CassetteClientPlayerTrackList* cassette_client_player_track_list_new (CassetteClientPlayerPlayer* player,
                                                                      GeeArrayList* queue,
                                                                      const gchar* context_type,
                                                                      const gchar* context_id,
                                                                      gint current_index,
                                                                      const gchar* context_description);
VALA_EXTERN CassetteClientPlayerTrackList* cassette_client_player_track_list_construct (GType object_type,
                                                                            CassetteClientPlayerPlayer* player,
                                                                            GeeArrayList* queue,
                                                                            const gchar* context_type,
                                                                            const gchar* context_id,
                                                                            gint current_index,
                                                                            const gchar* context_description);
VALA_EXTERN GType cassette_client_player_shufflable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteClientPlayerShufflable, g_object_unref)
VALA_EXTERN GType cassette_client_player_track_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteClientPlayerTrackList, g_object_unref)
VALA_EXTERN void cassette_client_player_player_clear_mode (CassetteClientPlayerPlayer* self);
VALA_EXTERN CassetteClientPlayerEmpty* cassette_client_player_empty_new (CassetteClientPlayerPlayer* player);
VALA_EXTERN CassetteClientPlayerEmpty* cassette_client_player_empty_construct (GType object_type,
                                                                   CassetteClientPlayerPlayer* player);
VALA_EXTERN GType cassette_client_player_empty_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteClientPlayerEmpty, g_object_unref)
VALA_EXTERN void cassette_client_player_player_play_pause (CassetteClientPlayerPlayer* self);
VALA_EXTERN void cassette_client_player_player_pause (CassetteClientPlayerPlayer* self);
VALA_EXTERN void cassette_client_player_player_play (CassetteClientPlayerPlayer* self);
static void cassette_client_player_player_set_state (CassetteClientPlayerPlayer* self,
                                              CassetteClientPlayerState value);
static void cassette_client_player_player_track_stop (CassetteClientPlayerPlayer* self,
                                               gboolean natural);
VALA_EXTERN gint cassette_client_ms2sec (gint64 ms);
VALA_EXTERN gint64 cassette_client_ya_mapi_track_get_duration_ms (CassetteClientYaMAPITrack* self);
VALA_EXTERN void cassette_client_player_mode_send_play_async (CassetteClientPlayerMode* self,
                                                  const gchar* play_id,
                                                  gdouble end_position_seconds,
                                                  gdouble total_played_seconds,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
VALA_EXTERN void cassette_client_player_mode_send_play_finish (CassetteClientPlayerMode* self,
                                                   GAsyncResult* _res_);
static const gchar* cassette_client_player_player_get_play_id (CassetteClientPlayerPlayer* self);
VALA_EXTERN gdouble cassette_client_player_player_get_total_played_seconds (CassetteClientPlayerPlayer* self);
VALA_EXTERN void cassette_client_player_flow_send_feedback (CassetteClientPlayerFlow* self,
                                                const gchar* feedback_type,
                                                const gchar* track_id,
                                                gdouble total_played_seconds,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
VALA_EXTERN void cassette_client_player_flow_send_feedback_finish (CassetteClientPlayerFlow* self,
                                                       GAsyncResult* _res_);
VALA_EXTERN const gchar* cassette_client_ya_mapi_track_get_id (CassetteClientYaMAPITrack* self);
static void cassette_client_player_player_next_natural (CassetteClientPlayerPlayer* self);
VALA_EXTERN gint cassette_client_player_mode_get_current_index (CassetteClientPlayerMode* self);
VALA_EXTERN void cassette_client_player_mode_next (CassetteClientPlayerMode* self,
                                       gboolean consider_repeat_mode);
static void ___lambda109_ (CassetteClientPlayerPlayer* self);
static void ____lambda109__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
VALA_EXTERN void cassette_client_player_player_next (CassetteClientPlayerPlayer* self);
static void ___lambda110_ (CassetteClientPlayerPlayer* self);
static void ____lambda110__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
VALA_EXTERN void cassette_client_player_player_prev (CassetteClientPlayerPlayer* self,
                                         gboolean ignore_progress);
VALA_EXTERN void cassette_client_player_mode_prev (CassetteClientPlayerMode* self);
static void __lambda111_ (CassetteClientPlayerPlayer* self);
static void ___lambda111__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
VALA_EXTERN void cassette_client_player_player_change_track (CassetteClientPlayerPlayer* self,
                                                 CassetteClientYaMAPITrack* track_info);
VALA_EXTERN gboolean cassette_client_player_mode_change_track (CassetteClientPlayerMode* self,
                                                   CassetteClientYaMAPITrack* track_info);
static void __lambda108_ (CassetteClientPlayerPlayer* self);
static void ___lambda108__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void cassette_client_player_player_start_current_track_data_free (gpointer _data);
static gboolean cassette_client_player_player_start_current_track_co (CassetteClientPlayerPlayerStartCurrentTrackData* _data_);
VALA_EXTERN void cassette_client_cachier_get_track_uri (const gchar* track_id,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
VALA_EXTERN gchar* cassette_client_cachier_get_track_uri_finish (GAsyncResult* _res_);
static void cassette_client_player_player_start_current_track_ready (GObject* source_object,
                                                              GAsyncResult* _res_,
                                                              gpointer _user_data_);
VALA_EXTERN GType cassette_client_cachier_storager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteClientCachierStorager, g_object_unref)
VALA_EXTERN void cassette_client_cachier_storager_clear_temp_track (CassetteClientCachierStorager* self);
static void cassette_client_player_player_cache_next_track (CassetteClientPlayerPlayer* self);
VALA_EXTERN void cassette_client_player_flow_prepare_next_track (CassetteClientPlayerFlow* self);
VALA_EXTERN CassetteClientYaMAPITrack* cassette_client_player_mode_get_next_track_info (CassetteClientPlayerMode* self,
                                                                            gboolean consider_repeat_mode);
VALA_EXTERN void cassette_client_cachier_save_track (CassetteClientYaMAPITrack* track_info,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
VALA_EXTERN void cassette_client_cachier_save_track_finish (GAsyncResult* _res_);
VALA_EXTERN void cassette_client_player_player_add_track (CassetteClientPlayerPlayer* self,
                                              CassetteClientYaMAPITrack* track_info,
                                              gboolean is_next);
VALA_EXTERN void cassette_client_player_player_add_many (CassetteClientPlayerPlayer* self,
                                             GeeArrayList* track_list);
VALA_EXTERN void cassette_client_player_shufflable_add_track_next (CassetteClientPlayerShufflable* self,
                                                       CassetteClientYaMAPITrack* track_info);
VALA_EXTERN void cassette_client_player_shufflable_add_track_end (CassetteClientPlayerShufflable* self,
                                                      CassetteClientYaMAPITrack* track_info);
VALA_EXTERN void cassette_client_player_shufflable_add_many_end (CassetteClientPlayerShufflable* self,
                                                     GeeArrayList* track_list);
VALA_EXTERN void cassette_client_player_player_remove_track_by_pos (CassetteClientPlayerPlayer* self,
                                                        gint position);
VALA_EXTERN void cassette_client_player_shufflable_remove_track_by_pos (CassetteClientPlayerShufflable* self,
                                                            gint position);
VALA_EXTERN GeeArrayList* cassette_client_player_mode_get_queue (CassetteClientPlayerMode* self);
VALA_EXTERN void cassette_client_player_player_remove_track (CassetteClientPlayerPlayer* self,
                                                 CassetteClientYaMAPITrack* track_info);
VALA_EXTERN void cassette_client_player_shufflable_remove_track (CassetteClientPlayerShufflable* self,
                                                     CassetteClientYaMAPITrack* track_info);
VALA_EXTERN void cassette_client_player_player_rotor_feedback (CassetteClientPlayerPlayer* self,
                                                   const gchar* feedback_type,
                                                   const gchar* track_id);
VALA_EXTERN CassetteClientPlayerPlayer* cassette_client_player_player_new (void);
VALA_EXTERN CassetteClientPlayerPlayer* cassette_client_player_player_construct (GType object_type);
VALA_EXTERN CassetteClientPlayerShuffleMode cassette_client_player_player_get_shuffle_mode (CassetteClientPlayerPlayer* self);
VALA_EXTERN void cassette_client_player_player_set_shuffle_mode (CassetteClientPlayerPlayer* self,
                                                     CassetteClientPlayerShuffleMode value);
VALA_EXTERN void cassette_client_player_shufflable_shuffle (CassetteClientPlayerShufflable* self);
VALA_EXTERN void cassette_client_player_shufflable_unshuffle (CassetteClientPlayerShufflable* self);
VALA_EXTERN gint64 cassette_client_player_player_get_playback_pos_ms (CassetteClientPlayerPlayer* self);
VALA_EXTERN gboolean cassette_client_player_player_get_can_go_force_prev (CassetteClientPlayerPlayer* self);
VALA_EXTERN gdouble cassette_client_player_player_get_volume (CassetteClientPlayerPlayer* self);
VALA_EXTERN void cassette_client_player_player_set_volume (CassetteClientPlayerPlayer* self,
                                               gdouble value);
VALA_EXTERN gboolean cassette_client_player_player_get_mute (CassetteClientPlayerPlayer* self);
VALA_EXTERN void cassette_client_player_player_set_mute (CassetteClientPlayerPlayer* self,
                                             gboolean value);
static void cassette_client_player_player_set_current_track_loading (CassetteClientPlayerPlayer* self,
                                                              gboolean value);
static void g_cclosure_user_marshal_VOID__OBJECT_STRING_STRING_INT_STRING (GClosure * closure,
                                                                    GValue * return_value,
                                                                    guint n_param_values,
                                                                    const GValue * param_values,
                                                                    gpointer invocation_hint,
                                                                    gpointer marshal_data);
static GObject * cassette_client_player_player_constructor (GType type,
                                                     guint n_construct_properties,
                                                     GObjectConstructParam * construct_properties);
static void _cassette_client_player_player___lambda112_ (CassetteClientPlayerPlayer* self,
                                                  GstBus* bus,
                                                  GstMessage* message);
static void __cassette_client_player_player___lambda112__gst_bus_message (GstBus* _sender,
                                                                   GstMessage* message,
                                                                   gpointer self);
static void _cassette_client_player_player___lambda113_ (CassetteClientPlayerPlayer* self);
static void __cassette_client_player_player___lambda113__cassette_client_player_player_current_track_start_loading (CassetteClientPlayerPlayer* _sender,
                                                                                                             gpointer self);
static void _cassette_client_player_player___lambda114_ (CassetteClientPlayerPlayer* self);
static void __cassette_client_player_player___lambda114__cassette_client_player_player_current_track_finish_loading (CassetteClientPlayerPlayer* _sender,
                                                                                                              CassetteClientYaMAPITrack* track_info,
                                                                                                              gpointer self);
static void _cassette_client_player_player___lambda115_ (CassetteClientPlayerPlayer* self);
static void __cassette_client_player_player___lambda115__cassette_client_player_player_next_track_loaded (CassetteClientPlayerPlayer* _sender,
                                                                                                   CassetteClientYaMAPITrack* next_track,
                                                                                                   gpointer self);
static void _cassette_client_player_player_update_player_cassette_client_player_player_mode_inited (CassetteClientPlayerPlayer* _sender,
                                                                                             gpointer self);
static gboolean _cassette_client_player_player___lambda116_ (CassetteClientPlayerPlayer* self);
static gboolean __cassette_client_player_player___lambda116__gsource_func (gpointer self);
static void cassette_client_player_player_finalize (GObject * obj);
static GType cassette_client_player_player_get_type_once (void);
static void _vala_cassette_client_player_player_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_cassette_client_player_player_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec);

 G_GNUC_NO_INLINE static GType
cassette_client_player_state_get_type_once (void)
{
	static const GEnumValue values[] = {{CASSETTE_CLIENT_PLAYER_STATE_NONE, "CASSETTE_CLIENT_PLAYER_STATE_NONE", "none"}, {CASSETTE_CLIENT_PLAYER_STATE_PLAYING, "CASSETTE_CLIENT_PLAYER_STATE_PLAYING", "playing"}, {CASSETTE_CLIENT_PLAYER_STATE_PAUSED, "CASSETTE_CLIENT_PLAYER_STATE_PAUSED", "paused"}, {0, NULL, NULL}};
	GType cassette_client_player_state_type_id;
	cassette_client_player_state_type_id = g_enum_register_static ("CassetteClientPlayerState", values);
	return cassette_client_player_state_type_id;
}

GType
cassette_client_player_state_get_type (void)
{
	static gsize cassette_client_player_state_type_id__once = 0;
	if (g_once_init_enter (&cassette_client_player_state_type_id__once)) {
		GType cassette_client_player_state_type_id;
		cassette_client_player_state_type_id = cassette_client_player_state_get_type_once ();
		g_once_init_leave (&cassette_client_player_state_type_id__once, cassette_client_player_state_type_id);
	}
	return cassette_client_player_state_type_id__once;
}

 G_GNUC_NO_INLINE static GType
cassette_client_player_repeat_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{CASSETTE_CLIENT_PLAYER_REPEAT_MODE_OFF, "CASSETTE_CLIENT_PLAYER_REPEAT_MODE_OFF", "off"}, {CASSETTE_CLIENT_PLAYER_REPEAT_MODE_ONE, "CASSETTE_CLIENT_PLAYER_REPEAT_MODE_ONE", "one"}, {CASSETTE_CLIENT_PLAYER_REPEAT_MODE_QUEUE, "CASSETTE_CLIENT_PLAYER_REPEAT_MODE_QUEUE", "queue"}, {0, NULL, NULL}};
	GType cassette_client_player_repeat_mode_type_id;
	cassette_client_player_repeat_mode_type_id = g_enum_register_static ("CassetteClientPlayerRepeatMode", values);
	return cassette_client_player_repeat_mode_type_id;
}

GType
cassette_client_player_repeat_mode_get_type (void)
{
	static gsize cassette_client_player_repeat_mode_type_id__once = 0;
	if (g_once_init_enter (&cassette_client_player_repeat_mode_type_id__once)) {
		GType cassette_client_player_repeat_mode_type_id;
		cassette_client_player_repeat_mode_type_id = cassette_client_player_repeat_mode_get_type_once ();
		g_once_init_leave (&cassette_client_player_repeat_mode_type_id__once, cassette_client_player_repeat_mode_type_id);
	}
	return cassette_client_player_repeat_mode_type_id__once;
}

 G_GNUC_NO_INLINE static GType
cassette_client_player_shuffle_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{CASSETTE_CLIENT_PLAYER_SHUFFLE_MODE_OFF, "CASSETTE_CLIENT_PLAYER_SHUFFLE_MODE_OFF", "off"}, {CASSETTE_CLIENT_PLAYER_SHUFFLE_MODE_ON, "CASSETTE_CLIENT_PLAYER_SHUFFLE_MODE_ON", "on"}, {0, NULL, NULL}};
	GType cassette_client_player_shuffle_mode_type_id;
	cassette_client_player_shuffle_mode_type_id = g_enum_register_static ("CassetteClientPlayerShuffleMode", values);
	return cassette_client_player_shuffle_mode_type_id;
}

GType
cassette_client_player_shuffle_mode_get_type (void)
{
	static gsize cassette_client_player_shuffle_mode_type_id__once = 0;
	if (g_once_init_enter (&cassette_client_player_shuffle_mode_type_id__once)) {
		GType cassette_client_player_shuffle_mode_type_id;
		cassette_client_player_shuffle_mode_type_id = cassette_client_player_shuffle_mode_get_type_once ();
		g_once_init_leave (&cassette_client_player_shuffle_mode_type_id__once, cassette_client_player_shuffle_mode_type_id);
	}
	return cassette_client_player_shuffle_mode_type_id__once;
}

static inline gpointer
cassette_client_player_player_get_instance_private (CassetteClientPlayerPlayer* self)
{
	return G_STRUCT_MEMBER_P (self, CassetteClientPlayerPlayer_private_offset);
}

static void
cassette_client_player_player_send_callback (CassetteClientPlayerPlayer* self)
{
	gboolean _tmp0_ = FALSE;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 256 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 257 "../src/client/player/player.vala"
	_tmp1_ = cassette_client_player_player_get_playback_pos_sec (self);
#line 257 "../src/client/player/player.vala"
	_tmp2_ = _tmp1_;
#line 257 "../src/client/player/player.vala"
	if (_tmp2_ > 0.0) {
#line 620 "player.c"
		CassetteClientPlayerState _tmp3_;
		CassetteClientPlayerState _tmp4_;
#line 257 "../src/client/player/player.vala"
		_tmp3_ = cassette_client_player_player_get_state (self);
#line 257 "../src/client/player/player.vala"
		_tmp4_ = _tmp3_;
#line 257 "../src/client/player/player.vala"
		_tmp0_ = _tmp4_ == CASSETTE_CLIENT_PLAYER_STATE_PLAYING;
#line 629 "player.c"
	} else {
#line 257 "../src/client/player/player.vala"
		_tmp0_ = FALSE;
#line 633 "player.c"
	}
#line 257 "../src/client/player/player.vala"
	if (_tmp0_) {
#line 637 "player.c"
		gdouble _tmp5_;
		gdouble _tmp6_;
#line 258 "../src/client/player/player.vala"
		_tmp5_ = cassette_client_player_player_get_playback_pos_sec (self);
#line 258 "../src/client/player/player.vala"
		_tmp6_ = _tmp5_;
#line 258 "../src/client/player/player.vala"
		g_signal_emit (self, cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_PLAYBACK_CALLBACK_SIGNAL], 0, _tmp6_);
#line 646 "player.c"
	}
}

static void
cassette_client_player_player_update_player (CassetteClientPlayerPlayer* self)
{
	gboolean _tmp0_ = FALSE;
	CassetteClientPlayerMode* _tmp1_;
	gboolean cgn = FALSE;
	gboolean _tmp3_ = FALSE;
	CassetteClientPlayerMode* _tmp4_;
	gboolean cgp = FALSE;
	gboolean _tmp9_;
	gboolean _tmp10_;
#line 262 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 263 "../src/client/player/player.vala"
	_tmp1_ = self->priv->_mode;
#line 263 "../src/client/player/player.vala"
	if (cassette_client_player_mode_get_next_index (_tmp1_, TRUE) != -1) {
#line 667 "player.c"
		gboolean _tmp2_;
#line 263 "../src/client/player/player.vala"
		_tmp2_ = self->priv->_current_track_loading;
#line 263 "../src/client/player/player.vala"
		_tmp0_ = !_tmp2_;
#line 673 "player.c"
	} else {
#line 263 "../src/client/player/player.vala"
		_tmp0_ = FALSE;
#line 677 "player.c"
	}
#line 263 "../src/client/player/player.vala"
	cgn = _tmp0_;
#line 264 "../src/client/player/player.vala"
	_tmp4_ = self->priv->_mode;
#line 264 "../src/client/player/player.vala"
	if (cassette_client_player_mode_get_prev_index (_tmp4_) != -1) {
#line 264 "../src/client/player/player.vala"
		_tmp3_ = TRUE;
#line 687 "player.c"
	} else {
		gboolean _tmp5_ = FALSE;
		gdouble _tmp6_;
		gdouble _tmp7_;
#line 264 "../src/client/player/player.vala"
		_tmp6_ = cassette_client_player_player_get_playback_pos_sec (self);
#line 264 "../src/client/player/player.vala"
		_tmp7_ = _tmp6_;
#line 264 "../src/client/player/player.vala"
		if (_tmp7_ > 3.0) {
#line 698 "player.c"
			gboolean _tmp8_;
#line 264 "../src/client/player/player.vala"
			_tmp8_ = self->priv->_current_track_loading;
#line 264 "../src/client/player/player.vala"
			_tmp5_ = !_tmp8_;
#line 704 "player.c"
		} else {
#line 264 "../src/client/player/player.vala"
			_tmp5_ = FALSE;
#line 708 "player.c"
		}
#line 264 "../src/client/player/player.vala"
		_tmp3_ = _tmp5_;
#line 712 "player.c"
	}
#line 264 "../src/client/player/player.vala"
	cgp = _tmp3_;
#line 267 "../src/client/player/player.vala"
	_tmp9_ = self->priv->_can_go_next;
#line 267 "../src/client/player/player.vala"
	if (cgn != _tmp9_) {
#line 268 "../src/client/player/player.vala"
		cassette_client_player_player_set_can_go_next (self, cgn);
#line 722 "player.c"
	}
#line 271 "../src/client/player/player.vala"
	_tmp10_ = self->priv->_can_go_prev;
#line 271 "../src/client/player/player.vala"
	if (cgp != _tmp10_) {
#line 272 "../src/client/player/player.vala"
		cassette_client_player_player_set_can_go_prev (self, cgp);
#line 730 "player.c"
	}
#line 275 "../src/client/player/player.vala"
	cassette_client_player_player_send_callback (self);
#line 734 "player.c"
}

static void
cassette_client_player_player_reset_play (CassetteClientPlayerPlayer* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 278 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 279 "../src/client/player/player.vala"
	_tmp0_ = g_uuid_string_random ();
#line 279 "../src/client/player/player.vala"
	_tmp1_ = _tmp0_;
#line 279 "../src/client/player/player.vala"
	cassette_client_player_player_set_play_id (self, _tmp1_);
#line 279 "../src/client/player/player.vala"
	_g_free0 (_tmp1_);
#line 280 "../src/client/player/player.vala"
	cassette_client_player_player_set_total_played_seconds (self, 0.0);
#line 282 "../src/client/player/player.vala"
	cassette_client_player_player_update_player (self);
#line 756 "player.c"
}

static void
cassette_client_player_player_init (CassetteClientPlayerPlayer* self,
                                    gchar** args,
                                    gint args_length1)
{
#line 285 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 286 "../src/client/player/player.vala"
	gst_init ((gint*) (&args_length1), &args);
#line 768 "player.c"
}

void
cassette_client_player_player_seek (CassetteClientPlayerPlayer* self,
                                    gint64 ms)
{
	GstElement* _tmp0_;
#line 289 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 290 "../src/client/player/player.vala"
	if (ms < ((gint64) 0)) {
#line 291 "../src/client/player/player.vala"
		ms = (gint64) 0;
#line 782 "player.c"
	}
#line 294 "../src/client/player/player.vala"
	cassette_client_player_player_update_player (self);
#line 295 "../src/client/player/player.vala"
	_tmp0_ = self->priv->playbin;
#line 295 "../src/client/player/player.vala"
	gst_element_seek_simple (_tmp0_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH | GST_SEEK_FLAG_KEY_UNIT, ms * GST_MSECOND);
#line 790 "player.c"
}

static Block39Data*
block39_data_ref (Block39Data* _data39_)
{
#line 298 "../src/client/player/player.vala"
	g_atomic_int_inc (&_data39_->_ref_count_);
#line 298 "../src/client/player/player.vala"
	return _data39_;
#line 800 "player.c"
}

static void
block39_data_unref (void * _userdata_)
{
	Block39Data* _data39_;
	_data39_ = (Block39Data*) _userdata_;
#line 298 "../src/client/player/player.vala"
	if (g_atomic_int_dec_and_test (&_data39_->_ref_count_)) {
#line 810 "player.c"
		CassetteClientPlayerPlayer* self;
#line 298 "../src/client/player/player.vala"
		self = _data39_->self;
#line 298 "../src/client/player/player.vala"
		_g_object_unref0 (_data39_->flow);
#line 298 "../src/client/player/player.vala"
		_g_object_unref0 (self);
#line 298 "../src/client/player/player.vala"
		g_slice_free (Block39Data, _data39_);
#line 820 "player.c"
	}
}

static void
__lambda103_ (Block39Data* _data39_,
              GObject* obj,
              GAsyncResult* res)
{
	CassetteClientPlayerPlayer* self;
#line 326 "../src/client/player/player.vala"
	self = _data39_->self;
#line 326 "../src/client/player/player.vala"
	g_return_if_fail (res != NULL);
#line 327 "../src/client/player/player.vala"
	if (cassette_client_player_flow_init_finish (_data39_->flow, res)) {
#line 836 "player.c"
		CassetteClientPlayerMode* _tmp0_;
		CassetteClientYaMAPITrack* _tmp1_;
		CassetteClientYaMAPITrack* _tmp2_;
#line 328 "../src/client/player/player.vala"
		_tmp0_ = self->priv->_mode;
#line 328 "../src/client/player/player.vala"
		_tmp1_ = cassette_client_player_mode_get_current_track_info (_tmp0_);
#line 328 "../src/client/player/player.vala"
		_tmp2_ = _tmp1_;
#line 328 "../src/client/player/player.vala"
		g_signal_emit (self, cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_CURRENT_TRACK_FINISH_LOADING_SIGNAL], 0, _tmp2_);
#line 328 "../src/client/player/player.vala"
		_g_object_unref0 (_tmp2_);
#line 330 "../src/client/player/player.vala"
		g_signal_emit (self, cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_MODE_INITED_SIGNAL], 0);
#line 332 "../src/client/player/player.vala"
		cassette_client_player_player_start_current_track (self, NULL, NULL);
#line 854 "player.c"
	}
}

static void
___lambda103__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 326 "../src/client/player/player.vala"
	__lambda103_ (self, source_object, res);
#line 326 "../src/client/player/player.vala"
	block39_data_unref (self);
#line 867 "player.c"
}

void
cassette_client_player_player_start_flow (CassetteClientPlayerPlayer* self,
                                          const gchar* station_id,
                                          GeeArrayList* queue)
{
	Block39Data* _data39_;
	CassetteClientPlayerRepeatMode _tmp0_;
	GeeArrayList* flow_queue = NULL;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp14_;
	CassetteClientPlayerFlow* _tmp15_;
#line 298 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 298 "../src/client/player/player.vala"
	g_return_if_fail (station_id != NULL);
#line 298 "../src/client/player/player.vala"
	g_return_if_fail (queue != NULL);
#line 298 "../src/client/player/player.vala"
	_data39_ = g_slice_new0 (Block39Data);
#line 298 "../src/client/player/player.vala"
	_data39_->_ref_count_ = 1;
#line 298 "../src/client/player/player.vala"
	_data39_->self = g_object_ref (self);
#line 302 "../src/client/player/player.vala"
	cassette_client_player_player_stop (self);
#line 304 "../src/client/player/player.vala"
	_tmp0_ = self->priv->_repeat_mode;
#line 304 "../src/client/player/player.vala"
	if (_tmp0_ == CASSETTE_CLIENT_PLAYER_REPEAT_MODE_QUEUE) {
#line 305 "../src/client/player/player.vala"
		cassette_client_player_player_set_repeat_mode (self, CASSETTE_CLIENT_PLAYER_REPEAT_MODE_OFF);
#line 901 "player.c"
	}
#line 308 "../src/client/player/player.vala"
	_tmp1_ = gee_array_list_new (CASSETTE_CLIENT_YA_MAPI_TYPE_TRACK, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 308 "../src/client/player/player.vala"
	flow_queue = _tmp1_;
#line 907 "player.c"
	{
		GeeArrayList* _track_info_list = NULL;
		gint _track_info_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _track_info_index = 0;
#line 310 "../src/client/player/player.vala"
		_track_info_list = queue;
#line 310 "../src/client/player/player.vala"
		_tmp2_ = _track_info_list;
#line 310 "../src/client/player/player.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 310 "../src/client/player/player.vala"
		_tmp4_ = _tmp3_;
#line 310 "../src/client/player/player.vala"
		_track_info_size = _tmp4_;
#line 310 "../src/client/player/player.vala"
		_track_info_index = -1;
#line 310 "../src/client/player/player.vala"
		while (TRUE) {
#line 929 "player.c"
			gint _tmp5_;
			gint _tmp6_;
			CassetteClientYaMAPITrack* track_info = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			CassetteClientYaMAPITrack* _tmp9_;
			gboolean _tmp10_;
			gboolean _tmp11_;
#line 310 "../src/client/player/player.vala"
			_track_info_index = _track_info_index + 1;
#line 310 "../src/client/player/player.vala"
			_tmp5_ = _track_info_index;
#line 310 "../src/client/player/player.vala"
			_tmp6_ = _track_info_size;
#line 310 "../src/client/player/player.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 310 "../src/client/player/player.vala"
				break;
#line 948 "player.c"
			}
#line 310 "../src/client/player/player.vala"
			_tmp7_ = _track_info_list;
#line 310 "../src/client/player/player.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _track_info_index);
#line 310 "../src/client/player/player.vala"
			track_info = (CassetteClientYaMAPITrack*) _tmp8_;
#line 311 "../src/client/player/player.vala"
			_tmp9_ = track_info;
#line 311 "../src/client/player/player.vala"
			_tmp10_ = cassette_client_ya_mapi_track_get_is_ugc (_tmp9_);
#line 311 "../src/client/player/player.vala"
			_tmp11_ = _tmp10_;
#line 311 "../src/client/player/player.vala"
			if (!_tmp11_) {
#line 964 "player.c"
				GeeArrayList* _tmp12_;
				CassetteClientYaMAPITrack* _tmp13_;
#line 312 "../src/client/player/player.vala"
				_tmp12_ = flow_queue;
#line 312 "../src/client/player/player.vala"
				_tmp13_ = track_info;
#line 312 "../src/client/player/player.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
#line 973 "player.c"
			}
#line 310 "../src/client/player/player.vala"
			_g_object_unref0 (track_info);
#line 977 "player.c"
		}
	}
#line 316 "../src/client/player/player.vala"
	_tmp14_ = flow_queue;
#line 316 "../src/client/player/player.vala"
	_tmp15_ = cassette_client_player_flow_new (self, station_id, _tmp14_);
#line 316 "../src/client/player/player.vala"
	_data39_->flow = _tmp15_;
#line 322 "../src/client/player/player.vala"
	cassette_client_player_player_set_mode (self, (CassetteClientPlayerMode*) _data39_->flow);
#line 324 "../src/client/player/player.vala"
	g_signal_emit (self, cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_CURRENT_TRACK_START_LOADING_SIGNAL], 0);
#line 326 "../src/client/player/player.vala"
	cassette_client_player_flow_init_async (_data39_->flow, ___lambda103__gasync_ready_callback, block39_data_ref (_data39_));
#line 298 "../src/client/player/player.vala"
	_g_object_unref0 (flow_queue);
#line 298 "../src/client/player/player.vala"
	block39_data_unref (_data39_);
#line 298 "../src/client/player/player.vala"
	_data39_ = NULL;
#line 998 "player.c"
}

void
cassette_client_player_player_start_track_list (CassetteClientPlayerPlayer* self,
                                                GeeArrayList* queue,
                                                const gchar* context_type,
                                                const gchar* context_id,
                                                gint current_index,
                                                const gchar* context_description)
{
	CassetteClientPlayerTrackList* _tmp0_;
	CassetteClientPlayerTrackList* _tmp1_;
#line 337 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 337 "../src/client/player/player.vala"
	g_return_if_fail (queue != NULL);
#line 337 "../src/client/player/player.vala"
	g_return_if_fail (context_type != NULL);
#line 344 "../src/client/player/player.vala"
	cassette_client_player_player_stop (self);
#line 346 "../src/client/player/player.vala"
	_tmp0_ = cassette_client_player_track_list_new (self, queue, context_type, context_id, current_index, context_description);
#line 346 "../src/client/player/player.vala"
	_tmp1_ = _tmp0_;
#line 346 "../src/client/player/player.vala"
	cassette_client_player_player_set_mode (self, (CassetteClientPlayerMode*) _tmp1_);
#line 346 "../src/client/player/player.vala"
	_g_object_unref0 (_tmp1_);
#line 355 "../src/client/player/player.vala"
	g_signal_emit (self, cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_MODE_INITED_SIGNAL], 0);
#line 357 "../src/client/player/player.vala"
	cassette_client_player_player_start_current_track (self, NULL, NULL);
#line 1031 "player.c"
}

void
cassette_client_player_player_clear_mode (CassetteClientPlayerPlayer* self)
{
	CassetteClientPlayerEmpty* _tmp0_;
	CassetteClientPlayerEmpty* _tmp1_;
#line 360 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 361 "../src/client/player/player.vala"
	cassette_client_player_player_stop (self);
#line 363 "../src/client/player/player.vala"
	_tmp0_ = cassette_client_player_empty_new (self);
#line 363 "../src/client/player/player.vala"
	_tmp1_ = _tmp0_;
#line 363 "../src/client/player/player.vala"
	cassette_client_player_player_set_mode (self, (CassetteClientPlayerMode*) _tmp1_);
#line 363 "../src/client/player/player.vala"
	_g_object_unref0 (_tmp1_);
#line 365 "../src/client/player/player.vala"
	g_signal_emit (self, cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_MODE_INITED_SIGNAL], 0);
#line 1053 "player.c"
}

void
cassette_client_player_player_play_pause (CassetteClientPlayerPlayer* self)
{
	CassetteClientPlayerState _tmp0_;
	CassetteClientPlayerState _tmp1_;
#line 368 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 369 "../src/client/player/player.vala"
	_tmp0_ = cassette_client_player_player_get_state (self);
#line 369 "../src/client/player/player.vala"
	_tmp1_ = _tmp0_;
#line 369 "../src/client/player/player.vala"
	switch (_tmp1_) {
#line 369 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_STATE_PLAYING:
#line 1071 "player.c"
		{
#line 371 "../src/client/player/player.vala"
			cassette_client_player_player_pause (self);
#line 372 "../src/client/player/player.vala"
			break;
#line 1077 "player.c"
		}
#line 369 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_STATE_PAUSED:
#line 1081 "player.c"
		{
#line 374 "../src/client/player/player.vala"
			cassette_client_player_player_play (self);
#line 375 "../src/client/player/player.vala"
			break;
#line 1087 "player.c"
		}
		default:
		{
#line 377 "../src/client/player/player.vala"
			cassette_client_player_player_start_current_track (self, NULL, NULL);
#line 378 "../src/client/player/player.vala"
			break;
#line 1095 "player.c"
		}
	}
}

void
cassette_client_player_player_play (CassetteClientPlayerPlayer* self)
{
	CassetteClientYaMAPITrack* current_track = NULL;
	CassetteClientPlayerMode* _tmp0_;
	CassetteClientYaMAPITrack* _tmp1_;
	CassetteClientYaMAPITrack* _tmp2_;
#line 382 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 383 "../src/client/player/player.vala"
	cassette_client_player_player_set_state (self, CASSETTE_CLIENT_PLAYER_STATE_PLAYING);
#line 385 "../src/client/player/player.vala"
	_tmp0_ = self->priv->_mode;
#line 385 "../src/client/player/player.vala"
	_tmp1_ = cassette_client_player_mode_get_current_track_info (_tmp0_);
#line 385 "../src/client/player/player.vala"
	current_track = _tmp1_;
#line 387 "../src/client/player/player.vala"
	_tmp2_ = current_track;
#line 387 "../src/client/player/player.vala"
	if (_tmp2_ != NULL) {
#line 1121 "player.c"
		CassetteClientYaMAPITrack* _tmp3_;
#line 388 "../src/client/player/player.vala"
		_tmp3_ = current_track;
#line 388 "../src/client/player/player.vala"
		g_signal_emit (self, cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_PLAYED_SIGNAL], 0, _tmp3_);
#line 1127 "player.c"
	}
#line 382 "../src/client/player/player.vala"
	_g_object_unref0 (current_track);
#line 1131 "player.c"
}

void
cassette_client_player_player_pause (CassetteClientPlayerPlayer* self)
{
	CassetteClientYaMAPITrack* current_track = NULL;
	CassetteClientPlayerMode* _tmp0_;
	CassetteClientYaMAPITrack* _tmp1_;
	CassetteClientYaMAPITrack* _tmp2_;
#line 392 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 393 "../src/client/player/player.vala"
	cassette_client_player_player_set_state (self, CASSETTE_CLIENT_PLAYER_STATE_PAUSED);
#line 395 "../src/client/player/player.vala"
	_tmp0_ = self->priv->_mode;
#line 395 "../src/client/player/player.vala"
	_tmp1_ = cassette_client_player_mode_get_current_track_info (_tmp0_);
#line 395 "../src/client/player/player.vala"
	current_track = _tmp1_;
#line 397 "../src/client/player/player.vala"
	_tmp2_ = current_track;
#line 397 "../src/client/player/player.vala"
	if (_tmp2_ != NULL) {
#line 1155 "player.c"
		CassetteClientYaMAPITrack* _tmp3_;
#line 398 "../src/client/player/player.vala"
		_tmp3_ = current_track;
#line 398 "../src/client/player/player.vala"
		g_signal_emit (self, cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_PAUSED_SIGNAL], 0, _tmp3_);
#line 1161 "player.c"
	}
#line 392 "../src/client/player/player.vala"
	_g_object_unref0 (current_track);
#line 1165 "player.c"
}

static void
cassette_client_player_player_track_stop (CassetteClientPlayerPlayer* self,
                                          gboolean natural)
{
	GstElement* _tmp0_;
	GValue _tmp1_ = {0};
	GValue _tmp2_;
	CassetteClientYaMAPITrack* current_track = NULL;
	CassetteClientPlayerMode* _tmp3_;
	CassetteClientYaMAPITrack* _tmp4_;
	gdouble _tmp5_ = 0.0;
	CassetteClientPlayerMode* _tmp13_;
	const gchar* _tmp14_;
	gdouble _tmp15_;
	CassetteClientPlayerMode* _tmp16_;
#line 402 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 403 "../src/client/player/player.vala"
	_tmp0_ = self->priv->playbin;
#line 403 "../src/client/player/player.vala"
	g_value_init (&_tmp1_, G_TYPE_STRING);
#line 403 "../src/client/player/player.vala"
	_tmp2_ = _tmp1_;
#line 403 "../src/client/player/player.vala"
	g_object_set_property ((GObject*) _tmp0_, "uri", &_tmp2_);
#line 403 "../src/client/player/player.vala"
	G_IS_VALUE (&_tmp2_) ? (g_value_unset (&_tmp2_), NULL) : NULL;
#line 405 "../src/client/player/player.vala"
	cassette_client_player_player_set_state (self, CASSETTE_CLIENT_PLAYER_STATE_NONE);
#line 407 "../src/client/player/player.vala"
	_tmp3_ = self->priv->_mode;
#line 407 "../src/client/player/player.vala"
	_tmp4_ = cassette_client_player_mode_get_current_track_info (_tmp3_);
#line 407 "../src/client/player/player.vala"
	current_track = _tmp4_;
#line 411 "../src/client/player/player.vala"
	if (natural) {
#line 1205 "player.c"
		CassetteClientPlayerMode* _tmp6_;
		CassetteClientYaMAPITrack* _tmp7_;
		CassetteClientYaMAPITrack* _tmp8_;
		gint64 _tmp9_;
		gint64 _tmp10_;
#line 411 "../src/client/player/player.vala"
		_tmp6_ = self->priv->_mode;
#line 411 "../src/client/player/player.vala"
		_tmp7_ = cassette_client_player_mode_get_current_track_info (_tmp6_);
#line 411 "../src/client/player/player.vala"
		_tmp8_ = _tmp7_;
#line 411 "../src/client/player/player.vala"
		_tmp9_ = cassette_client_ya_mapi_track_get_duration_ms (_tmp8_);
#line 411 "../src/client/player/player.vala"
		_tmp10_ = _tmp9_;
#line 411 "../src/client/player/player.vala"
		_tmp5_ = (gdouble) cassette_client_ms2sec (_tmp10_);
#line 411 "../src/client/player/player.vala"
		_g_object_unref0 (_tmp8_);
#line 1225 "player.c"
	} else {
		gdouble _tmp11_;
		gdouble _tmp12_;
#line 411 "../src/client/player/player.vala"
		_tmp11_ = cassette_client_player_player_get_playback_pos_sec (self);
#line 411 "../src/client/player/player.vala"
		_tmp12_ = _tmp11_;
#line 411 "../src/client/player/player.vala"
		_tmp5_ = _tmp12_;
#line 1235 "player.c"
	}
#line 409 "../src/client/player/player.vala"
	_tmp13_ = self->priv->_mode;
#line 409 "../src/client/player/player.vala"
	_tmp14_ = self->priv->_play_id;
#line 409 "../src/client/player/player.vala"
	_tmp15_ = self->priv->_total_played_seconds;
#line 409 "../src/client/player/player.vala"
	cassette_client_player_mode_send_play_async (_tmp13_, _tmp14_, _tmp5_, _tmp15_, NULL, NULL);
#line 415 "../src/client/player/player.vala"
	_tmp16_ = self->priv->_mode;
#line 415 "../src/client/player/player.vala"
	if (CASSETTE_CLIENT_PLAYER_IS_FLOW (_tmp16_)) {
#line 1249 "player.c"
		const gchar* _tmp17_ = NULL;
		CassetteClientPlayerMode* _tmp18_;
		CassetteClientYaMAPITrack* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		gdouble _tmp22_;
#line 417 "../src/client/player/player.vala"
		if (natural) {
#line 417 "../src/client/player/player.vala"
			_tmp17_ = CASSETTE_CLIENT_YA_MAPI_ROTOR_FEEDBACK_TYPE_TRACK_FINISHED;
#line 1260 "player.c"
		} else {
#line 417 "../src/client/player/player.vala"
			_tmp17_ = CASSETTE_CLIENT_YA_MAPI_ROTOR_FEEDBACK_TYPE_SKIP;
#line 1264 "player.c"
		}
#line 416 "../src/client/player/player.vala"
		_tmp18_ = self->priv->_mode;
#line 416 "../src/client/player/player.vala"
		_tmp19_ = current_track;
#line 416 "../src/client/player/player.vala"
		_tmp20_ = cassette_client_ya_mapi_track_get_id (_tmp19_);
#line 416 "../src/client/player/player.vala"
		_tmp21_ = _tmp20_;
#line 416 "../src/client/player/player.vala"
		_tmp22_ = self->priv->_total_played_seconds;
#line 416 "../src/client/player/player.vala"
		cassette_client_player_flow_send_feedback (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, CASSETTE_CLIENT_PLAYER_TYPE_FLOW, CassetteClientPlayerFlow), _tmp17_, _tmp21_, _tmp22_, NULL, NULL);
#line 1278 "player.c"
	}
#line 423 "../src/client/player/player.vala"
	cassette_client_player_player_reset_play (self);
#line 425 "../src/client/player/player.vala"
	g_signal_emit (self, cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_TRACK_STOPPED_SIGNAL], 0);
#line 402 "../src/client/player/player.vala"
	_g_object_unref0 (current_track);
#line 1286 "player.c"
}

void
cassette_client_player_player_stop (CassetteClientPlayerPlayer* self)
{
#line 428 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 429 "../src/client/player/player.vala"
	cassette_client_player_player_track_stop (self, FALSE);
#line 431 "../src/client/player/player.vala"
	g_signal_emit (self, cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_STOPPED_SIGNAL], 0);
#line 1298 "player.c"
}

static void
___lambda109_ (CassetteClientPlayerPlayer* self)
{
#line 446 "../src/client/player/player.vala"
	g_signal_emit (self, cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_READY_PLAY_NEXT_SIGNAL], 0);
#line 1306 "player.c"
}

static void
____lambda109__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 445 "../src/client/player/player.vala"
	___lambda109_ ((CassetteClientPlayerPlayer*) self);
#line 445 "../src/client/player/player.vala"
	g_object_unref (self);
#line 1318 "player.c"
}

static void
cassette_client_player_player_next_natural (CassetteClientPlayerPlayer* self)
{
	CassetteClientPlayerMode* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	CassetteClientPlayerMode* _tmp3_;
	CassetteClientPlayerMode* _tmp4_;
	CassetteClientPlayerMode* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
#line 434 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 435 "../src/client/player/player.vala"
	_tmp0_ = self->priv->_mode;
#line 435 "../src/client/player/player.vala"
	_tmp1_ = cassette_client_player_mode_get_current_index (_tmp0_);
#line 435 "../src/client/player/player.vala"
	_tmp2_ = _tmp1_;
#line 435 "../src/client/player/player.vala"
	_tmp3_ = self->priv->_mode;
#line 435 "../src/client/player/player.vala"
	if (_tmp2_ == cassette_client_player_mode_get_next_index (_tmp3_, TRUE)) {
#line 436 "../src/client/player/player.vala"
		cassette_client_player_player_seek (self, (gint64) 0);
#line 437 "../src/client/player/player.vala"
		return;
#line 1348 "player.c"
	}
#line 440 "../src/client/player/player.vala"
	cassette_client_player_player_track_stop (self, TRUE);
#line 442 "../src/client/player/player.vala"
	_tmp4_ = self->priv->_mode;
#line 442 "../src/client/player/player.vala"
	cassette_client_player_mode_next (_tmp4_, TRUE);
#line 444 "../src/client/player/player.vala"
	_tmp5_ = self->priv->_mode;
#line 444 "../src/client/player/player.vala"
	_tmp6_ = cassette_client_player_mode_get_current_index (_tmp5_);
#line 444 "../src/client/player/player.vala"
	_tmp7_ = _tmp6_;
#line 444 "../src/client/player/player.vala"
	if (_tmp7_ != -1) {
#line 445 "../src/client/player/player.vala"
		cassette_client_player_player_start_current_track (self, ____lambda109__gasync_ready_callback, g_object_ref (self));
#line 1366 "player.c"
	}
}

static void
___lambda110_ (CassetteClientPlayerPlayer* self)
{
#line 458 "../src/client/player/player.vala"
	g_signal_emit (self, cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_READY_PLAY_NEXT_SIGNAL], 0);
#line 1375 "player.c"
}

static void
____lambda110__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 457 "../src/client/player/player.vala"
	___lambda110_ ((CassetteClientPlayerPlayer*) self);
#line 457 "../src/client/player/player.vala"
	g_object_unref (self);
#line 1387 "player.c"
}

void
cassette_client_player_player_next (CassetteClientPlayerPlayer* self)
{
	CassetteClientPlayerMode* _tmp0_;
	CassetteClientPlayerMode* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 451 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 452 "../src/client/player/player.vala"
	cassette_client_player_player_track_stop (self, FALSE);
#line 454 "../src/client/player/player.vala"
	_tmp0_ = self->priv->_mode;
#line 454 "../src/client/player/player.vala"
	cassette_client_player_mode_next (_tmp0_, FALSE);
#line 456 "../src/client/player/player.vala"
	_tmp1_ = self->priv->_mode;
#line 456 "../src/client/player/player.vala"
	_tmp2_ = cassette_client_player_mode_get_current_index (_tmp1_);
#line 456 "../src/client/player/player.vala"
	_tmp3_ = _tmp2_;
#line 456 "../src/client/player/player.vala"
	if (_tmp3_ != -1) {
#line 457 "../src/client/player/player.vala"
		cassette_client_player_player_start_current_track (self, ____lambda110__gasync_ready_callback, g_object_ref (self));
#line 1415 "player.c"
	}
}

static void
__lambda111_ (CassetteClientPlayerPlayer* self)
{
#line 475 "../src/client/player/player.vala"
	g_signal_emit (self, cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_READY_PLAY_PREV_SIGNAL], 0);
#line 1424 "player.c"
}

static void
___lambda111__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 474 "../src/client/player/player.vala"
	__lambda111_ ((CassetteClientPlayerPlayer*) self);
#line 474 "../src/client/player/player.vala"
	g_object_unref (self);
#line 1436 "player.c"
}

void
cassette_client_player_player_prev (CassetteClientPlayerPlayer* self,
                                    gboolean ignore_progress)
{
	gboolean _tmp0_ = FALSE;
	gdouble _tmp1_;
	gdouble _tmp2_;
	CassetteClientPlayerMode* _tmp3_;
#line 463 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 464 "../src/client/player/player.vala"
	_tmp1_ = cassette_client_player_player_get_playback_pos_sec (self);
#line 464 "../src/client/player/player.vala"
	_tmp2_ = _tmp1_;
#line 464 "../src/client/player/player.vala"
	if (_tmp2_ > 3.0) {
#line 464 "../src/client/player/player.vala"
		_tmp0_ = !ignore_progress;
#line 1457 "player.c"
	} else {
#line 464 "../src/client/player/player.vala"
		_tmp0_ = FALSE;
#line 1461 "player.c"
	}
#line 464 "../src/client/player/player.vala"
	if (_tmp0_) {
#line 465 "../src/client/player/player.vala"
		cassette_client_player_player_seek (self, (gint64) 0);
#line 466 "../src/client/player/player.vala"
		return;
#line 1469 "player.c"
	}
#line 470 "../src/client/player/player.vala"
	cassette_client_player_player_track_stop (self, FALSE);
#line 472 "../src/client/player/player.vala"
	_tmp3_ = self->priv->_mode;
#line 472 "../src/client/player/player.vala"
	cassette_client_player_mode_prev (_tmp3_);
#line 474 "../src/client/player/player.vala"
	cassette_client_player_player_start_current_track (self, ___lambda111__gasync_ready_callback, g_object_ref (self));
#line 1479 "player.c"
}

static void
__lambda108_ (CassetteClientPlayerPlayer* self)
{
#line 488 "../src/client/player/player.vala"
	g_signal_emit (self, cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_READY_PLAY_NEXT_SIGNAL], 0);
#line 1487 "player.c"
}

static void
___lambda108__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 487 "../src/client/player/player.vala"
	__lambda108_ ((CassetteClientPlayerPlayer*) self);
#line 487 "../src/client/player/player.vala"
	g_object_unref (self);
#line 1499 "player.c"
}

void
cassette_client_player_player_change_track (CassetteClientPlayerPlayer* self,
                                            CassetteClientYaMAPITrack* track_info)
{
	CassetteClientPlayerMode* _tmp0_;
#line 479 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 479 "../src/client/player/player.vala"
	g_return_if_fail (track_info != NULL);
#line 483 "../src/client/player/player.vala"
	cassette_client_player_player_track_stop (self, FALSE);
#line 485 "../src/client/player/player.vala"
	_tmp0_ = self->priv->_mode;
#line 485 "../src/client/player/player.vala"
	cassette_client_player_mode_change_track (_tmp0_, track_info);
#line 487 "../src/client/player/player.vala"
	cassette_client_player_player_start_current_track (self, ___lambda108__gasync_ready_callback, g_object_ref (self));
#line 1519 "player.c"
}

static void
cassette_client_player_player_start_current_track_data_free (gpointer _data)
{
	CassetteClientPlayerPlayerStartCurrentTrackData* _data_;
	_data_ = _data;
#line 39 "../src/client/player/player.vala"
	_g_object_unref0 (_data_->self);
#line 39 "../src/client/player/player.vala"
	g_slice_free (CassetteClientPlayerPlayerStartCurrentTrackData, _data_);
#line 1531 "player.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 39 "../src/client/player/player.vala"
	return self ? g_object_ref (self) : NULL;
#line 1539 "player.c"
}

void
cassette_client_player_player_start_current_track (CassetteClientPlayerPlayer* self,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_)
{
	CassetteClientPlayerPlayerStartCurrentTrackData* _data_;
	CassetteClientPlayerPlayer* _tmp0_;
#line 39 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/client/player/player.vala"
	_data_ = g_slice_new0 (CassetteClientPlayerPlayerStartCurrentTrackData);
#line 39 "../src/client/player/player.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 39 "../src/client/player/player.vala"
	g_task_set_task_data (_data_->_async_result, _data_, cassette_client_player_player_start_current_track_data_free);
#line 39 "../src/client/player/player.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 39 "../src/client/player/player.vala"
	_data_->self = _tmp0_;
#line 39 "../src/client/player/player.vala"
	cassette_client_player_player_start_current_track_co (_data_);
#line 1563 "player.c"
}

void
cassette_client_player_player_start_current_track_finish (CassetteClientPlayerPlayer* self,
                                                          GAsyncResult* _res_)
{
	CassetteClientPlayerPlayerStartCurrentTrackData* _data_;
#line 39 "../src/client/player/player.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1573 "player.c"
}

static void
cassette_client_player_player_start_current_track_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_)
{
	CassetteClientPlayerPlayerStartCurrentTrackData* _data_;
#line 509 "../src/client/player/player.vala"
	_data_ = _user_data_;
#line 509 "../src/client/player/player.vala"
	_data_->_source_object_ = source_object;
#line 509 "../src/client/player/player.vala"
	_data_->_res_ = _res_;
#line 509 "../src/client/player/player.vala"
	cassette_client_player_player_start_current_track_co (_data_);
#line 1590 "player.c"
}

static gboolean
cassette_client_player_player_start_current_track_co (CassetteClientPlayerPlayerStartCurrentTrackData* _data_)
{
#line 492 "../src/client/player/player.vala"
	switch (_data_->_state_) {
#line 492 "../src/client/player/player.vala"
		case 0:
#line 1600 "player.c"
		goto _state_0;
#line 492 "../src/client/player/player.vala"
		case 1:
#line 1604 "player.c"
		goto _state_1;
		default:
#line 492 "../src/client/player/player.vala"
		g_assert_not_reached ();
#line 1609 "player.c"
	}
	_state_0:
#line 493 "../src/client/player/player.vala"
	_data_->_tmp0_ = _data_->self->priv->_mode;
#line 493 "../src/client/player/player.vala"
	_data_->_tmp1_ = cassette_client_player_mode_get_current_track_info (_data_->_tmp0_);
#line 493 "../src/client/player/player.vala"
	_data_->current_track = _data_->_tmp1_;
#line 495 "../src/client/player/player.vala"
	_data_->_tmp2_ = _data_->current_track;
#line 495 "../src/client/player/player.vala"
	if (_data_->_tmp2_ == NULL) {
#line 496 "../src/client/player/player.vala"
		_g_object_unref0 (_data_->current_track);
#line 496 "../src/client/player/player.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 496 "../src/client/player/player.vala"
		if (_data_->_state_ != 0) {
#line 496 "../src/client/player/player.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 496 "../src/client/player/player.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1632 "player.c"
			}
		}
#line 496 "../src/client/player/player.vala"
		g_object_unref (_data_->_async_result);
#line 496 "../src/client/player/player.vala"
		return FALSE;
#line 1639 "player.c"
	}
#line 499 "../src/client/player/player.vala"
	g_signal_emit (_data_->self, cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_CURRENT_TRACK_START_LOADING_SIGNAL], 0);
#line 501 "../src/client/player/player.vala"
	_data_->_tmp3_ = _data_->self->priv->_mode;
#line 501 "../src/client/player/player.vala"
	_data_->_tmp4_ = _data_->self->priv->_play_id;
#line 501 "../src/client/player/player.vala"
	cassette_client_player_mode_send_play_async (_data_->_tmp3_, _data_->_tmp4_, 0.0, 0.0, NULL, NULL);
#line 502 "../src/client/player/player.vala"
	_data_->_tmp5_ = _data_->self->priv->_mode;
#line 502 "../src/client/player/player.vala"
	if (CASSETTE_CLIENT_PLAYER_IS_FLOW (_data_->_tmp5_)) {
#line 503 "../src/client/player/player.vala"
		_data_->_tmp6_ = _data_->self->priv->_mode;
#line 503 "../src/client/player/player.vala"
		_data_->_tmp7_ = _data_->current_track;
#line 503 "../src/client/player/player.vala"
		_data_->_tmp8_ = cassette_client_ya_mapi_track_get_id (_data_->_tmp7_);
#line 503 "../src/client/player/player.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 503 "../src/client/player/player.vala"
		cassette_client_player_flow_send_feedback (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, CASSETTE_CLIENT_PLAYER_TYPE_FLOW, CassetteClientPlayerFlow), CASSETTE_CLIENT_YA_MAPI_ROTOR_FEEDBACK_TYPE_TRACK_STARTED, _data_->_tmp9_, 0.0, NULL, NULL);
#line 1663 "player.c"
	}
#line 509 "../src/client/player/player.vala"
	_data_->_tmp10_ = _data_->current_track;
#line 509 "../src/client/player/player.vala"
	_data_->_tmp11_ = cassette_client_ya_mapi_track_get_id (_data_->_tmp10_);
#line 509 "../src/client/player/player.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 509 "../src/client/player/player.vala"
	_data_->_state_ = 1;
#line 509 "../src/client/player/player.vala"
	cassette_client_cachier_get_track_uri (_data_->_tmp12_, cassette_client_player_player_start_current_track_ready, _data_);
#line 509 "../src/client/player/player.vala"
	return FALSE;
#line 1677 "player.c"
	_state_1:
#line 509 "../src/client/player/player.vala"
	_data_->_tmp13_ = cassette_client_cachier_get_track_uri_finish (_data_->_res_);
#line 509 "../src/client/player/player.vala"
	_data_->track_uri = _data_->_tmp13_;
#line 511 "../src/client/player/player.vala"
	_data_->_tmp14_ = _data_->track_uri;
#line 511 "../src/client/player/player.vala"
	if (_data_->_tmp14_ == NULL) {
#line 512 "../src/client/player/player.vala"
		_data_->_tmp15_ = _data_->self->priv->playbin;
#line 512 "../src/client/player/player.vala"
		memset (&_data_->_tmp16_, 0, sizeof (GValue));
#line 512 "../src/client/player/player.vala"
		g_value_init (&_data_->_tmp16_, G_TYPE_STRING);
#line 512 "../src/client/player/player.vala"
		_data_->_tmp17_ = _data_->_tmp16_;
#line 512 "../src/client/player/player.vala"
		g_object_set_property ((GObject*) _data_->_tmp15_, "uri", &_data_->_tmp17_);
#line 512 "../src/client/player/player.vala"
		G_IS_VALUE (&_data_->_tmp17_) ? (g_value_unset (&_data_->_tmp17_), NULL) : NULL;
#line 1699 "player.c"
	} else {
#line 514 "../src/client/player/player.vala"
		_data_->_tmp18_ = _data_->self->priv->playbin;
#line 514 "../src/client/player/player.vala"
		_data_->_tmp19_ = _data_->track_uri;
#line 514 "../src/client/player/player.vala"
		memset (&_data_->_tmp20_, 0, sizeof (GValue));
#line 514 "../src/client/player/player.vala"
		g_value_init (&_data_->_tmp20_, G_TYPE_STRING);
#line 514 "../src/client/player/player.vala"
		g_value_set_string (&_data_->_tmp20_, _data_->_tmp19_);
#line 514 "../src/client/player/player.vala"
		g_object_set_property ((GObject*) _data_->_tmp18_, "uri", &_data_->_tmp20_);
#line 514 "../src/client/player/player.vala"
		G_IS_VALUE (&_data_->_tmp20_) ? (g_value_unset (&_data_->_tmp20_), NULL) : NULL;
#line 516 "../src/client/player/player.vala"
		cassette_client_player_player_play (_data_->self);
#line 517 "../src/client/player/player.vala"
		_data_->_tmp21_ = cassette_client_storager;
#line 517 "../src/client/player/player.vala"
		cassette_client_cachier_storager_clear_temp_track (_data_->_tmp21_);
#line 1721 "player.c"
	}
#line 520 "../src/client/player/player.vala"
	_data_->_tmp22_ = _data_->current_track;
#line 520 "../src/client/player/player.vala"
	g_signal_emit (_data_->self, cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_CURRENT_TRACK_FINISH_LOADING_SIGNAL], 0, _data_->_tmp22_);
#line 522 "../src/client/player/player.vala"
	_data_->_tmp23_ = cassette_client_settings;
#line 522 "../src/client/player/player.vala"
	if (g_settings_get_boolean (_data_->_tmp23_, "can-cache")) {
#line 523 "../src/client/player/player.vala"
		cassette_client_player_player_cache_next_track (_data_->self);
#line 1733 "player.c"
	}
#line 526 "../src/client/player/player.vala"
	_data_->_tmp24_ = _data_->self->priv->_mode;
#line 526 "../src/client/player/player.vala"
	if (cassette_client_player_mode_get_next_index (_data_->_tmp24_, FALSE) == -1) {
#line 527 "../src/client/player/player.vala"
		_data_->_tmp26_ = _data_->self->priv->_mode;
#line 527 "../src/client/player/player.vala"
		_data_->_tmp25_ = CASSETTE_CLIENT_PLAYER_IS_FLOW (_data_->_tmp26_) ? ((CassetteClientPlayerFlow*) _data_->_tmp26_) : NULL;
#line 527 "../src/client/player/player.vala"
		if (_data_->_tmp25_ != NULL) {
#line 527 "../src/client/player/player.vala"
			cassette_client_player_flow_prepare_next_track (_data_->_tmp25_);
#line 1747 "player.c"
		}
	}
#line 530 "../src/client/player/player.vala"
	cassette_client_player_player_update_player (_data_->self);
#line 492 "../src/client/player/player.vala"
	_g_free0 (_data_->track_uri);
#line 492 "../src/client/player/player.vala"
	_g_object_unref0 (_data_->current_track);
#line 492 "../src/client/player/player.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 492 "../src/client/player/player.vala"
	if (_data_->_state_ != 0) {
#line 492 "../src/client/player/player.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 492 "../src/client/player/player.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1764 "player.c"
		}
	}
#line 492 "../src/client/player/player.vala"
	g_object_unref (_data_->_async_result);
#line 492 "../src/client/player/player.vala"
	return FALSE;
#line 1771 "player.c"
}

static void
cassette_client_player_player_cache_next_track (CassetteClientPlayerPlayer* self)
{
	CassetteClientYaMAPITrack* next_track = NULL;
	CassetteClientPlayerMode* _tmp0_;
	CassetteClientYaMAPITrack* _tmp1_;
	gboolean _tmp2_ = FALSE;
	CassetteClientYaMAPITrack* _tmp3_;
	CassetteClientPlayerMode* _tmp4_;
	CassetteClientYaMAPITrack* _tmp5_;
	CassetteClientYaMAPITrack* _tmp6_;
	gboolean _tmp7_;
#line 533 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 534 "../src/client/player/player.vala"
	_tmp0_ = self->priv->_mode;
#line 534 "../src/client/player/player.vala"
	_tmp1_ = cassette_client_player_mode_get_next_track_info (_tmp0_, FALSE);
#line 534 "../src/client/player/player.vala"
	next_track = _tmp1_;
#line 536 "../src/client/player/player.vala"
	_tmp3_ = next_track;
#line 536 "../src/client/player/player.vala"
	_tmp4_ = self->priv->_mode;
#line 536 "../src/client/player/player.vala"
	_tmp5_ = cassette_client_player_mode_get_current_track_info (_tmp4_);
#line 536 "../src/client/player/player.vala"
	_tmp6_ = _tmp5_;
#line 536 "../src/client/player/player.vala"
	_tmp7_ = _tmp3_ != _tmp6_;
#line 536 "../src/client/player/player.vala"
	_g_object_unref0 (_tmp6_);
#line 536 "../src/client/player/player.vala"
	if (_tmp7_) {
#line 1808 "player.c"
		CassetteClientYaMAPITrack* _tmp8_;
#line 536 "../src/client/player/player.vala"
		_tmp8_ = next_track;
#line 536 "../src/client/player/player.vala"
		_tmp2_ = _tmp8_ != NULL;
#line 1814 "player.c"
	} else {
#line 536 "../src/client/player/player.vala"
		_tmp2_ = FALSE;
#line 1818 "player.c"
	}
#line 536 "../src/client/player/player.vala"
	if (_tmp2_) {
#line 1822 "player.c"
		CassetteClientYaMAPITrack* _tmp9_;
#line 537 "../src/client/player/player.vala"
		_tmp9_ = next_track;
#line 537 "../src/client/player/player.vala"
		cassette_client_cachier_save_track (_tmp9_, NULL, NULL);
#line 1828 "player.c"
	}
#line 533 "../src/client/player/player.vala"
	_g_object_unref0 (next_track);
#line 1832 "player.c"
}

void
cassette_client_player_player_add_track (CassetteClientPlayerPlayer* self,
                                         CassetteClientYaMAPITrack* track_info,
                                         gboolean is_next)
{
	CassetteClientPlayerMode* _tmp0_;
	CassetteClientPlayerShufflable* sh_mode = NULL;
	CassetteClientPlayerMode* _tmp4_;
	CassetteClientPlayerShufflable* _tmp5_;
	CassetteClientPlayerShufflable* _tmp6_;
	GSettings* _tmp9_;
#line 541 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 541 "../src/client/player/player.vala"
	g_return_if_fail (track_info != NULL);
#line 542 "../src/client/player/player.vala"
	_tmp0_ = self->priv->_mode;
#line 542 "../src/client/player/player.vala"
	if (CASSETTE_CLIENT_PLAYER_IS_EMPTY (_tmp0_)) {
#line 1854 "player.c"
		GeeArrayList* track_list = NULL;
		GeeArrayList* _tmp1_;
		GeeArrayList* _tmp2_;
		GeeArrayList* _tmp3_;
#line 543 "../src/client/player/player.vala"
		_tmp1_ = gee_array_list_new (CASSETTE_CLIENT_YA_MAPI_TYPE_TRACK, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 543 "../src/client/player/player.vala"
		track_list = _tmp1_;
#line 544 "../src/client/player/player.vala"
		_tmp2_ = track_list;
#line 544 "../src/client/player/player.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp2_, track_info);
#line 546 "../src/client/player/player.vala"
		_tmp3_ = track_list;
#line 546 "../src/client/player/player.vala"
		cassette_client_player_player_add_many (self, _tmp3_);
#line 547 "../src/client/player/player.vala"
		_g_object_unref0 (track_list);
#line 547 "../src/client/player/player.vala"
		return;
#line 1875 "player.c"
	}
#line 550 "../src/client/player/player.vala"
	_tmp4_ = self->priv->_mode;
#line 550 "../src/client/player/player.vala"
	_tmp5_ = _g_object_ref0 (CASSETTE_CLIENT_PLAYER_IS_SHUFFLABLE (_tmp4_) ? ((CassetteClientPlayerShufflable*) _tmp4_) : NULL);
#line 550 "../src/client/player/player.vala"
	sh_mode = _tmp5_;
#line 552 "../src/client/player/player.vala"
	_tmp6_ = sh_mode;
#line 552 "../src/client/player/player.vala"
	if (_tmp6_ == NULL) {
#line 553 "../src/client/player/player.vala"
		_g_object_unref0 (sh_mode);
#line 553 "../src/client/player/player.vala"
		return;
#line 1891 "player.c"
	}
#line 556 "../src/client/player/player.vala"
	if (is_next) {
#line 1895 "player.c"
		CassetteClientPlayerShufflable* _tmp7_;
#line 557 "../src/client/player/player.vala"
		_tmp7_ = sh_mode;
#line 557 "../src/client/player/player.vala"
		cassette_client_player_shufflable_add_track_next (_tmp7_, track_info);
#line 1901 "player.c"
	} else {
		CassetteClientPlayerShufflable* _tmp8_;
#line 559 "../src/client/player/player.vala"
		_tmp8_ = sh_mode;
#line 559 "../src/client/player/player.vala"
		cassette_client_player_shufflable_add_track_end (_tmp8_, track_info);
#line 1908 "player.c"
	}
#line 562 "../src/client/player/player.vala"
	_tmp9_ = cassette_client_settings;
#line 562 "../src/client/player/player.vala"
	if (g_settings_get_boolean (_tmp9_, "can-cache")) {
#line 563 "../src/client/player/player.vala"
		cassette_client_player_player_cache_next_track (self);
#line 1916 "player.c"
	}
#line 541 "../src/client/player/player.vala"
	_g_object_unref0 (sh_mode);
#line 1920 "player.c"
}

void
cassette_client_player_player_add_many (CassetteClientPlayerPlayer* self,
                                        GeeArrayList* track_list)
{
	CassetteClientPlayerMode* _tmp0_;
	CassetteClientPlayerShufflable* sh_mode = NULL;
	CassetteClientPlayerMode* _tmp1_;
	CassetteClientPlayerShufflable* _tmp2_;
	CassetteClientPlayerShufflable* _tmp3_;
	CassetteClientPlayerShufflable* _tmp4_;
	GSettings* _tmp5_;
#line 567 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 567 "../src/client/player/player.vala"
	g_return_if_fail (track_list != NULL);
#line 568 "../src/client/player/player.vala"
	_tmp0_ = self->priv->_mode;
#line 568 "../src/client/player/player.vala"
	if (CASSETTE_CLIENT_PLAYER_IS_EMPTY (_tmp0_)) {
#line 569 "../src/client/player/player.vala"
		cassette_client_player_player_start_track_list (self, track_list, "various", NULL, 0, NULL);
#line 576 "../src/client/player/player.vala"
		return;
#line 1946 "player.c"
	}
#line 579 "../src/client/player/player.vala"
	_tmp1_ = self->priv->_mode;
#line 579 "../src/client/player/player.vala"
	_tmp2_ = _g_object_ref0 (CASSETTE_CLIENT_PLAYER_IS_SHUFFLABLE (_tmp1_) ? ((CassetteClientPlayerShufflable*) _tmp1_) : NULL);
#line 579 "../src/client/player/player.vala"
	sh_mode = _tmp2_;
#line 581 "../src/client/player/player.vala"
	_tmp3_ = sh_mode;
#line 581 "../src/client/player/player.vala"
	if (_tmp3_ == NULL) {
#line 582 "../src/client/player/player.vala"
		_g_object_unref0 (sh_mode);
#line 582 "../src/client/player/player.vala"
		return;
#line 1962 "player.c"
	}
#line 585 "../src/client/player/player.vala"
	_tmp4_ = sh_mode;
#line 585 "../src/client/player/player.vala"
	cassette_client_player_shufflable_add_many_end (_tmp4_, track_list);
#line 587 "../src/client/player/player.vala"
	_tmp5_ = cassette_client_settings;
#line 587 "../src/client/player/player.vala"
	if (g_settings_get_boolean (_tmp5_, "can-cache")) {
#line 588 "../src/client/player/player.vala"
		cassette_client_player_player_cache_next_track (self);
#line 1974 "player.c"
	}
#line 567 "../src/client/player/player.vala"
	_g_object_unref0 (sh_mode);
#line 1978 "player.c"
}

void
cassette_client_player_player_remove_track_by_pos (CassetteClientPlayerPlayer* self,
                                                   gint position)
{
	CassetteClientPlayerShufflable* sh_mode = NULL;
	CassetteClientPlayerMode* _tmp0_;
	CassetteClientPlayerShufflable* _tmp1_;
	CassetteClientPlayerShufflable* _tmp2_;
	CassetteClientPlayerShufflable* _tmp3_;
	gboolean _tmp4_ = FALSE;
	CassetteClientPlayerShufflable* _tmp5_;
	GeeArrayList* _tmp6_;
	GeeArrayList* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
#line 592 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 593 "../src/client/player/player.vala"
	_tmp0_ = self->priv->_mode;
#line 593 "../src/client/player/player.vala"
	_tmp1_ = _g_object_ref0 (CASSETTE_CLIENT_PLAYER_IS_SHUFFLABLE (_tmp0_) ? ((CassetteClientPlayerShufflable*) _tmp0_) : NULL);
#line 593 "../src/client/player/player.vala"
	sh_mode = _tmp1_;
#line 595 "../src/client/player/player.vala"
	_tmp2_ = sh_mode;
#line 595 "../src/client/player/player.vala"
	if (_tmp2_ == NULL) {
#line 596 "../src/client/player/player.vala"
		_g_object_unref0 (sh_mode);
#line 596 "../src/client/player/player.vala"
		return;
#line 2012 "player.c"
	}
#line 599 "../src/client/player/player.vala"
	_tmp3_ = sh_mode;
#line 599 "../src/client/player/player.vala"
	cassette_client_player_shufflable_remove_track_by_pos (_tmp3_, position);
#line 601 "../src/client/player/player.vala"
	_tmp5_ = sh_mode;
#line 601 "../src/client/player/player.vala"
	_tmp6_ = cassette_client_player_mode_get_queue ((CassetteClientPlayerMode*) _tmp5_);
#line 601 "../src/client/player/player.vala"
	_tmp7_ = _tmp6_;
#line 601 "../src/client/player/player.vala"
	_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 601 "../src/client/player/player.vala"
	_tmp9_ = _tmp8_;
#line 601 "../src/client/player/player.vala"
	if (_tmp9_ != 0) {
#line 2030 "player.c"
		GSettings* _tmp10_;
#line 601 "../src/client/player/player.vala"
		_tmp10_ = cassette_client_settings;
#line 601 "../src/client/player/player.vala"
		_tmp4_ = g_settings_get_boolean (_tmp10_, "can-cache");
#line 2036 "player.c"
	} else {
#line 601 "../src/client/player/player.vala"
		_tmp4_ = FALSE;
#line 2040 "player.c"
	}
#line 601 "../src/client/player/player.vala"
	if (_tmp4_) {
#line 602 "../src/client/player/player.vala"
		cassette_client_player_player_cache_next_track (self);
#line 2046 "player.c"
	}
#line 592 "../src/client/player/player.vala"
	_g_object_unref0 (sh_mode);
#line 2050 "player.c"
}

void
cassette_client_player_player_remove_track (CassetteClientPlayerPlayer* self,
                                            CassetteClientYaMAPITrack* track_info)
{
	CassetteClientPlayerShufflable* sh_mode = NULL;
	CassetteClientPlayerMode* _tmp0_;
	CassetteClientPlayerShufflable* _tmp1_;
	CassetteClientPlayerShufflable* _tmp2_;
	CassetteClientPlayerShufflable* _tmp3_;
	gboolean _tmp4_ = FALSE;
	CassetteClientPlayerShufflable* _tmp5_;
	GeeArrayList* _tmp6_;
	GeeArrayList* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
#line 606 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 606 "../src/client/player/player.vala"
	g_return_if_fail (track_info != NULL);
#line 607 "../src/client/player/player.vala"
	_tmp0_ = self->priv->_mode;
#line 607 "../src/client/player/player.vala"
	_tmp1_ = _g_object_ref0 (CASSETTE_CLIENT_PLAYER_IS_SHUFFLABLE (_tmp0_) ? ((CassetteClientPlayerShufflable*) _tmp0_) : NULL);
#line 607 "../src/client/player/player.vala"
	sh_mode = _tmp1_;
#line 609 "../src/client/player/player.vala"
	_tmp2_ = sh_mode;
#line 609 "../src/client/player/player.vala"
	if (_tmp2_ == NULL) {
#line 610 "../src/client/player/player.vala"
		_g_object_unref0 (sh_mode);
#line 610 "../src/client/player/player.vala"
		return;
#line 2086 "player.c"
	}
#line 613 "../src/client/player/player.vala"
	_tmp3_ = sh_mode;
#line 613 "../src/client/player/player.vala"
	cassette_client_player_shufflable_remove_track (_tmp3_, track_info);
#line 615 "../src/client/player/player.vala"
	_tmp5_ = sh_mode;
#line 615 "../src/client/player/player.vala"
	_tmp6_ = cassette_client_player_mode_get_queue ((CassetteClientPlayerMode*) _tmp5_);
#line 615 "../src/client/player/player.vala"
	_tmp7_ = _tmp6_;
#line 615 "../src/client/player/player.vala"
	_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 615 "../src/client/player/player.vala"
	_tmp9_ = _tmp8_;
#line 615 "../src/client/player/player.vala"
	if (_tmp9_ != 0) {
#line 2104 "player.c"
		GSettings* _tmp10_;
#line 615 "../src/client/player/player.vala"
		_tmp10_ = cassette_client_settings;
#line 615 "../src/client/player/player.vala"
		_tmp4_ = g_settings_get_boolean (_tmp10_, "can-cache");
#line 2110 "player.c"
	} else {
#line 615 "../src/client/player/player.vala"
		_tmp4_ = FALSE;
#line 2114 "player.c"
	}
#line 615 "../src/client/player/player.vala"
	if (_tmp4_) {
#line 616 "../src/client/player/player.vala"
		cassette_client_player_player_cache_next_track (self);
#line 2120 "player.c"
	}
#line 606 "../src/client/player/player.vala"
	_g_object_unref0 (sh_mode);
#line 2124 "player.c"
}

void
cassette_client_player_player_rotor_feedback (CassetteClientPlayerPlayer* self,
                                              const gchar* feedback_type,
                                              const gchar* track_id)
{
	gboolean _tmp0_ = FALSE;
	CassetteClientPlayerMode* _tmp1_;
#line 620 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 620 "../src/client/player/player.vala"
	g_return_if_fail (feedback_type != NULL);
#line 620 "../src/client/player/player.vala"
	g_return_if_fail (track_id != NULL);
#line 621 "../src/client/player/player.vala"
	_tmp1_ = self->priv->_mode;
#line 621 "../src/client/player/player.vala"
	if (CASSETTE_CLIENT_PLAYER_IS_FLOW (_tmp1_)) {
#line 2144 "player.c"
		CassetteClientPlayerMode* _tmp2_;
		CassetteClientYaMAPITrack* _tmp3_;
		CassetteClientYaMAPITrack* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 621 "../src/client/player/player.vala"
		_tmp2_ = self->priv->_mode;
#line 621 "../src/client/player/player.vala"
		_tmp3_ = cassette_client_player_mode_get_current_track_info (_tmp2_);
#line 621 "../src/client/player/player.vala"
		_tmp4_ = _tmp3_;
#line 621 "../src/client/player/player.vala"
		_tmp5_ = cassette_client_ya_mapi_track_get_id (_tmp4_);
#line 621 "../src/client/player/player.vala"
		_tmp6_ = _tmp5_;
#line 621 "../src/client/player/player.vala"
		_tmp0_ = g_strcmp0 (_tmp6_, track_id) == 0;
#line 621 "../src/client/player/player.vala"
		_g_object_unref0 (_tmp4_);
#line 2164 "player.c"
	} else {
#line 621 "../src/client/player/player.vala"
		_tmp0_ = FALSE;
#line 2168 "player.c"
	}
#line 621 "../src/client/player/player.vala"
	if (_tmp0_) {
#line 2172 "player.c"
		CassetteClientPlayerMode* _tmp7_;
		gdouble _tmp8_;
#line 622 "../src/client/player/player.vala"
		_tmp7_ = self->priv->_mode;
#line 622 "../src/client/player/player.vala"
		_tmp8_ = self->priv->_total_played_seconds;
#line 622 "../src/client/player/player.vala"
		cassette_client_player_flow_send_feedback (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, CASSETTE_CLIENT_PLAYER_TYPE_FLOW, CassetteClientPlayerFlow), feedback_type, track_id, _tmp8_, NULL, NULL);
#line 2181 "player.c"
	}
}

CassetteClientPlayerPlayer*
cassette_client_player_player_construct (GType object_type)
{
	CassetteClientPlayerPlayer * self = NULL;
#line 39 "../src/client/player/player.vala"
	self = (CassetteClientPlayerPlayer*) g_object_new (object_type, NULL);
#line 39 "../src/client/player/player.vala"
	return self;
#line 2193 "player.c"
}

CassetteClientPlayerPlayer*
cassette_client_player_player_new (void)
{
#line 39 "../src/client/player/player.vala"
	return cassette_client_player_player_construct (CASSETTE_CLIENT_PLAYER_TYPE_PLAYER);
#line 2201 "player.c"
}

CassetteClientPlayerState
cassette_client_player_player_get_state (CassetteClientPlayerPlayer* self)
{
	CassetteClientPlayerState result;
#line 43 "../src/client/player/player.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 44 "../src/client/player/player.vala"
	result = self->priv->_state;
#line 44 "../src/client/player/player.vala"
	return result;
#line 2214 "player.c"
}

static void
cassette_client_player_player_set_state (CassetteClientPlayerPlayer* self,
                                         CassetteClientPlayerState value)
{
#line 46 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/client/player/player.vala"
	self->priv->_state = value;
#line 49 "../src/client/player/player.vala"
	switch (self->priv->_state) {
#line 49 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_STATE_NONE:
#line 2229 "player.c"
		{
			GstElement* _tmp0_;
#line 51 "../src/client/player/player.vala"
			_tmp0_ = self->priv->playbin;
#line 51 "../src/client/player/player.vala"
			gst_element_set_state (_tmp0_, GST_STATE_NULL);
#line 52 "../src/client/player/player.vala"
			break;
#line 2238 "player.c"
		}
#line 49 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_STATE_PLAYING:
#line 2242 "player.c"
		{
			GstElement* _tmp1_;
#line 54 "../src/client/player/player.vala"
			_tmp1_ = self->priv->playbin;
#line 54 "../src/client/player/player.vala"
			gst_element_set_state (_tmp1_, GST_STATE_PLAYING);
#line 55 "../src/client/player/player.vala"
			break;
#line 2251 "player.c"
		}
#line 49 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_STATE_PAUSED:
#line 2255 "player.c"
		{
			GstElement* _tmp2_;
#line 57 "../src/client/player/player.vala"
			_tmp2_ = self->priv->playbin;
#line 57 "../src/client/player/player.vala"
			gst_element_set_state (_tmp2_, GST_STATE_PAUSED);
#line 58 "../src/client/player/player.vala"
			break;
#line 2264 "player.c"
		}
		default:
#line 49 "../src/client/player/player.vala"
		break;
#line 2269 "player.c"
	}
#line 46 "../src/client/player/player.vala"
	g_object_notify_by_pspec ((GObject *) self, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_STATE_PROPERTY]);
#line 2273 "player.c"
}

CassetteClientPlayerRepeatMode
cassette_client_player_player_get_repeat_mode (CassetteClientPlayerPlayer* self)
{
	CassetteClientPlayerRepeatMode result;
#line 63 "../src/client/player/player.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 63 "../src/client/player/player.vala"
	result = self->priv->_repeat_mode;
#line 63 "../src/client/player/player.vala"
	return result;
#line 2286 "player.c"
}

void
cassette_client_player_player_set_repeat_mode (CassetteClientPlayerPlayer* self,
                                               CassetteClientPlayerRepeatMode value)
{
	CassetteClientPlayerRepeatMode old_value;
#line 63 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 63 "../src/client/player/player.vala"
	old_value = cassette_client_player_player_get_repeat_mode (self);
#line 63 "../src/client/player/player.vala"
	if (old_value != value) {
#line 63 "../src/client/player/player.vala"
		self->priv->_repeat_mode = value;
#line 63 "../src/client/player/player.vala"
		g_object_notify_by_pspec ((GObject *) self, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_REPEAT_MODE_PROPERTY]);
#line 2304 "player.c"
	}
}

CassetteClientPlayerShuffleMode
cassette_client_player_player_get_shuffle_mode (CassetteClientPlayerPlayer* self)
{
	CassetteClientPlayerShuffleMode result;
#line 67 "../src/client/player/player.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 68 "../src/client/player/player.vala"
	result = self->priv->_shuffle_mode;
#line 68 "../src/client/player/player.vala"
	return result;
#line 2318 "player.c"
}

void
cassette_client_player_player_set_shuffle_mode (CassetteClientPlayerPlayer* self,
                                                CassetteClientPlayerShuffleMode value)
{
	CassetteClientPlayerShufflable* shufflable_mode = NULL;
	CassetteClientPlayerMode* _tmp0_;
	CassetteClientPlayerShufflable* _tmp1_;
	CassetteClientPlayerShufflable* _tmp2_;
#line 70 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 71 "../src/client/player/player.vala"
	self->priv->_shuffle_mode = value;
#line 73 "../src/client/player/player.vala"
	_tmp0_ = self->priv->_mode;
#line 73 "../src/client/player/player.vala"
	_tmp1_ = _g_object_ref0 (CASSETTE_CLIENT_PLAYER_IS_SHUFFLABLE (_tmp0_) ? ((CassetteClientPlayerShufflable*) _tmp0_) : NULL);
#line 73 "../src/client/player/player.vala"
	shufflable_mode = _tmp1_;
#line 75 "../src/client/player/player.vala"
	_tmp2_ = shufflable_mode;
#line 75 "../src/client/player/player.vala"
	if (_tmp2_ != NULL) {
#line 2343 "player.c"
		GSettings* _tmp5_;
#line 76 "../src/client/player/player.vala"
		switch (self->priv->_shuffle_mode) {
#line 76 "../src/client/player/player.vala"
			case CASSETTE_CLIENT_PLAYER_SHUFFLE_MODE_ON:
#line 2349 "player.c"
			{
				CassetteClientPlayerShufflable* _tmp3_;
#line 78 "../src/client/player/player.vala"
				_tmp3_ = shufflable_mode;
#line 78 "../src/client/player/player.vala"
				cassette_client_player_shufflable_shuffle (_tmp3_);
#line 79 "../src/client/player/player.vala"
				break;
#line 2358 "player.c"
			}
#line 76 "../src/client/player/player.vala"
			case CASSETTE_CLIENT_PLAYER_SHUFFLE_MODE_OFF:
#line 2362 "player.c"
			{
				CassetteClientPlayerShufflable* _tmp4_;
#line 82 "../src/client/player/player.vala"
				_tmp4_ = shufflable_mode;
#line 82 "../src/client/player/player.vala"
				cassette_client_player_shufflable_unshuffle (_tmp4_);
#line 83 "../src/client/player/player.vala"
				break;
#line 2371 "player.c"
			}
			default:
#line 76 "../src/client/player/player.vala"
			break;
#line 2376 "player.c"
		}
#line 86 "../src/client/player/player.vala"
		cassette_client_player_player_update_player (self);
#line 88 "../src/client/player/player.vala"
		_tmp5_ = cassette_client_settings;
#line 88 "../src/client/player/player.vala"
		if (g_settings_get_boolean (_tmp5_, "can-cache")) {
#line 89 "../src/client/player/player.vala"
			cassette_client_player_player_cache_next_track (self);
#line 2386 "player.c"
		}
	}
#line 70 "../src/client/player/player.vala"
	_g_object_unref0 (shufflable_mode);
#line 70 "../src/client/player/player.vala"
	g_object_notify_by_pspec ((GObject *) self, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_SHUFFLE_MODE_PROPERTY]);
#line 2393 "player.c"
}

gdouble
cassette_client_player_player_get_playback_pos_sec (CassetteClientPlayerPlayer* self)
{
	gdouble result;
	gint64 cur = 0LL;
	GstElement* _tmp0_;
	gint64 _tmp1_ = 0LL;
#line 96 "../src/client/player/player.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 98 "../src/client/player/player.vala"
	_tmp0_ = self->priv->playbin;
#line 98 "../src/client/player/player.vala"
	gst_element_query_position (_tmp0_, GST_FORMAT_TIME, &_tmp1_);
#line 98 "../src/client/player/player.vala"
	cur = _tmp1_;
#line 99 "../src/client/player/player.vala"
	result = ((gdouble) cur) / GST_SECOND;
#line 99 "../src/client/player/player.vala"
	return result;
#line 2415 "player.c"
}

gdouble
cassette_client_player_player_get_total_played_seconds (CassetteClientPlayerPlayer* self)
{
	gdouble result;
#line 103 "../src/client/player/player.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 103 "../src/client/player/player.vala"
	result = self->priv->_total_played_seconds;
#line 103 "../src/client/player/player.vala"
	return result;
#line 2428 "player.c"
}

void
cassette_client_player_player_set_total_played_seconds (CassetteClientPlayerPlayer* self,
                                                        gdouble value)
{
	gdouble old_value;
#line 103 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 103 "../src/client/player/player.vala"
	old_value = cassette_client_player_player_get_total_played_seconds (self);
#line 103 "../src/client/player/player.vala"
	if (old_value != value) {
#line 103 "../src/client/player/player.vala"
		self->priv->_total_played_seconds = value;
#line 103 "../src/client/player/player.vala"
		g_object_notify_by_pspec ((GObject *) self, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_TOTAL_PLAYED_SECONDS_PROPERTY]);
#line 2446 "player.c"
	}
}

gint64
cassette_client_player_player_get_playback_pos_ms (CassetteClientPlayerPlayer* self)
{
	gint64 result;
	gint64 cur = 0LL;
	GstElement* _tmp0_;
	gint64 _tmp1_ = 0LL;
#line 106 "../src/client/player/player.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 108 "../src/client/player/player.vala"
	_tmp0_ = self->priv->playbin;
#line 108 "../src/client/player/player.vala"
	gst_element_query_position (_tmp0_, GST_FORMAT_TIME, &_tmp1_);
#line 108 "../src/client/player/player.vala"
	cur = _tmp1_;
#line 109 "../src/client/player/player.vala"
	result = cur / GST_MSECOND;
#line 109 "../src/client/player/player.vala"
	return result;
#line 2469 "player.c"
}

gboolean
cassette_client_player_player_get_can_go_force_prev (CassetteClientPlayerPlayer* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	CassetteClientPlayerMode* _tmp1_;
#line 122 "../src/client/player/player.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 123 "../src/client/player/player.vala"
	_tmp1_ = self->priv->_mode;
#line 123 "../src/client/player/player.vala"
	if (cassette_client_player_mode_get_prev_index (_tmp1_) != -1) {
#line 2484 "player.c"
		gboolean _tmp2_;
#line 123 "../src/client/player/player.vala"
		_tmp2_ = self->priv->_current_track_loading;
#line 123 "../src/client/player/player.vala"
		_tmp0_ = !_tmp2_;
#line 2490 "player.c"
	} else {
#line 123 "../src/client/player/player.vala"
		_tmp0_ = FALSE;
#line 2494 "player.c"
	}
#line 123 "../src/client/player/player.vala"
	result = _tmp0_;
#line 123 "../src/client/player/player.vala"
	return result;
#line 2500 "player.c"
}

gdouble
cassette_client_player_player_get_volume (CassetteClientPlayerPlayer* self)
{
	gdouble result;
#line 127 "../src/client/player/player.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 127 "../src/client/player/player.vala"
	result = self->priv->_volume;
#line 127 "../src/client/player/player.vala"
	return result;
#line 2513 "player.c"
}

void
cassette_client_player_player_set_volume (CassetteClientPlayerPlayer* self,
                                          gdouble value)
{
	gdouble old_value;
#line 127 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/client/player/player.vala"
	old_value = cassette_client_player_player_get_volume (self);
#line 127 "../src/client/player/player.vala"
	if (old_value != value) {
#line 127 "../src/client/player/player.vala"
		self->priv->_volume = value;
#line 127 "../src/client/player/player.vala"
		g_object_notify_by_pspec ((GObject *) self, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_VOLUME_PROPERTY]);
#line 2531 "player.c"
	}
}

gboolean
cassette_client_player_player_get_mute (CassetteClientPlayerPlayer* self)
{
	gboolean result;
#line 129 "../src/client/player/player.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 129 "../src/client/player/player.vala"
	result = self->priv->_mute;
#line 129 "../src/client/player/player.vala"
	return result;
#line 2545 "player.c"
}

void
cassette_client_player_player_set_mute (CassetteClientPlayerPlayer* self,
                                        gboolean value)
{
	gboolean old_value;
#line 129 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 129 "../src/client/player/player.vala"
	old_value = cassette_client_player_player_get_mute (self);
#line 129 "../src/client/player/player.vala"
	if (old_value != value) {
#line 129 "../src/client/player/player.vala"
		self->priv->_mute = value;
#line 129 "../src/client/player/player.vala"
		g_object_notify_by_pspec ((GObject *) self, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_MUTE_PROPERTY]);
#line 2563 "player.c"
	}
}

gboolean
cassette_client_player_player_get_can_go_prev (CassetteClientPlayerPlayer* self)
{
	gboolean result;
#line 131 "../src/client/player/player.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 131 "../src/client/player/player.vala"
	result = self->priv->_can_go_prev;
#line 131 "../src/client/player/player.vala"
	return result;
#line 2577 "player.c"
}

static void
cassette_client_player_player_set_can_go_prev (CassetteClientPlayerPlayer* self,
                                               gboolean value)
{
	gboolean old_value;
#line 131 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 131 "../src/client/player/player.vala"
	old_value = cassette_client_player_player_get_can_go_prev (self);
#line 131 "../src/client/player/player.vala"
	if (old_value != value) {
#line 131 "../src/client/player/player.vala"
		self->priv->_can_go_prev = value;
#line 131 "../src/client/player/player.vala"
		g_object_notify_by_pspec ((GObject *) self, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_CAN_GO_PREV_PROPERTY]);
#line 2595 "player.c"
	}
}

gboolean
cassette_client_player_player_get_can_go_next (CassetteClientPlayerPlayer* self)
{
	gboolean result;
#line 133 "../src/client/player/player.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 133 "../src/client/player/player.vala"
	result = self->priv->_can_go_next;
#line 133 "../src/client/player/player.vala"
	return result;
#line 2609 "player.c"
}

static void
cassette_client_player_player_set_can_go_next (CassetteClientPlayerPlayer* self,
                                               gboolean value)
{
	gboolean old_value;
#line 133 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 133 "../src/client/player/player.vala"
	old_value = cassette_client_player_player_get_can_go_next (self);
#line 133 "../src/client/player/player.vala"
	if (old_value != value) {
#line 133 "../src/client/player/player.vala"
		self->priv->_can_go_next = value;
#line 133 "../src/client/player/player.vala"
		g_object_notify_by_pspec ((GObject *) self, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_CAN_GO_NEXT_PROPERTY]);
#line 2627 "player.c"
	}
}

gboolean
cassette_client_player_player_get_current_track_loading (CassetteClientPlayerPlayer* self)
{
	gboolean result;
#line 138 "../src/client/player/player.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 138 "../src/client/player/player.vala"
	result = self->priv->_current_track_loading;
#line 138 "../src/client/player/player.vala"
	return result;
#line 2641 "player.c"
}

static void
cassette_client_player_player_set_current_track_loading (CassetteClientPlayerPlayer* self,
                                                         gboolean value)
{
	gboolean old_value;
#line 138 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 138 "../src/client/player/player.vala"
	old_value = cassette_client_player_player_get_current_track_loading (self);
#line 138 "../src/client/player/player.vala"
	if (old_value != value) {
#line 138 "../src/client/player/player.vala"
		self->priv->_current_track_loading = value;
#line 138 "../src/client/player/player.vala"
		g_object_notify_by_pspec ((GObject *) self, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_CURRENT_TRACK_LOADING_PROPERTY]);
#line 2659 "player.c"
	}
}

CassetteClientPlayerMode*
cassette_client_player_player_get_mode (CassetteClientPlayerPlayer* self)
{
	CassetteClientPlayerMode* result;
	CassetteClientPlayerMode* _tmp0_;
#line 204 "../src/client/player/player.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 204 "../src/client/player/player.vala"
	_tmp0_ = self->priv->_mode;
#line 204 "../src/client/player/player.vala"
	result = _tmp0_;
#line 204 "../src/client/player/player.vala"
	return result;
#line 2676 "player.c"
}

static void
cassette_client_player_player_set_mode (CassetteClientPlayerPlayer* self,
                                        CassetteClientPlayerMode* value)
{
	CassetteClientPlayerMode* old_value;
#line 204 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 204 "../src/client/player/player.vala"
	old_value = cassette_client_player_player_get_mode (self);
#line 204 "../src/client/player/player.vala"
	if (old_value != value) {
#line 2690 "player.c"
		CassetteClientPlayerMode* _tmp0_;
#line 204 "../src/client/player/player.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 204 "../src/client/player/player.vala"
		_g_object_unref0 (self->priv->_mode);
#line 204 "../src/client/player/player.vala"
		self->priv->_mode = _tmp0_;
#line 204 "../src/client/player/player.vala"
		g_object_notify_by_pspec ((GObject *) self, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_MODE_PROPERTY]);
#line 2700 "player.c"
	}
}

static const gchar*
cassette_client_player_player_get_play_id (CassetteClientPlayerPlayer* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 208 "../src/client/player/player.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 208 "../src/client/player/player.vala"
	_tmp0_ = self->priv->_play_id;
#line 208 "../src/client/player/player.vala"
	result = _tmp0_;
#line 208 "../src/client/player/player.vala"
	return result;
#line 2717 "player.c"
}

static void
cassette_client_player_player_set_play_id (CassetteClientPlayerPlayer* self,
                                           const gchar* value)
{
	gchar* _tmp0_;
#line 208 "../src/client/player/player.vala"
	g_return_if_fail (self != NULL);
#line 208 "../src/client/player/player.vala"
	_tmp0_ = g_strdup (value);
#line 208 "../src/client/player/player.vala"
	_g_free0 (self->priv->_play_id);
#line 208 "../src/client/player/player.vala"
	self->priv->_play_id = _tmp0_;
#line 2733 "player.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_STRING_STRING_INT_STRING (GClosure * closure,
                                                               GValue * return_value,
                                                               guint n_param_values,
                                                               const GValue * param_values,
                                                               gpointer invocation_hint,
                                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_STRING_STRING_INT_STRING) (gpointer data1, gpointer arg_1, const char* arg_2, const char* arg_3, gint arg_4, const char* arg_5, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_STRING_STRING_INT_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 39 "../src/client/player/player.vala"
	g_return_if_fail (n_param_values == 6);
#line 39 "../src/client/player/player.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 39 "../src/client/player/player.vala"
		data1 = closure->data;
#line 39 "../src/client/player/player.vala"
		data2 = param_values->data[0].v_pointer;
#line 2758 "player.c"
	} else {
#line 39 "../src/client/player/player.vala"
		data1 = param_values->data[0].v_pointer;
#line 39 "../src/client/player/player.vala"
		data2 = closure->data;
#line 2764 "player.c"
	}
#line 39 "../src/client/player/player.vala"
	callback = (GMarshalFunc_VOID__OBJECT_STRING_STRING_INT_STRING) (marshal_data ? marshal_data : cc->callback);
#line 39 "../src/client/player/player.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_string (param_values + 2), g_value_get_string (param_values + 3), g_value_get_int (param_values + 4), g_value_get_string (param_values + 5), data2);
#line 2770 "player.c"
}

static void
_cassette_client_player_player___lambda112_ (CassetteClientPlayerPlayer* self,
                                             GstBus* bus,
                                             GstMessage* message)
{
#line 221 "../src/client/player/player.vala"
	g_return_if_fail (bus != NULL);
#line 221 "../src/client/player/player.vala"
	g_return_if_fail (message != NULL);
#line 222 "../src/client/player/player.vala"
	cassette_client_player_player_next_natural (self);
#line 2784 "player.c"
}

static void
__cassette_client_player_player___lambda112__gst_bus_message (GstBus* _sender,
                                                              GstMessage* message,
                                                              gpointer self)
{
#line 221 "../src/client/player/player.vala"
	_cassette_client_player_player___lambda112_ ((CassetteClientPlayerPlayer*) self, _sender, message);
#line 2794 "player.c"
}

static void
_cassette_client_player_player___lambda113_ (CassetteClientPlayerPlayer* self)
{
#line 229 "../src/client/player/player.vala"
	cassette_client_player_player_set_current_track_loading (self, TRUE);
#line 2802 "player.c"
}

static void
__cassette_client_player_player___lambda113__cassette_client_player_player_current_track_start_loading (CassetteClientPlayerPlayer* _sender,
                                                                                                        gpointer self)
{
#line 228 "../src/client/player/player.vala"
	_cassette_client_player_player___lambda113_ ((CassetteClientPlayerPlayer*) self);
#line 2811 "player.c"
}

static void
_cassette_client_player_player___lambda114_ (CassetteClientPlayerPlayer* self)
{
#line 232 "../src/client/player/player.vala"
	cassette_client_player_player_set_current_track_loading (self, FALSE);
#line 2819 "player.c"
}

static void
__cassette_client_player_player___lambda114__cassette_client_player_player_current_track_finish_loading (CassetteClientPlayerPlayer* _sender,
                                                                                                         CassetteClientYaMAPITrack* track_info,
                                                                                                         gpointer self)
{
#line 231 "../src/client/player/player.vala"
	_cassette_client_player_player___lambda114_ ((CassetteClientPlayerPlayer*) self);
#line 2829 "player.c"
}

static void
_cassette_client_player_player___lambda115_ (CassetteClientPlayerPlayer* self)
{
#line 242 "../src/client/player/player.vala"
	cassette_client_player_player_update_player (self);
#line 2837 "player.c"
}

static void
__cassette_client_player_player___lambda115__cassette_client_player_player_next_track_loaded (CassetteClientPlayerPlayer* _sender,
                                                                                              CassetteClientYaMAPITrack* next_track,
                                                                                              gpointer self)
{
#line 241 "../src/client/player/player.vala"
	_cassette_client_player_player___lambda115_ ((CassetteClientPlayerPlayer*) self);
#line 2847 "player.c"
}

static void
_cassette_client_player_player_update_player_cassette_client_player_player_mode_inited (CassetteClientPlayerPlayer* _sender,
                                                                                        gpointer self)
{
#line 245 "../src/client/player/player.vala"
	cassette_client_player_player_update_player ((CassetteClientPlayerPlayer*) self);
#line 2856 "player.c"
}

static gboolean
_cassette_client_player_player___lambda116_ (CassetteClientPlayerPlayer* self)
{
	gdouble _tmp0_;
	gboolean result;
#line 248 "../src/client/player/player.vala"
	cassette_client_player_player_send_callback (self);
#line 250 "../src/client/player/player.vala"
	_tmp0_ = self->priv->_total_played_seconds;
#line 250 "../src/client/player/player.vala"
	cassette_client_player_player_set_total_played_seconds (self, _tmp0_ + CASSETTE_CLIENT_PLAYER_PLAYER_PLAY_CALLBACK_STEP);
#line 252 "../src/client/player/player.vala"
	result = G_SOURCE_CONTINUE;
#line 252 "../src/client/player/player.vala"
	return result;
#line 2874 "player.c"
}

static gboolean
__cassette_client_player_player___lambda116__gsource_func (gpointer self)
{
	gboolean result;
	result = _cassette_client_player_player___lambda116_ ((CassetteClientPlayerPlayer*) self);
#line 247 "../src/client/player/player.vala"
	return result;
#line 2884 "player.c"
}

static GObject *
cassette_client_player_player_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CassetteClientPlayerPlayer * self;
	CassetteClientPlayerEmpty* _tmp0_;
	CassetteClientPlayerEmpty* _tmp1_;
	GstElement* _tmp2_;
	GstBus* bus = NULL;
	GstElement* _tmp3_;
	GstBus* _tmp4_;
	GstBus* _tmp5_;
	GstBus* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GstElement* _tmp9_;
	GSettings* _tmp10_;
	GstElement* _tmp11_;
	GSettings* _tmp12_;
#line 212 "../src/client/player/player.vala"
	parent_class = G_OBJECT_CLASS (cassette_client_player_player_parent_class);
#line 212 "../src/client/player/player.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 212 "../src/client/player/player.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CASSETTE_CLIENT_PLAYER_TYPE_PLAYER, CassetteClientPlayerPlayer);
#line 213 "../src/client/player/player.vala"
	cassette_client_player_player_init (self, NULL, (gint) 0);
#line 215 "../src/client/player/player.vala"
	_tmp0_ = cassette_client_player_empty_new (self);
#line 215 "../src/client/player/player.vala"
	_tmp1_ = _tmp0_;
#line 215 "../src/client/player/player.vala"
	cassette_client_player_player_set_mode (self, (CassetteClientPlayerMode*) _tmp1_);
#line 215 "../src/client/player/player.vala"
	_g_object_unref0 (_tmp1_);
#line 217 "../src/client/player/player.vala"
	_tmp2_ = gst_element_factory_make ("playbin", NULL);
#line 217 "../src/client/player/player.vala"
	if (_tmp2_ != NULL) {
#line 217 "../src/client/player/player.vala"
		g_object_ref_sink (_tmp2_);
#line 2931 "player.c"
	}
#line 217 "../src/client/player/player.vala"
	_g_object_unref0 (self->priv->playbin);
#line 217 "../src/client/player/player.vala"
	self->priv->playbin = _tmp2_;
#line 218 "../src/client/player/player.vala"
	_tmp3_ = self->priv->playbin;
#line 218 "../src/client/player/player.vala"
	_tmp4_ = gst_element_get_bus (_tmp3_);
#line 218 "../src/client/player/player.vala"
	bus = _tmp4_;
#line 220 "../src/client/player/player.vala"
	_tmp5_ = bus;
#line 220 "../src/client/player/player.vala"
	gst_bus_add_signal_watch_full (_tmp5_, G_PRIORITY_DEFAULT);
#line 221 "../src/client/player/player.vala"
	_tmp6_ = bus;
#line 221 "../src/client/player/player.vala"
	g_signal_connect_object (_tmp6_, "message::eos", (GCallback) __cassette_client_player_player___lambda112__gst_bus_message, self, 0);
#line 225 "../src/client/player/player.vala"
	_tmp7_ = cassette_client_settings;
#line 225 "../src/client/player/player.vala"
	g_settings_bind (_tmp7_, "repeat-mode", (GObject*) self, "repeat-mode", G_SETTINGS_BIND_DEFAULT);
#line 226 "../src/client/player/player.vala"
	_tmp8_ = cassette_client_settings;
#line 226 "../src/client/player/player.vala"
	g_settings_bind (_tmp8_, "shuffle-mode", (GObject*) self, "shuffle-mode", G_SETTINGS_BIND_DEFAULT);
#line 228 "../src/client/player/player.vala"
	g_signal_connect_object (self, "current-track-start-loading", (GCallback) __cassette_client_player_player___lambda113__cassette_client_player_player_current_track_start_loading, self, 0);
#line 231 "../src/client/player/player.vala"
	g_signal_connect_object (self, "current-track-finish-loading", (GCallback) __cassette_client_player_player___lambda114__cassette_client_player_player_current_track_finish_loading, self, 0);
#line 235 "../src/client/player/player.vala"
	_tmp9_ = self->priv->playbin;
#line 235 "../src/client/player/player.vala"
	g_object_bind_property_with_closures ((GObject*) self, "volume", (GObject*) _tmp9_, "volume", G_BINDING_BIDIRECTIONAL | G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 236 "../src/client/player/player.vala"
	_tmp10_ = cassette_client_settings;
#line 236 "../src/client/player/player.vala"
	g_settings_bind (_tmp10_, "volume", (GObject*) self, "volume", G_SETTINGS_BIND_DEFAULT);
#line 238 "../src/client/player/player.vala"
	_tmp11_ = self->priv->playbin;
#line 238 "../src/client/player/player.vala"
	g_object_bind_property_with_closures ((GObject*) self, "mute", (GObject*) _tmp11_, "mute", G_BINDING_BIDIRECTIONAL | G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 239 "../src/client/player/player.vala"
	_tmp12_ = cassette_client_settings;
#line 239 "../src/client/player/player.vala"
	g_settings_bind (_tmp12_, "mute", (GObject*) self, "mute", G_SETTINGS_BIND_DEFAULT);
#line 241 "../src/client/player/player.vala"
	g_signal_connect_object (self, "next-track-loaded", (GCallback) __cassette_client_player_player___lambda115__cassette_client_player_player_next_track_loaded, self, 0);
#line 245 "../src/client/player/player.vala"
	g_signal_connect_object (self, "mode-inited", (GCallback) _cassette_client_player_player_update_player_cassette_client_player_player_mode_inited, self, 0);
#line 247 "../src/client/player/player.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) ((gint) (CASSETTE_CLIENT_PLAYER_PLAYER_PLAY_CALLBACK_STEP * 1000.0)), __cassette_client_player_player___lambda116__gsource_func, g_object_ref (self), g_object_unref);
#line 212 "../src/client/player/player.vala"
	_g_object_unref0 (bus);
#line 212 "../src/client/player/player.vala"
	return obj;
#line 2989 "player.c"
}

static void
cassette_client_player_player_class_init (CassetteClientPlayerPlayerClass * klass,
                                          gpointer klass_data)
{
#line 39 "../src/client/player/player.vala"
	cassette_client_player_player_parent_class = g_type_class_peek_parent (klass);
#line 39 "../src/client/player/player.vala"
	g_type_class_adjust_private_offset (klass, &CassetteClientPlayerPlayer_private_offset);
#line 39 "../src/client/player/player.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_cassette_client_player_player_get_property;
#line 39 "../src/client/player/player.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_cassette_client_player_player_set_property;
#line 39 "../src/client/player/player.vala"
	G_OBJECT_CLASS (klass)->constructor = cassette_client_player_player_constructor;
#line 39 "../src/client/player/player.vala"
	G_OBJECT_CLASS (klass)->finalize = cassette_client_player_player_finalize;
#line 39 "../src/client/player/player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_CLIENT_PLAYER_PLAYER_STATE_PROPERTY, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", CASSETTE_CLIENT_PLAYER_TYPE_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 39 "../src/client/player/player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_CLIENT_PLAYER_PLAYER_REPEAT_MODE_PROPERTY, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_REPEAT_MODE_PROPERTY] = g_param_spec_enum ("repeat-mode", "repeat-mode", "repeat-mode", CASSETTE_CLIENT_PLAYER_TYPE_REPEAT_MODE, CASSETTE_CLIENT_PLAYER_REPEAT_MODE_OFF, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 39 "../src/client/player/player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_CLIENT_PLAYER_PLAYER_SHUFFLE_MODE_PROPERTY, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_SHUFFLE_MODE_PROPERTY] = g_param_spec_enum ("shuffle-mode", "shuffle-mode", "shuffle-mode", CASSETTE_CLIENT_PLAYER_TYPE_SHUFFLE_MODE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 39 "../src/client/player/player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_CLIENT_PLAYER_PLAYER_PLAYBACK_POS_SEC_PROPERTY, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_PLAYBACK_POS_SEC_PROPERTY] = g_param_spec_double ("playback-pos-sec", "playback-pos-sec", "playback-pos-sec", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 39 "../src/client/player/player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_CLIENT_PLAYER_PLAYER_TOTAL_PLAYED_SECONDS_PROPERTY, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_TOTAL_PLAYED_SECONDS_PROPERTY] = g_param_spec_double ("total-played-seconds", "total-played-seconds", "total-played-seconds", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 39 "../src/client/player/player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_CLIENT_PLAYER_PLAYER_PLAYBACK_POS_MS_PROPERTY, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_PLAYBACK_POS_MS_PROPERTY] = g_param_spec_int64 ("playback-pos-ms", "playback-pos-ms", "playback-pos-ms", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 39 "../src/client/player/player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_CLIENT_PLAYER_PLAYER_CAN_GO_FORCE_PREV_PROPERTY, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_CAN_GO_FORCE_PREV_PROPERTY] = g_param_spec_boolean ("can-go-force-prev", "can-go-force-prev", "can-go-force-prev", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 39 "../src/client/player/player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_CLIENT_PLAYER_PLAYER_VOLUME_PROPERTY, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_VOLUME_PROPERTY] = g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 39 "../src/client/player/player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_CLIENT_PLAYER_PLAYER_MUTE_PROPERTY, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_MUTE_PROPERTY] = g_param_spec_boolean ("mute", "mute", "mute", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 39 "../src/client/player/player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_CLIENT_PLAYER_PLAYER_CAN_GO_PREV_PROPERTY, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_CAN_GO_PREV_PROPERTY] = g_param_spec_boolean ("can-go-prev", "can-go-prev", "can-go-prev", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 39 "../src/client/player/player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_CLIENT_PLAYER_PLAYER_CAN_GO_NEXT_PROPERTY, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_CAN_GO_NEXT_PROPERTY] = g_param_spec_boolean ("can-go-next", "can-go-next", "can-go-next", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3030 "player.c"
	/**
	     * Is current track loading.
	     */
#line 39 "../src/client/player/player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_CLIENT_PLAYER_PLAYER_CURRENT_TRACK_LOADING_PROPERTY, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_CURRENT_TRACK_LOADING_PROPERTY] = g_param_spec_boolean ("current-track-loading", "current-track-loading", "current-track-loading", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 39 "../src/client/player/player.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_CLIENT_PLAYER_PLAYER_MODE_PROPERTY, cassette_client_player_player_properties[CASSETTE_CLIENT_PLAYER_PLAYER_MODE_PROPERTY] = g_param_spec_object ("mode", "mode", "mode", CASSETTE_CLIENT_PLAYER_TYPE_MODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 39 "../src/client/player/player.vala"
	cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_QUEUE_CHANGED_SIGNAL] = g_signal_new ("queue-changed", CASSETTE_CLIENT_PLAYER_TYPE_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_STRING_STRING_INT_STRING, G_TYPE_NONE, 5, GEE_TYPE_ARRAY_LIST, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_INT, G_TYPE_STRING);
#line 3040 "player.c"
	/**
	     * Feedback.
	     * Triggered when track paused.
	     *
	     * @param track_info    track that been paused
	     */
#line 39 "../src/client/player/player.vala"
	cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_PAUSED_SIGNAL] = g_signal_new ("paused", CASSETTE_CLIENT_PLAYER_TYPE_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, CASSETTE_CLIENT_YA_MAPI_TYPE_TRACK);
#line 3049 "player.c"
	/**
	     * Feedback.
	     * Triggered when track start playing.
	     *
	     * @param track_info    track that start playing
	     */
#line 39 "../src/client/player/player.vala"
	cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_PLAYED_SIGNAL] = g_signal_new ("played", CASSETTE_CLIENT_PLAYER_TYPE_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, CASSETTE_CLIENT_YA_MAPI_TYPE_TRACK);
#line 3058 "player.c"
	/**
	     * Feedback.
	     * Triggered when player stopped.
	     */
#line 39 "../src/client/player/player.vala"
	cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_STOPPED_SIGNAL] = g_signal_new ("stopped", CASSETTE_CLIENT_PLAYER_TYPE_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3065 "player.c"
	/**
	     * Feedback.
	     * Triggered when track stopped.
	     */
#line 39 "../src/client/player/player.vala"
	cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_TRACK_STOPPED_SIGNAL] = g_signal_new ("track-stopped", CASSETTE_CLIENT_PLAYER_TYPE_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3072 "player.c"
	/**
	     * Next track loaded and ready to play.
	     * For situations where there was a switch to
	     * the next track so that the interface could react correctly.
	     */
#line 39 "../src/client/player/player.vala"
	cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_READY_PLAY_NEXT_SIGNAL] = g_signal_new ("ready-play-next", CASSETTE_CLIENT_PLAYER_TYPE_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3080 "player.c"
	/**
	     * Previous track loaded and ready to play.
	     * For situations where there was a switch to
	     * the previous track so that the interface could react correctly.
	     */
#line 39 "../src/client/player/player.vala"
	cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_READY_PLAY_PREV_SIGNAL] = g_signal_new ("ready-play-prev", CASSETTE_CLIENT_PLAYER_TYPE_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3088 "player.c"
	/**
	     * Triggers when previous track in queue finish loading.
	     * For next track show possibility.
	     */
#line 39 "../src/client/player/player.vala"
	cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_NEXT_TRACK_LOADED_SIGNAL] = g_signal_new ("next-track-loaded", CASSETTE_CLIENT_PLAYER_TYPE_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, CASSETTE_CLIENT_YA_MAPI_TYPE_TRACK);
#line 3095 "player.c"
	/**
	     * Current track started loaded.
	     * Interface should block for interaction.
	     */
#line 39 "../src/client/player/player.vala"
	cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_CURRENT_TRACK_START_LOADING_SIGNAL] = g_signal_new ("current-track-start-loading", CASSETTE_CLIENT_PLAYER_TYPE_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3102 "player.c"
	/**
	     * Current track started loaded.
	     * Interface can be released from block.
	     */
#line 39 "../src/client/player/player.vala"
	cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_CURRENT_TRACK_FINISH_LOADING_SIGNAL] = g_signal_new ("current-track-finish-loading", CASSETTE_CLIENT_PLAYER_TYPE_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, CASSETTE_CLIENT_YA_MAPI_TYPE_TRACK);
#line 39 "../src/client/player/player.vala"
	cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_PLAYBACK_CALLBACK_SIGNAL] = g_signal_new ("playback-callback", CASSETTE_CLIENT_PLAYER_TYPE_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
#line 39 "../src/client/player/player.vala"
	cassette_client_player_player_signals[CASSETTE_CLIENT_PLAYER_PLAYER_MODE_INITED_SIGNAL] = g_signal_new ("mode-inited", CASSETTE_CLIENT_PLAYER_TYPE_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3113 "player.c"
}

static void
cassette_client_player_player_instance_init (CassetteClientPlayerPlayer * self,
                                             gpointer klass)
{
	gchar* _tmp0_;
#line 39 "../src/client/player/player.vala"
	self->priv = cassette_client_player_player_get_instance_private (self);
#line 41 "../src/client/player/player.vala"
	self->priv->_state = CASSETTE_CLIENT_PLAYER_STATE_NONE;
#line 63 "../src/client/player/player.vala"
	self->priv->_repeat_mode = CASSETTE_CLIENT_PLAYER_REPEAT_MODE_OFF;
#line 65 "../src/client/player/player.vala"
	self->priv->_shuffle_mode = CASSETTE_CLIENT_PLAYER_SHUFFLE_MODE_OFF;
#line 103 "../src/client/player/player.vala"
	self->priv->_total_played_seconds = 0.0;
#line 131 "../src/client/player/player.vala"
	self->priv->_can_go_prev = TRUE;
#line 133 "../src/client/player/player.vala"
	self->priv->_can_go_next = TRUE;
#line 138 "../src/client/player/player.vala"
	self->priv->_current_track_loading = FALSE;
#line 208 "../src/client/player/player.vala"
	_tmp0_ = g_strdup ("");
#line 208 "../src/client/player/player.vala"
	self->priv->_play_id = _tmp0_;
#line 3141 "player.c"
}

static void
cassette_client_player_player_finalize (GObject * obj)
{
	CassetteClientPlayerPlayer * self;
#line 39 "../src/client/player/player.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CASSETTE_CLIENT_PLAYER_TYPE_PLAYER, CassetteClientPlayerPlayer);
#line 204 "../src/client/player/player.vala"
	_g_object_unref0 (self->priv->_mode);
#line 208 "../src/client/player/player.vala"
	_g_free0 (self->priv->_play_id);
#line 210 "../src/client/player/player.vala"
	_g_object_unref0 (self->priv->playbin);
#line 39 "../src/client/player/player.vala"
	G_OBJECT_CLASS (cassette_client_player_player_parent_class)->finalize (obj);
#line 3158 "player.c"
}

 G_GNUC_NO_INLINE static GType
cassette_client_player_player_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CassetteClientPlayerPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cassette_client_player_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CassetteClientPlayerPlayer), 0, (GInstanceInitFunc) cassette_client_player_player_instance_init, NULL };
	GType cassette_client_player_player_type_id;
	cassette_client_player_player_type_id = g_type_register_static (G_TYPE_OBJECT, "CassetteClientPlayerPlayer", &g_define_type_info, 0);
	CassetteClientPlayerPlayer_private_offset = g_type_add_instance_private (cassette_client_player_player_type_id, sizeof (CassetteClientPlayerPlayerPrivate));
	return cassette_client_player_player_type_id;
}

GType
cassette_client_player_player_get_type (void)
{
	static gsize cassette_client_player_player_type_id__once = 0;
	if (g_once_init_enter (&cassette_client_player_player_type_id__once)) {
		GType cassette_client_player_player_type_id;
		cassette_client_player_player_type_id = cassette_client_player_player_get_type_once ();
		g_once_init_leave (&cassette_client_player_player_type_id__once, cassette_client_player_player_type_id);
	}
	return cassette_client_player_player_type_id__once;
}

static void
_vala_cassette_client_player_player_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	CassetteClientPlayerPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CASSETTE_CLIENT_PLAYER_TYPE_PLAYER, CassetteClientPlayerPlayer);
#line 39 "../src/client/player/player.vala"
	switch (property_id) {
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_STATE_PROPERTY:
#line 39 "../src/client/player/player.vala"
		g_value_set_enum (value, cassette_client_player_player_get_state (self));
#line 39 "../src/client/player/player.vala"
		break;
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_REPEAT_MODE_PROPERTY:
#line 39 "../src/client/player/player.vala"
		g_value_set_enum (value, cassette_client_player_player_get_repeat_mode (self));
#line 39 "../src/client/player/player.vala"
		break;
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_SHUFFLE_MODE_PROPERTY:
#line 39 "../src/client/player/player.vala"
		g_value_set_enum (value, cassette_client_player_player_get_shuffle_mode (self));
#line 39 "../src/client/player/player.vala"
		break;
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_PLAYBACK_POS_SEC_PROPERTY:
#line 39 "../src/client/player/player.vala"
		g_value_set_double (value, cassette_client_player_player_get_playback_pos_sec (self));
#line 39 "../src/client/player/player.vala"
		break;
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_TOTAL_PLAYED_SECONDS_PROPERTY:
#line 39 "../src/client/player/player.vala"
		g_value_set_double (value, cassette_client_player_player_get_total_played_seconds (self));
#line 39 "../src/client/player/player.vala"
		break;
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_PLAYBACK_POS_MS_PROPERTY:
#line 39 "../src/client/player/player.vala"
		g_value_set_int64 (value, cassette_client_player_player_get_playback_pos_ms (self));
#line 39 "../src/client/player/player.vala"
		break;
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_CAN_GO_FORCE_PREV_PROPERTY:
#line 39 "../src/client/player/player.vala"
		g_value_set_boolean (value, cassette_client_player_player_get_can_go_force_prev (self));
#line 39 "../src/client/player/player.vala"
		break;
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_VOLUME_PROPERTY:
#line 39 "../src/client/player/player.vala"
		g_value_set_double (value, cassette_client_player_player_get_volume (self));
#line 39 "../src/client/player/player.vala"
		break;
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_MUTE_PROPERTY:
#line 39 "../src/client/player/player.vala"
		g_value_set_boolean (value, cassette_client_player_player_get_mute (self));
#line 39 "../src/client/player/player.vala"
		break;
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_CAN_GO_PREV_PROPERTY:
#line 39 "../src/client/player/player.vala"
		g_value_set_boolean (value, cassette_client_player_player_get_can_go_prev (self));
#line 39 "../src/client/player/player.vala"
		break;
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_CAN_GO_NEXT_PROPERTY:
#line 39 "../src/client/player/player.vala"
		g_value_set_boolean (value, cassette_client_player_player_get_can_go_next (self));
#line 39 "../src/client/player/player.vala"
		break;
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_CURRENT_TRACK_LOADING_PROPERTY:
#line 39 "../src/client/player/player.vala"
		g_value_set_boolean (value, cassette_client_player_player_get_current_track_loading (self));
#line 39 "../src/client/player/player.vala"
		break;
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_MODE_PROPERTY:
#line 39 "../src/client/player/player.vala"
		g_value_set_object (value, cassette_client_player_player_get_mode (self));
#line 39 "../src/client/player/player.vala"
		break;
#line 3271 "player.c"
		default:
#line 39 "../src/client/player/player.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 39 "../src/client/player/player.vala"
		break;
#line 3277 "player.c"
	}
}

static void
_vala_cassette_client_player_player_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec)
{
	CassetteClientPlayerPlayer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CASSETTE_CLIENT_PLAYER_TYPE_PLAYER, CassetteClientPlayerPlayer);
#line 39 "../src/client/player/player.vala"
	switch (property_id) {
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_STATE_PROPERTY:
#line 39 "../src/client/player/player.vala"
		cassette_client_player_player_set_state (self, g_value_get_enum (value));
#line 39 "../src/client/player/player.vala"
		break;
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_REPEAT_MODE_PROPERTY:
#line 39 "../src/client/player/player.vala"
		cassette_client_player_player_set_repeat_mode (self, g_value_get_enum (value));
#line 39 "../src/client/player/player.vala"
		break;
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_SHUFFLE_MODE_PROPERTY:
#line 39 "../src/client/player/player.vala"
		cassette_client_player_player_set_shuffle_mode (self, g_value_get_enum (value));
#line 39 "../src/client/player/player.vala"
		break;
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_TOTAL_PLAYED_SECONDS_PROPERTY:
#line 39 "../src/client/player/player.vala"
		cassette_client_player_player_set_total_played_seconds (self, g_value_get_double (value));
#line 39 "../src/client/player/player.vala"
		break;
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_VOLUME_PROPERTY:
#line 39 "../src/client/player/player.vala"
		cassette_client_player_player_set_volume (self, g_value_get_double (value));
#line 39 "../src/client/player/player.vala"
		break;
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_MUTE_PROPERTY:
#line 39 "../src/client/player/player.vala"
		cassette_client_player_player_set_mute (self, g_value_get_boolean (value));
#line 39 "../src/client/player/player.vala"
		break;
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_CAN_GO_PREV_PROPERTY:
#line 39 "../src/client/player/player.vala"
		cassette_client_player_player_set_can_go_prev (self, g_value_get_boolean (value));
#line 39 "../src/client/player/player.vala"
		break;
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_CAN_GO_NEXT_PROPERTY:
#line 39 "../src/client/player/player.vala"
		cassette_client_player_player_set_can_go_next (self, g_value_get_boolean (value));
#line 39 "../src/client/player/player.vala"
		break;
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_CURRENT_TRACK_LOADING_PROPERTY:
#line 39 "../src/client/player/player.vala"
		cassette_client_player_player_set_current_track_loading (self, g_value_get_boolean (value));
#line 39 "../src/client/player/player.vala"
		break;
#line 39 "../src/client/player/player.vala"
		case CASSETTE_CLIENT_PLAYER_PLAYER_MODE_PROPERTY:
#line 39 "../src/client/player/player.vala"
		cassette_client_player_player_set_mode (self, g_value_get_object (value));
#line 39 "../src/client/player/player.vala"
		break;
#line 3351 "player.c"
		default:
#line 39 "../src/client/player/player.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 39 "../src/client/player/player.vala"
		break;
#line 3357 "player.c"
	}
}

