/* soup-wrapper.c generated by valac 0.56.18, the Vala compiler
 * generated from soup-wrapper.vala, do not modify */

/* Copyright 2023-2024 Vladimir Vaskov
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>
#include <libsoup/soup.h>
#include <gee.h>
#include <gio/gio.h>
#include <json-glib/json-glib.h>

#define CASSETTE_CLIENT_TIMEOUT 10
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CASSETTE_CLIENT_TYPE_BAD_STATUS_CODE_ERROR (cassette_client_bad_status_code_error_get_type ())

#define CASSETTE_CLIENT_TYPE_HEADER (cassette_client_header_get_type ())
typedef struct _CassetteClientHeader CassetteClientHeader;
#define _g_free0(var) (var = (g_free (var), NULL))

#define CASSETTE_CLIENT_TYPE_HEADERS (cassette_client_headers_get_type ())
#define CASSETTE_CLIENT_HEADERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_CLIENT_TYPE_HEADERS, CassetteClientHeaders))
#define CASSETTE_CLIENT_HEADERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_CLIENT_TYPE_HEADERS, CassetteClientHeadersClass))
#define CASSETTE_CLIENT_IS_HEADERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_CLIENT_TYPE_HEADERS))
#define CASSETTE_CLIENT_IS_HEADERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_CLIENT_TYPE_HEADERS))
#define CASSETTE_CLIENT_HEADERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_CLIENT_TYPE_HEADERS, CassetteClientHeadersClass))

typedef struct _CassetteClientHeaders CassetteClientHeaders;
typedef struct _CassetteClientHeadersClass CassetteClientHeadersClass;
typedef struct _CassetteClientHeadersPrivate CassetteClientHeadersPrivate;
typedef struct _CassetteClientParamSpecHeaders CassetteClientParamSpecHeaders;
typedef enum  {
	CASSETTE_CLIENT_POST_CONTENT_TYPE_X_WWW_FORM_URLENCODED,
	CASSETTE_CLIENT_POST_CONTENT_TYPE_JSON
} CassetteClientPostContentType;

#define CASSETTE_CLIENT_TYPE_POST_CONTENT_TYPE (cassette_client_post_content_type_get_type ())

#define CASSETTE_CLIENT_TYPE_POST_CONTENT (cassette_client_post_content_get_type ())
typedef struct _CassetteClientPostContent CassetteClientPostContent;

#define CASSETTE_CLIENT_TYPE_SOUP_WRAPPER (cassette_client_soup_wrapper_get_type ())
#define CASSETTE_CLIENT_SOUP_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_CLIENT_TYPE_SOUP_WRAPPER, CassetteClientSoupWrapper))
#define CASSETTE_CLIENT_SOUP_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_CLIENT_TYPE_SOUP_WRAPPER, CassetteClientSoupWrapperClass))
#define CASSETTE_CLIENT_IS_SOUP_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_CLIENT_TYPE_SOUP_WRAPPER))
#define CASSETTE_CLIENT_IS_SOUP_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_CLIENT_TYPE_SOUP_WRAPPER))
#define CASSETTE_CLIENT_SOUP_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_CLIENT_TYPE_SOUP_WRAPPER, CassetteClientSoupWrapperClass))

typedef struct _CassetteClientSoupWrapper CassetteClientSoupWrapper;
typedef struct _CassetteClientSoupWrapperClass CassetteClientSoupWrapperClass;
typedef struct _CassetteClientSoupWrapperPrivate CassetteClientSoupWrapperPrivate;
enum  {
	CASSETTE_CLIENT_SOUP_WRAPPER_0_PROPERTY,
	CASSETTE_CLIENT_SOUP_WRAPPER_USER_AGENT_PROPERTY,
	CASSETTE_CLIENT_SOUP_WRAPPER_COOKIES_FILE_PROPERTY,
	CASSETTE_CLIENT_SOUP_WRAPPER_NUM_PROPERTIES
};
static GParamSpec* cassette_client_soup_wrapper_properties[CASSETTE_CLIENT_SOUP_WRAPPER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cassette_client_headers_unref0(var) ((var == NULL) ? NULL : (var = (cassette_client_headers_unref (var), NULL)))
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))

#define CASSETTE_CLIENT_TYPE_CLIENT_ERROR (cassette_client_client_error_get_type ())

#define CASSETTE_CLIENT_TYPE_YA_MOBJECT (cassette_client_ya_mobject_get_type ())
#define CASSETTE_CLIENT_YA_MOBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_CLIENT_TYPE_YA_MOBJECT, CassetteClientYaMObject))
#define CASSETTE_CLIENT_YA_MOBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_CLIENT_TYPE_YA_MOBJECT, CassetteClientYaMObjectClass))
#define CASSETTE_CLIENT_IS_YA_MOBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_CLIENT_TYPE_YA_MOBJECT))
#define CASSETTE_CLIENT_IS_YA_MOBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_CLIENT_TYPE_YA_MOBJECT))
#define CASSETTE_CLIENT_YA_MOBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_CLIENT_TYPE_YA_MOBJECT, CassetteClientYaMObjectClass))

typedef struct _CassetteClientYaMObject CassetteClientYaMObject;
typedef struct _CassetteClientYaMObjectClass CassetteClientYaMObjectClass;

#define CASSETTE_CLIENT_YA_MAPI_TYPE_API_ERROR (cassette_client_ya_mapi_api_error_get_type ())
#define CASSETTE_CLIENT_YA_MAPI_API_ERROR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_CLIENT_YA_MAPI_TYPE_API_ERROR, CassetteClientYaMAPIApiError))
#define CASSETTE_CLIENT_YA_MAPI_API_ERROR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_CLIENT_YA_MAPI_TYPE_API_ERROR, CassetteClientYaMAPIApiErrorClass))
#define CASSETTE_CLIENT_YA_MAPI_IS_API_ERROR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_CLIENT_YA_MAPI_TYPE_API_ERROR))
#define CASSETTE_CLIENT_YA_MAPI_IS_API_ERROR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_CLIENT_YA_MAPI_TYPE_API_ERROR))
#define CASSETTE_CLIENT_YA_MAPI_API_ERROR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_CLIENT_YA_MAPI_TYPE_API_ERROR, CassetteClientYaMAPIApiErrorClass))

typedef struct _CassetteClientYaMAPIApiError CassetteClientYaMAPIApiError;
typedef struct _CassetteClientYaMAPIApiErrorClass CassetteClientYaMAPIApiErrorClass;

#define CASSETTE_CLIENT_TYPE_JSONER (cassette_client_jsoner_get_type ())
#define CASSETTE_CLIENT_JSONER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_CLIENT_TYPE_JSONER, CassetteClientJsoner))
#define CASSETTE_CLIENT_JSONER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_CLIENT_TYPE_JSONER, CassetteClientJsonerClass))
#define CASSETTE_CLIENT_IS_JSONER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_CLIENT_TYPE_JSONER))
#define CASSETTE_CLIENT_IS_JSONER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_CLIENT_TYPE_JSONER))
#define CASSETTE_CLIENT_JSONER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_CLIENT_TYPE_JSONER, CassetteClientJsonerClass))

typedef struct _CassetteClientJsoner CassetteClientJsoner;
typedef struct _CassetteClientJsonerClass CassetteClientJsonerClass;
typedef enum  {
	CASSETTE_CLIENT_CASE_SNAKE,
	CASSETTE_CLIENT_CASE_KEBAB,
	CASSETTE_CLIENT_CASE_CAMEL
} CassetteClientCase;

#define CASSETTE_CLIENT_TYPE_CASE (cassette_client_case_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _CassetteClientSoupWrapperRunAsyncData CassetteClientSoupWrapperRunAsyncData;
typedef struct _CassetteClientSoupWrapperGetAsyncData CassetteClientSoupWrapperGetAsyncData;
#define _cassette_client_post_content_free0(var) ((var == NULL) ? NULL : (var = (cassette_client_post_content_free (var), NULL)))
typedef struct _CassetteClientSoupWrapperPostAsyncData CassetteClientSoupWrapperPostAsyncData;
typedef enum  {
	CASSETTE_CLIENT_LOG_LEVEL_DEVEL,
	CASSETTE_CLIENT_LOG_LEVEL_DEBUG,
	CASSETTE_CLIENT_LOG_LEVEL_USER,
	CASSETTE_CLIENT_LOG_LEVEL_NONE
} CassetteClientLogLevel;

#define CASSETTE_CLIENT_TYPE_LOG_LEVEL (cassette_client_log_level_get_type ())

typedef enum  {
	CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR_BAD_REQUEST = 400,
	CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR_NOT_FOUND = 404,
	CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR_UNAUTHORIZE_ERROR = 403,
	CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR_UNKNOWN = 0
} CassetteClientBadStatusCodeError;
#define CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR cassette_client_bad_status_code_error_quark ()

struct _CassetteClientHeader {
	gchar* name;
	gchar* value;
};

struct _CassetteClientHeaders {
	GTypeInstance parent_instance;
	volatile int ref_count;
	CassetteClientHeadersPrivate * priv;
};

struct _CassetteClientHeadersClass {
	GTypeClass parent_class;
	void (*finalize) (CassetteClientHeaders *self);
};

struct _CassetteClientHeadersPrivate {
	CassetteClientHeader* headers_arr;
	gint headers_arr_length1;
	gint _headers_arr_size_;
};

struct _CassetteClientParamSpecHeaders {
	GParamSpec parent_instance;
};

struct _CassetteClientPostContent {
	CassetteClientPostContentType content_type;
	gchar* content;
};

struct _CassetteClientSoupWrapper {
	GObject parent_instance;
	CassetteClientSoupWrapperPrivate * priv;
};

struct _CassetteClientSoupWrapperClass {
	GObjectClass parent_class;
};

struct _CassetteClientSoupWrapperPrivate {
	GeeHashMap* presets_table;
	SoupSession* session;
};

typedef enum  {
	CASSETTE_CLIENT_CLIENT_ERROR_PARSE_ERROR,
	CASSETTE_CLIENT_CLIENT_ERROR_SOUP_ERROR,
	CASSETTE_CLIENT_CLIENT_ERROR_ANSWER_ERROR,
	CASSETTE_CLIENT_CLIENT_ERROR_AUTH_ERROR
} CassetteClientClientError;
#define CASSETTE_CLIENT_CLIENT_ERROR cassette_client_client_error_quark ()

struct _CassetteClientSoupWrapperRunAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	CassetteClientSoupWrapper* self;
	SoupMessage* msg;
	gint priority;
	GBytes* result;
	GBytes* bytes;
	GBytes* _tmp0_;
	SoupSession* _tmp1_;
	GBytes* _tmp2_;
	GBytes* _tmp3_;
	GError* e;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GUri* _tmp6_;
	GUri* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GError* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GError* _tmp14_;
	GError* _tmp15_;
	GBytes* _tmp16_;
	GError* _inner_error0_;
};

struct _CassetteClientSoupWrapperGetAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	CassetteClientSoupWrapper* self;
	gchar* uri;
	gchar** header_preset_names;
	gint header_preset_names_length1;
	gchar** parameters;
	gint parameters_length1;
	gint parameters_length2;
	CassetteClientHeader* headers;
	gint headers_length1;
	gint priority;
	GBytes* result;
	SoupMessage* msg;
	gchar* _tmp0_;
	SoupMessage* _tmp1_;
	GBytes* _tmp2_;
	GBytes* _tmp3_;
	GBytes* _tmp4_;
	GError* _inner_error0_;
};

struct _CassetteClientSoupWrapperPostAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	CassetteClientSoupWrapper* self;
	gchar* uri;
	gchar** header_preset_names;
	gint header_preset_names_length1;
	CassetteClientPostContent* post_content;
	gchar** parameters;
	gint parameters_length1;
	gint parameters_length2;
	CassetteClientHeader* headers;
	gint headers_length1;
	gint priority;
	GBytes* result;
	SoupMessage* msg;
	gchar* _tmp0_;
	SoupMessage* _tmp1_;
	GBytes* _tmp2_;
	GBytes* _tmp3_;
	GBytes* _tmp4_;
	GError* _inner_error0_;
};

static gint CassetteClientHeaders_private_offset;
static gpointer cassette_client_headers_parent_class = NULL;
static gint CassetteClientSoupWrapper_private_offset;
static gpointer cassette_client_soup_wrapper_parent_class = NULL;

VALA_EXTERN GQuark cassette_client_bad_status_code_error_quark (void);
VALA_EXTERN GType cassette_client_bad_status_code_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType cassette_client_header_get_type (void) G_GNUC_CONST ;
VALA_EXTERN CassetteClientHeader* cassette_client_header_dup (const CassetteClientHeader* self);
VALA_EXTERN void cassette_client_header_free (CassetteClientHeader* self);
VALA_EXTERN void cassette_client_header_copy (const CassetteClientHeader* self,
                                  CassetteClientHeader* dest);
VALA_EXTERN void cassette_client_header_destroy (CassetteClientHeader* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (CassetteClientHeader, cassette_client_header_destroy)
VALA_EXTERN gpointer cassette_client_headers_ref (gpointer instance);
VALA_EXTERN void cassette_client_headers_unref (gpointer instance);
VALA_EXTERN GParamSpec* cassette_client_param_spec_headers (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
VALA_EXTERN void cassette_client_value_set_headers (GValue* value,
                                        gpointer v_object);
VALA_EXTERN void cassette_client_value_take_headers (GValue* value,
                                         gpointer v_object);
VALA_EXTERN gpointer cassette_client_value_get_headers (const GValue* value);
VALA_EXTERN GType cassette_client_headers_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteClientHeaders, cassette_client_headers_unref)
static void _vala_CassetteClientHeader_array_free (CassetteClientHeader * array,
                                            gssize array_length);
VALA_EXTERN CassetteClientHeaders* cassette_client_headers_new (void);
VALA_EXTERN CassetteClientHeaders* cassette_client_headers_construct (GType object_type);
VALA_EXTERN void cassette_client_headers_add (CassetteClientHeaders* self,
                                  CassetteClientHeader* header);
VALA_EXTERN void cassette_client_headers_set_headers (CassetteClientHeaders* self,
                                          CassetteClientHeader* headers_arr,
                                          gint headers_arr_length1);
static CassetteClientHeader* _vala_array_dup13 (CassetteClientHeader* self,
                                         gssize length);
VALA_EXTERN CassetteClientHeader* cassette_client_headers_get_headers (CassetteClientHeaders* self,
                                                           gint* result_length1);
static CassetteClientHeader* _vala_array_dup14 (CassetteClientHeader* self,
                                         gssize length);
static void cassette_client_headers_finalize (CassetteClientHeaders * obj);
static GType cassette_client_headers_get_type_once (void);
VALA_EXTERN GType cassette_client_post_content_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType cassette_client_post_content_get_type (void) G_GNUC_CONST ;
VALA_EXTERN CassetteClientPostContent* cassette_client_post_content_dup (const CassetteClientPostContent* self);
VALA_EXTERN void cassette_client_post_content_free (CassetteClientPostContent* self);
VALA_EXTERN void cassette_client_post_content_copy (const CassetteClientPostContent* self,
                                        CassetteClientPostContent* dest);
VALA_EXTERN void cassette_client_post_content_destroy (CassetteClientPostContent* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (CassetteClientPostContent, cassette_client_post_content_destroy)
VALA_EXTERN gchar* cassette_client_post_content_get_content_type_string (CassetteClientPostContent *self);
VALA_EXTERN GBytes* cassette_client_post_content_get_bytes (CassetteClientPostContent *self);
VALA_EXTERN void cassette_client_post_content_set_datalist (CassetteClientPostContent *self,
                                                GData** datalist);
VALA_EXTERN gchar* cassette_client_jsoner_serialize_datalist (GData** datalist);
VALA_EXTERN GType cassette_client_soup_wrapper_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteClientSoupWrapper, g_object_unref)
VALA_EXTERN CassetteClientSoupWrapper* cassette_client_soup_wrapper_new (const gchar* user_agent,
                                                             GFile* cookies_file);
VALA_EXTERN CassetteClientSoupWrapper* cassette_client_soup_wrapper_construct (GType object_type,
                                                                   const gchar* user_agent,
                                                                   GFile* cookies_file);
VALA_EXTERN void cassette_client_soup_wrapper_reload_cookies (CassetteClientSoupWrapper* self,
                                                  GFile* cookies_file);
VALA_EXTERN void cassette_client_logger_debug (const gchar* message);
VALA_EXTERN void cassette_client_soup_wrapper_add_headers_preset (CassetteClientSoupWrapper* self,
                                                      const gchar* preset_name,
                                                      CassetteClientHeader* headers_arr,
                                                      gint headers_arr_length1);
static void cassette_client_soup_wrapper_append_headers_with_preset_to (CassetteClientSoupWrapper* self,
                                                                 SoupMessage* msg,
                                                                 const gchar* preset_name);
static void cassette_client_soup_wrapper_append_headers_to (CassetteClientSoupWrapper* self,
                                                     SoupMessage* msg,
                                                     CassetteClientHeader* headers_arr,
                                                     gint headers_arr_length1);
static void cassette_client_soup_wrapper_add_params_to_uri (CassetteClientSoupWrapper* self,
                                                     gchar** parameters,
                                                     gint parameters_length1,
                                                     gint parameters_length2,
                                                     gchar** uri);
static SoupMessage* cassette_client_soup_wrapper_message_get (CassetteClientSoupWrapper* self,
                                                       gchar* uri,
                                                       gchar** header_preset_names,
                                                       gint header_preset_names_length1,
                                                       gchar** parameters,
                                                       gint parameters_length1,
                                                       gint parameters_length2,
                                                       CassetteClientHeader* headers,
                                                       gint headers_length1);
static SoupMessage* cassette_client_soup_wrapper_message_post (CassetteClientSoupWrapper* self,
                                                        gchar* uri,
                                                        gchar** header_preset_names,
                                                        gint header_preset_names_length1,
                                                        CassetteClientPostContent* post_content,
                                                        gchar** parameters,
                                                        gint parameters_length1,
                                                        gint parameters_length2,
                                                        CassetteClientHeader* headers,
                                                        gint headers_length1);
VALA_EXTERN GQuark cassette_client_client_error_quark (void);
VALA_EXTERN GType cassette_client_client_error_get_type (void) G_GNUC_CONST ;
static void cassette_client_soup_wrapper_check_status_code (CassetteClientSoupWrapper* self,
                                                     SoupMessage* msg,
                                                     GBytes* bytes,
                                                     GError** error);
VALA_EXTERN GType cassette_client_ya_mobject_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteClientYaMObject, g_object_unref)
VALA_EXTERN GType cassette_client_ya_mapi_api_error_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteClientYaMAPIApiError, g_object_unref)
VALA_EXTERN CassetteClientYaMAPIApiError* cassette_client_ya_mapi_api_error_new (void);
VALA_EXTERN CassetteClientYaMAPIApiError* cassette_client_ya_mapi_api_error_construct (GType object_type);
VALA_EXTERN GType cassette_client_jsoner_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteClientJsoner, g_object_unref)
VALA_EXTERN GType cassette_client_case_get_type (void) G_GNUC_CONST ;
VALA_EXTERN CassetteClientJsoner* cassette_client_jsoner_from_bytes (GBytes* bytes,
                                                         gchar** sub_members,
                                                         gint sub_members_length1,
                                                         CassetteClientCase names_case,
                                                         GError** error);
VALA_EXTERN JsonNode* cassette_client_jsoner_get_root (CassetteClientJsoner* self);
VALA_EXTERN CassetteClientYaMObject* cassette_client_jsoner_deserialize_object (CassetteClientJsoner* self,
                                                                    GType obj_type,
                                                                    JsonNode* node,
                                                                    GError** error);
VALA_EXTERN void cassette_client_ya_mapi_api_error_set_status_code (CassetteClientYaMAPIApiError* self,
                                                        guint value);
VALA_EXTERN gchar* cassette_client_ya_mapi_api_error_get_msg (CassetteClientYaMAPIApiError* self);
static GBytes* cassette_client_soup_wrapper_run_sync (CassetteClientSoupWrapper* self,
                                               SoupMessage* msg,
                                               GError** error);
static void cassette_client_soup_wrapper_run_async_data_free (gpointer _data);
static void cassette_client_soup_wrapper_run_async (CassetteClientSoupWrapper* self,
                                             SoupMessage* msg,
                                             gint priority,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
static GBytes* cassette_client_soup_wrapper_run_finish (CassetteClientSoupWrapper* self,
                                                 GAsyncResult* _res_,
                                                 GError** error);
static gboolean cassette_client_soup_wrapper_run_async_co (CassetteClientSoupWrapperRunAsyncData* _data_);
static void cassette_client_soup_wrapper_run_async_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_);
VALA_EXTERN GBytes* cassette_client_soup_wrapper_get_sync (CassetteClientSoupWrapper* self,
                                               gchar* uri,
                                               gchar** header_preset_names,
                                               gint header_preset_names_length1,
                                               gchar** parameters,
                                               gint parameters_length1,
                                               gint parameters_length2,
                                               CassetteClientHeader* headers,
                                               gint headers_length1,
                                               GError** error);
static void cassette_client_soup_wrapper_get_async_data_free (gpointer _data);
VALA_EXTERN void cassette_client_soup_wrapper_get_async (CassetteClientSoupWrapper* self,
                                             gchar* uri,
                                             gchar** header_preset_names,
                                             gint header_preset_names_length1,
                                             gchar** parameters,
                                             gint parameters_length1,
                                             gint parameters_length2,
                                             CassetteClientHeader* headers,
                                             gint headers_length1,
                                             gint priority,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
VALA_EXTERN GBytes* cassette_client_soup_wrapper_get_finish (CassetteClientSoupWrapper* self,
                                                 GAsyncResult* _res_,
                                                 GError** error);
static gboolean cassette_client_soup_wrapper_get_async_co (CassetteClientSoupWrapperGetAsyncData* _data_);
static void cassette_client_soup_wrapper_get_async_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_);
VALA_EXTERN GBytes* cassette_client_soup_wrapper_post_sync (CassetteClientSoupWrapper* self,
                                                gchar* uri,
                                                gchar** header_preset_names,
                                                gint header_preset_names_length1,
                                                CassetteClientPostContent* post_content,
                                                gchar** parameters,
                                                gint parameters_length1,
                                                gint parameters_length2,
                                                CassetteClientHeader* headers,
                                                gint headers_length1,
                                                GError** error);
static void cassette_client_soup_wrapper_post_async_data_free (gpointer _data);
VALA_EXTERN void cassette_client_soup_wrapper_post_async (CassetteClientSoupWrapper* self,
                                              gchar* uri,
                                              gchar** header_preset_names,
                                              gint header_preset_names_length1,
                                              CassetteClientPostContent* post_content,
                                              gchar** parameters,
                                              gint parameters_length1,
                                              gint parameters_length2,
                                              CassetteClientHeader* headers,
                                              gint headers_length1,
                                              gint priority,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
VALA_EXTERN GBytes* cassette_client_soup_wrapper_post_finish (CassetteClientSoupWrapper* self,
                                                  GAsyncResult* _res_,
                                                  GError** error);
static gboolean cassette_client_soup_wrapper_post_async_co (CassetteClientSoupWrapperPostAsyncData* _data_);
static void cassette_client_soup_wrapper_post_async_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_);
static void cassette_client_soup_wrapper_set_user_agent (CassetteClientSoupWrapper* self,
                                                  const gchar* value);
VALA_EXTERN void cassette_client_soup_wrapper_set_cookies_file (CassetteClientSoupWrapper* self,
                                                    GFile* value);
static GObject * cassette_client_soup_wrapper_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties);
VALA_EXTERN GType cassette_client_log_level_get_type (void) G_GNUC_CONST ;
VALA_EXTERN CassetteClientLogLevel cassette_client_logger_get_log_level (void);
static void _cassette_client_soup_wrapper____lambda23_ (CassetteClientSoupWrapper* self,
                                                 SoupLogger* logger,
                                                 SoupLoggerLogLevel level,
                                                 gchar direction,
                                                 const gchar* data);
VALA_EXTERN void cassette_client_logger_net_in (SoupLoggerLogLevel soup_log_level,
                                    const gchar* data);
VALA_EXTERN void cassette_client_logger_net_out (SoupLoggerLogLevel soup_log_level,
                                     const gchar* data);
VALA_EXTERN void cassette_client_logger_time (void);
static void __cassette_client_soup_wrapper____lambda23__soup_logger_printer (SoupLogger* logger,
                                                                      SoupLoggerLogLevel level,
                                                                      gchar direction,
                                                                      const gchar* data,
                                                                      gpointer self);
static void cassette_client_soup_wrapper_finalize (GObject * obj);
static GType cassette_client_soup_wrapper_get_type_once (void);
static void _vala_cassette_client_soup_wrapper_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

GQuark
cassette_client_bad_status_code_error_quark (void)
{
#line 36 "../src/client/jsoner.vala"
	return g_quark_from_static_string ("cassette-client-bad-status-code-error-quark");
#line 546 "soup-wrapper.c"
}

 G_GNUC_NO_INLINE static GType
cassette_client_bad_status_code_error_get_type_once (void)
{
	static const GEnumValue values[] = {{CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR_BAD_REQUEST, "CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR_BAD_REQUEST", "bad-request"}, {CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR_NOT_FOUND, "CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR_NOT_FOUND", "not-found"}, {CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR_UNAUTHORIZE_ERROR, "CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR_UNAUTHORIZE_ERROR", "unauthorize-error"}, {CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR_UNKNOWN, "CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR_UNKNOWN", "unknown"}, {0, NULL, NULL}};
	GType cassette_client_bad_status_code_error_type_id;
	cassette_client_bad_status_code_error_type_id = g_enum_register_static ("CassetteClientBadStatusCodeError", values);
	return cassette_client_bad_status_code_error_type_id;
}

GType
cassette_client_bad_status_code_error_get_type (void)
{
	static gsize cassette_client_bad_status_code_error_type_id__once = 0;
	if (g_once_init_enter (&cassette_client_bad_status_code_error_type_id__once)) {
		GType cassette_client_bad_status_code_error_type_id;
		cassette_client_bad_status_code_error_type_id = cassette_client_bad_status_code_error_get_type_once ();
		g_once_init_leave (&cassette_client_bad_status_code_error_type_id__once, cassette_client_bad_status_code_error_type_id);
	}
	return cassette_client_bad_status_code_error_type_id__once;
}

void
cassette_client_header_copy (const CassetteClientHeader* self,
                             CassetteClientHeader* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 30 "../src/client/soup-wrapper.vala"
	_tmp0_ = (*self).name;
#line 30 "../src/client/soup-wrapper.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 30 "../src/client/soup-wrapper.vala"
	_g_free0 ((*dest).name);
#line 30 "../src/client/soup-wrapper.vala"
	(*dest).name = _tmp1_;
#line 30 "../src/client/soup-wrapper.vala"
	_tmp2_ = (*self).value;
#line 30 "../src/client/soup-wrapper.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 30 "../src/client/soup-wrapper.vala"
	_g_free0 ((*dest).value);
#line 30 "../src/client/soup-wrapper.vala"
	(*dest).value = _tmp3_;
#line 594 "soup-wrapper.c"
}

void
cassette_client_header_destroy (CassetteClientHeader* self)
{
#line 31 "../src/client/soup-wrapper.vala"
	_g_free0 ((*self).name);
#line 32 "../src/client/soup-wrapper.vala"
	_g_free0 ((*self).value);
#line 604 "soup-wrapper.c"
}

CassetteClientHeader*
cassette_client_header_dup (const CassetteClientHeader* self)
{
	CassetteClientHeader* dup;
#line 30 "../src/client/soup-wrapper.vala"
	dup = g_new0 (CassetteClientHeader, 1);
#line 30 "../src/client/soup-wrapper.vala"
	cassette_client_header_copy (self, dup);
#line 30 "../src/client/soup-wrapper.vala"
	return dup;
#line 617 "soup-wrapper.c"
}

void
cassette_client_header_free (CassetteClientHeader* self)
{
#line 30 "../src/client/soup-wrapper.vala"
	cassette_client_header_destroy (self);
#line 30 "../src/client/soup-wrapper.vala"
	g_free (self);
#line 627 "soup-wrapper.c"
}

 G_GNUC_NO_INLINE static GType
cassette_client_header_get_type_once (void)
{
	GType cassette_client_header_type_id;
	cassette_client_header_type_id = g_boxed_type_register_static ("CassetteClientHeader", (GBoxedCopyFunc) cassette_client_header_dup, (GBoxedFreeFunc) cassette_client_header_free);
	return cassette_client_header_type_id;
}

GType
cassette_client_header_get_type (void)
{
	static gsize cassette_client_header_type_id__once = 0;
	if (g_once_init_enter (&cassette_client_header_type_id__once)) {
		GType cassette_client_header_type_id;
		cassette_client_header_type_id = cassette_client_header_get_type_once ();
		g_once_init_leave (&cassette_client_header_type_id__once, cassette_client_header_type_id);
	}
	return cassette_client_header_type_id__once;
}

static inline gpointer
cassette_client_headers_get_instance_private (CassetteClientHeaders* self)
{
	return G_STRUCT_MEMBER_P (self, CassetteClientHeaders_private_offset);
}

static void
_vala_CassetteClientHeader_array_free (CassetteClientHeader * array,
                                       gssize array_length)
{
#line 36 "../src/client/soup-wrapper.vala"
	if (array != NULL) {
#line 662 "soup-wrapper.c"
		gssize i;
#line 36 "../src/client/soup-wrapper.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 36 "../src/client/soup-wrapper.vala"
			cassette_client_header_destroy (&array[i]);
#line 668 "soup-wrapper.c"
		}
	}
#line 36 "../src/client/soup-wrapper.vala"
	g_free (array);
#line 673 "soup-wrapper.c"
}

CassetteClientHeaders*
cassette_client_headers_construct (GType object_type)
{
	CassetteClientHeaders* self = NULL;
#line 38 "../src/client/soup-wrapper.vala"
	self = (CassetteClientHeaders*) g_type_create_instance (object_type);
#line 38 "../src/client/soup-wrapper.vala"
	return self;
#line 684 "soup-wrapper.c"
}

CassetteClientHeaders*
cassette_client_headers_new (void)
{
#line 38 "../src/client/soup-wrapper.vala"
	return cassette_client_headers_construct (CASSETTE_CLIENT_TYPE_HEADERS);
#line 692 "soup-wrapper.c"
}

void
cassette_client_headers_add (CassetteClientHeaders* self,
                             CassetteClientHeader* header)
{
	CassetteClientHeader* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_;
	CassetteClientHeader* _tmp2_;
	gint _tmp2__length1;
	CassetteClientHeader* _tmp3_;
	gint _tmp3__length1;
	CassetteClientHeader _tmp4_;
	CassetteClientHeader _tmp5_;
	CassetteClientHeader _tmp6_ = {0};
#line 40 "../src/client/soup-wrapper.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/client/soup-wrapper.vala"
	g_return_if_fail (header != NULL);
#line 41 "../src/client/soup-wrapper.vala"
	_tmp0_ = self->priv->headers_arr;
#line 41 "../src/client/soup-wrapper.vala"
	_tmp0__length1 = self->priv->headers_arr_length1;
#line 41 "../src/client/soup-wrapper.vala"
	_tmp1_ = _tmp0__length1 + 1;
#line 41 "../src/client/soup-wrapper.vala"
	self->priv->headers_arr = g_renew (CassetteClientHeader, self->priv->headers_arr, _tmp0__length1 + 1);
#line 41 "../src/client/soup-wrapper.vala"
	(_tmp1_ > self->priv->headers_arr_length1) ? memset (self->priv->headers_arr + self->priv->headers_arr_length1, 0, sizeof (CassetteClientHeader) * (_tmp1_ - self->priv->headers_arr_length1)) : NULL;
#line 41 "../src/client/soup-wrapper.vala"
	self->priv->headers_arr_length1 = _tmp1_;
#line 41 "../src/client/soup-wrapper.vala"
	self->priv->_headers_arr_size_ = _tmp1_;
#line 42 "../src/client/soup-wrapper.vala"
	_tmp2_ = self->priv->headers_arr;
#line 42 "../src/client/soup-wrapper.vala"
	_tmp2__length1 = self->priv->headers_arr_length1;
#line 42 "../src/client/soup-wrapper.vala"
	_tmp3_ = self->priv->headers_arr;
#line 42 "../src/client/soup-wrapper.vala"
	_tmp3__length1 = self->priv->headers_arr_length1;
#line 42 "../src/client/soup-wrapper.vala"
	_tmp4_ = *header;
#line 42 "../src/client/soup-wrapper.vala"
	_tmp5_ = _tmp4_;
#line 42 "../src/client/soup-wrapper.vala"
	cassette_client_header_copy (&_tmp5_, &_tmp6_);
#line 42 "../src/client/soup-wrapper.vala"
	cassette_client_header_destroy (&_tmp2_[_tmp3__length1 - 1]);
#line 42 "../src/client/soup-wrapper.vala"
	_tmp2_[_tmp3__length1 - 1] = _tmp6_;
#line 745 "soup-wrapper.c"
}

static CassetteClientHeader*
_vala_array_dup13 (CassetteClientHeader* self,
                   gssize length)
{
#line 46 "../src/client/soup-wrapper.vala"
	if (length > 0) {
#line 754 "soup-wrapper.c"
		CassetteClientHeader* result;
		gssize i;
#line 46 "../src/client/soup-wrapper.vala"
		result = g_new0 (CassetteClientHeader, length);
#line 46 "../src/client/soup-wrapper.vala"
		for (i = 0; i < length; i++) {
#line 761 "soup-wrapper.c"
			CassetteClientHeader _tmp0_;
			CassetteClientHeader _tmp1_ = {0};
#line 46 "../src/client/soup-wrapper.vala"
			_tmp0_ = self[i];
#line 46 "../src/client/soup-wrapper.vala"
			cassette_client_header_copy (&_tmp0_, &_tmp1_);
#line 46 "../src/client/soup-wrapper.vala"
			result[i] = _tmp1_;
#line 770 "soup-wrapper.c"
		}
#line 46 "../src/client/soup-wrapper.vala"
		return result;
#line 774 "soup-wrapper.c"
	}
#line 46 "../src/client/soup-wrapper.vala"
	return NULL;
#line 778 "soup-wrapper.c"
}

void
cassette_client_headers_set_headers (CassetteClientHeaders* self,
                                     CassetteClientHeader* headers_arr,
                                     gint headers_arr_length1)
{
	CassetteClientHeader* _tmp0_;
	gint _tmp0__length1;
#line 45 "../src/client/soup-wrapper.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/client/soup-wrapper.vala"
	_tmp0_ = (headers_arr != NULL) ? _vala_array_dup13 (headers_arr, headers_arr_length1) : headers_arr;
#line 46 "../src/client/soup-wrapper.vala"
	_tmp0__length1 = headers_arr_length1;
#line 46 "../src/client/soup-wrapper.vala"
	self->priv->headers_arr = (_vala_CassetteClientHeader_array_free (self->priv->headers_arr, self->priv->headers_arr_length1), NULL);
#line 46 "../src/client/soup-wrapper.vala"
	self->priv->headers_arr = _tmp0_;
#line 46 "../src/client/soup-wrapper.vala"
	self->priv->headers_arr_length1 = _tmp0__length1;
#line 46 "../src/client/soup-wrapper.vala"
	self->priv->_headers_arr_size_ = self->priv->headers_arr_length1;
#line 802 "soup-wrapper.c"
}

static CassetteClientHeader*
_vala_array_dup14 (CassetteClientHeader* self,
                   gssize length)
{
#line 50 "../src/client/soup-wrapper.vala"
	if (length > 0) {
#line 811 "soup-wrapper.c"
		CassetteClientHeader* result;
		gssize i;
#line 50 "../src/client/soup-wrapper.vala"
		result = g_new0 (CassetteClientHeader, length);
#line 50 "../src/client/soup-wrapper.vala"
		for (i = 0; i < length; i++) {
#line 818 "soup-wrapper.c"
			CassetteClientHeader _tmp0_;
			CassetteClientHeader _tmp1_ = {0};
#line 50 "../src/client/soup-wrapper.vala"
			_tmp0_ = self[i];
#line 50 "../src/client/soup-wrapper.vala"
			cassette_client_header_copy (&_tmp0_, &_tmp1_);
#line 50 "../src/client/soup-wrapper.vala"
			result[i] = _tmp1_;
#line 827 "soup-wrapper.c"
		}
#line 50 "../src/client/soup-wrapper.vala"
		return result;
#line 831 "soup-wrapper.c"
	}
#line 50 "../src/client/soup-wrapper.vala"
	return NULL;
#line 835 "soup-wrapper.c"
}

CassetteClientHeader*
cassette_client_headers_get_headers (CassetteClientHeaders* self,
                                     gint* result_length1)
{
	CassetteClientHeader* _tmp0_;
	gint _tmp0__length1;
	CassetteClientHeader* _tmp1_;
	gint _tmp1__length1;
	CassetteClientHeader* _tmp2_;
	gint _tmp2__length1;
	CassetteClientHeader* result;
#line 49 "../src/client/soup-wrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/client/soup-wrapper.vala"
	_tmp0_ = self->priv->headers_arr;
#line 50 "../src/client/soup-wrapper.vala"
	_tmp0__length1 = self->priv->headers_arr_length1;
#line 50 "../src/client/soup-wrapper.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup14 (_tmp0_, _tmp0__length1) : _tmp0_;
#line 50 "../src/client/soup-wrapper.vala"
	_tmp1__length1 = _tmp0__length1;
#line 50 "../src/client/soup-wrapper.vala"
	_tmp2_ = _tmp1_;
#line 50 "../src/client/soup-wrapper.vala"
	_tmp2__length1 = _tmp1__length1;
#line 50 "../src/client/soup-wrapper.vala"
	if (result_length1) {
#line 50 "../src/client/soup-wrapper.vala"
		*result_length1 = _tmp2__length1;
#line 867 "soup-wrapper.c"
	}
#line 50 "../src/client/soup-wrapper.vala"
	result = _tmp2_;
#line 50 "../src/client/soup-wrapper.vala"
	return result;
#line 873 "soup-wrapper.c"
}

static void
cassette_client_value_headers_init (GValue* value)
{
#line 35 "../src/client/soup-wrapper.vala"
	value->data[0].v_pointer = NULL;
#line 881 "soup-wrapper.c"
}

static void
cassette_client_value_headers_free_value (GValue* value)
{
#line 35 "../src/client/soup-wrapper.vala"
	if (value->data[0].v_pointer) {
#line 35 "../src/client/soup-wrapper.vala"
		cassette_client_headers_unref (value->data[0].v_pointer);
#line 891 "soup-wrapper.c"
	}
}

static void
cassette_client_value_headers_copy_value (const GValue* src_value,
                                          GValue* dest_value)
{
#line 35 "../src/client/soup-wrapper.vala"
	if (src_value->data[0].v_pointer) {
#line 35 "../src/client/soup-wrapper.vala"
		dest_value->data[0].v_pointer = cassette_client_headers_ref (src_value->data[0].v_pointer);
#line 903 "soup-wrapper.c"
	} else {
#line 35 "../src/client/soup-wrapper.vala"
		dest_value->data[0].v_pointer = NULL;
#line 907 "soup-wrapper.c"
	}
}

static gpointer
cassette_client_value_headers_peek_pointer (const GValue* value)
{
#line 35 "../src/client/soup-wrapper.vala"
	return value->data[0].v_pointer;
#line 916 "soup-wrapper.c"
}

static gchar*
cassette_client_value_headers_collect_value (GValue* value,
                                             guint n_collect_values,
                                             GTypeCValue* collect_values,
                                             guint collect_flags)
{
#line 35 "../src/client/soup-wrapper.vala"
	if (collect_values[0].v_pointer) {
#line 927 "soup-wrapper.c"
		CassetteClientHeaders * object;
		object = collect_values[0].v_pointer;
#line 35 "../src/client/soup-wrapper.vala"
		if (object->parent_instance.g_class == NULL) {
#line 35 "../src/client/soup-wrapper.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 934 "soup-wrapper.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 35 "../src/client/soup-wrapper.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 938 "soup-wrapper.c"
		}
#line 35 "../src/client/soup-wrapper.vala"
		value->data[0].v_pointer = cassette_client_headers_ref (object);
#line 942 "soup-wrapper.c"
	} else {
#line 35 "../src/client/soup-wrapper.vala"
		value->data[0].v_pointer = NULL;
#line 946 "soup-wrapper.c"
	}
#line 35 "../src/client/soup-wrapper.vala"
	return NULL;
#line 950 "soup-wrapper.c"
}

static gchar*
cassette_client_value_headers_lcopy_value (const GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
	CassetteClientHeaders ** object_p;
	object_p = collect_values[0].v_pointer;
#line 35 "../src/client/soup-wrapper.vala"
	if (!object_p) {
#line 35 "../src/client/soup-wrapper.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 965 "soup-wrapper.c"
	}
#line 35 "../src/client/soup-wrapper.vala"
	if (!value->data[0].v_pointer) {
#line 35 "../src/client/soup-wrapper.vala"
		*object_p = NULL;
#line 971 "soup-wrapper.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 35 "../src/client/soup-wrapper.vala"
		*object_p = value->data[0].v_pointer;
#line 975 "soup-wrapper.c"
	} else {
#line 35 "../src/client/soup-wrapper.vala"
		*object_p = cassette_client_headers_ref (value->data[0].v_pointer);
#line 979 "soup-wrapper.c"
	}
#line 35 "../src/client/soup-wrapper.vala"
	return NULL;
#line 983 "soup-wrapper.c"
}

GParamSpec*
cassette_client_param_spec_headers (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags)
{
	CassetteClientParamSpecHeaders* spec;
#line 35 "../src/client/soup-wrapper.vala"
	g_return_val_if_fail (g_type_is_a (object_type, CASSETTE_CLIENT_TYPE_HEADERS), NULL);
#line 35 "../src/client/soup-wrapper.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 35 "../src/client/soup-wrapper.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 35 "../src/client/soup-wrapper.vala"
	return G_PARAM_SPEC (spec);
#line 1002 "soup-wrapper.c"
}

gpointer
cassette_client_value_get_headers (const GValue* value)
{
#line 35 "../src/client/soup-wrapper.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CASSETTE_CLIENT_TYPE_HEADERS), NULL);
#line 35 "../src/client/soup-wrapper.vala"
	return value->data[0].v_pointer;
#line 1012 "soup-wrapper.c"
}

void
cassette_client_value_set_headers (GValue* value,
                                   gpointer v_object)
{
	CassetteClientHeaders * old;
#line 35 "../src/client/soup-wrapper.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CASSETTE_CLIENT_TYPE_HEADERS));
#line 35 "../src/client/soup-wrapper.vala"
	old = value->data[0].v_pointer;
#line 35 "../src/client/soup-wrapper.vala"
	if (v_object) {
#line 35 "../src/client/soup-wrapper.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, CASSETTE_CLIENT_TYPE_HEADERS));
#line 35 "../src/client/soup-wrapper.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 35 "../src/client/soup-wrapper.vala"
		value->data[0].v_pointer = v_object;
#line 35 "../src/client/soup-wrapper.vala"
		cassette_client_headers_ref (value->data[0].v_pointer);
#line 1034 "soup-wrapper.c"
	} else {
#line 35 "../src/client/soup-wrapper.vala"
		value->data[0].v_pointer = NULL;
#line 1038 "soup-wrapper.c"
	}
#line 35 "../src/client/soup-wrapper.vala"
	if (old) {
#line 35 "../src/client/soup-wrapper.vala"
		cassette_client_headers_unref (old);
#line 1044 "soup-wrapper.c"
	}
}

void
cassette_client_value_take_headers (GValue* value,
                                    gpointer v_object)
{
	CassetteClientHeaders * old;
#line 35 "../src/client/soup-wrapper.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CASSETTE_CLIENT_TYPE_HEADERS));
#line 35 "../src/client/soup-wrapper.vala"
	old = value->data[0].v_pointer;
#line 35 "../src/client/soup-wrapper.vala"
	if (v_object) {
#line 35 "../src/client/soup-wrapper.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, CASSETTE_CLIENT_TYPE_HEADERS));
#line 35 "../src/client/soup-wrapper.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 35 "../src/client/soup-wrapper.vala"
		value->data[0].v_pointer = v_object;
#line 1065 "soup-wrapper.c"
	} else {
#line 35 "../src/client/soup-wrapper.vala"
		value->data[0].v_pointer = NULL;
#line 1069 "soup-wrapper.c"
	}
#line 35 "../src/client/soup-wrapper.vala"
	if (old) {
#line 35 "../src/client/soup-wrapper.vala"
		cassette_client_headers_unref (old);
#line 1075 "soup-wrapper.c"
	}
}

static void
cassette_client_headers_class_init (CassetteClientHeadersClass * klass,
                                    gpointer klass_data)
{
#line 35 "../src/client/soup-wrapper.vala"
	cassette_client_headers_parent_class = g_type_class_peek_parent (klass);
#line 35 "../src/client/soup-wrapper.vala"
	((CassetteClientHeadersClass *) klass)->finalize = cassette_client_headers_finalize;
#line 35 "../src/client/soup-wrapper.vala"
	g_type_class_adjust_private_offset (klass, &CassetteClientHeaders_private_offset);
#line 1089 "soup-wrapper.c"
}

static void
cassette_client_headers_instance_init (CassetteClientHeaders * self,
                                       gpointer klass)
{
	CassetteClientHeader* _tmp0_;
#line 35 "../src/client/soup-wrapper.vala"
	self->priv = cassette_client_headers_get_instance_private (self);
#line 36 "../src/client/soup-wrapper.vala"
	_tmp0_ = g_new0 (CassetteClientHeader, 0);
#line 36 "../src/client/soup-wrapper.vala"
	self->priv->headers_arr = _tmp0_;
#line 36 "../src/client/soup-wrapper.vala"
	self->priv->headers_arr_length1 = 0;
#line 36 "../src/client/soup-wrapper.vala"
	self->priv->_headers_arr_size_ = self->priv->headers_arr_length1;
#line 35 "../src/client/soup-wrapper.vala"
	self->ref_count = 1;
#line 1109 "soup-wrapper.c"
}

static void
cassette_client_headers_finalize (CassetteClientHeaders * obj)
{
	CassetteClientHeaders * self;
#line 35 "../src/client/soup-wrapper.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CASSETTE_CLIENT_TYPE_HEADERS, CassetteClientHeaders);
#line 35 "../src/client/soup-wrapper.vala"
	g_signal_handlers_destroy (self);
#line 36 "../src/client/soup-wrapper.vala"
	self->priv->headers_arr = (_vala_CassetteClientHeader_array_free (self->priv->headers_arr, self->priv->headers_arr_length1), NULL);
#line 1122 "soup-wrapper.c"
}

 G_GNUC_NO_INLINE static GType
cassette_client_headers_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { cassette_client_value_headers_init, cassette_client_value_headers_free_value, cassette_client_value_headers_copy_value, cassette_client_value_headers_peek_pointer, "p", cassette_client_value_headers_collect_value, "p", cassette_client_value_headers_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (CassetteClientHeadersClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cassette_client_headers_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CassetteClientHeaders), 0, (GInstanceInitFunc) cassette_client_headers_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType cassette_client_headers_type_id;
	cassette_client_headers_type_id = g_type_register_fundamental (g_type_fundamental_next (), "CassetteClientHeaders", &g_define_type_info, &g_define_type_fundamental_info, 0);
	CassetteClientHeaders_private_offset = g_type_add_instance_private (cassette_client_headers_type_id, sizeof (CassetteClientHeadersPrivate));
	return cassette_client_headers_type_id;
}

GType
cassette_client_headers_get_type (void)
{
	static gsize cassette_client_headers_type_id__once = 0;
	if (g_once_init_enter (&cassette_client_headers_type_id__once)) {
		GType cassette_client_headers_type_id;
		cassette_client_headers_type_id = cassette_client_headers_get_type_once ();
		g_once_init_leave (&cassette_client_headers_type_id__once, cassette_client_headers_type_id);
	}
	return cassette_client_headers_type_id__once;
}

gpointer
cassette_client_headers_ref (gpointer instance)
{
	CassetteClientHeaders * self;
	self = instance;
#line 35 "../src/client/soup-wrapper.vala"
	g_atomic_int_inc (&self->ref_count);
#line 35 "../src/client/soup-wrapper.vala"
	return instance;
#line 1158 "soup-wrapper.c"
}

void
cassette_client_headers_unref (gpointer instance)
{
	CassetteClientHeaders * self;
	self = instance;
#line 35 "../src/client/soup-wrapper.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 35 "../src/client/soup-wrapper.vala"
		CASSETTE_CLIENT_HEADERS_GET_CLASS (self)->finalize (self);
#line 35 "../src/client/soup-wrapper.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1172 "soup-wrapper.c"
	}
}

 G_GNUC_NO_INLINE static GType
cassette_client_post_content_type_get_type_once (void)
{
	static const GEnumValue values[] = {{CASSETTE_CLIENT_POST_CONTENT_TYPE_X_WWW_FORM_URLENCODED, "CASSETTE_CLIENT_POST_CONTENT_TYPE_X_WWW_FORM_URLENCODED", "x-www-form-urlencoded"}, {CASSETTE_CLIENT_POST_CONTENT_TYPE_JSON, "CASSETTE_CLIENT_POST_CONTENT_TYPE_JSON", "json"}, {0, NULL, NULL}};
	GType cassette_client_post_content_type_type_id;
	cassette_client_post_content_type_type_id = g_enum_register_static ("CassetteClientPostContentType", values);
	return cassette_client_post_content_type_type_id;
}

GType
cassette_client_post_content_type_get_type (void)
{
	static gsize cassette_client_post_content_type_type_id__once = 0;
	if (g_once_init_enter (&cassette_client_post_content_type_type_id__once)) {
		GType cassette_client_post_content_type_type_id;
		cassette_client_post_content_type_type_id = cassette_client_post_content_type_get_type_once ();
		g_once_init_leave (&cassette_client_post_content_type_type_id__once, cassette_client_post_content_type_type_id);
	}
	return cassette_client_post_content_type_type_id__once;
}

gchar*
cassette_client_post_content_get_content_type_string (CassetteClientPostContent *self)
{
	gchar* result;
#line 64 "../src/client/soup-wrapper.vala"
	switch ((*self).content_type) {
#line 64 "../src/client/soup-wrapper.vala"
		case CASSETTE_CLIENT_POST_CONTENT_TYPE_X_WWW_FORM_URLENCODED:
#line 1205 "soup-wrapper.c"
		{
			gchar* _tmp0_;
#line 66 "../src/client/soup-wrapper.vala"
			_tmp0_ = g_strdup ("application/x-www-form-urlencoded");
#line 66 "../src/client/soup-wrapper.vala"
			result = _tmp0_;
#line 66 "../src/client/soup-wrapper.vala"
			return result;
#line 1214 "soup-wrapper.c"
		}
#line 64 "../src/client/soup-wrapper.vala"
		case CASSETTE_CLIENT_POST_CONTENT_TYPE_JSON:
#line 1218 "soup-wrapper.c"
		{
			gchar* _tmp1_;
#line 68 "../src/client/soup-wrapper.vala"
			_tmp1_ = g_strdup ("application/json");
#line 68 "../src/client/soup-wrapper.vala"
			result = _tmp1_;
#line 68 "../src/client/soup-wrapper.vala"
			return result;
#line 1227 "soup-wrapper.c"
		}
		default:
		{
#line 70 "../src/client/soup-wrapper.vala"
			g_assert_not_reached ();
#line 1233 "soup-wrapper.c"
		}
	}
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 1272 "soup-wrapper.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 1278 "soup-wrapper.c"
}

GBytes*
cassette_client_post_content_get_bytes (CassetteClientPostContent *self)
{
	const gchar* _tmp0_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	gint _tmp2_ = 0;
	guint8* _tmp3_;
	gint _tmp3__length1;
	GBytes* _tmp4_;
	GBytes* result;
#line 75 "../src/client/soup-wrapper.vala"
	_tmp0_ = (*self).content;
#line 75 "../src/client/soup-wrapper.vala"
	_tmp1_ = string_get_data (_tmp0_, &_tmp2_);
#line 75 "../src/client/soup-wrapper.vala"
	_tmp1__length1 = _tmp2_;
#line 75 "../src/client/soup-wrapper.vala"
	_tmp3_ = _tmp1_;
#line 75 "../src/client/soup-wrapper.vala"
	_tmp3__length1 = _tmp1__length1;
#line 75 "../src/client/soup-wrapper.vala"
	_tmp4_ = g_bytes_new (_tmp3_, _tmp3__length1);
#line 75 "../src/client/soup-wrapper.vala"
	result = _tmp4_;
#line 75 "../src/client/soup-wrapper.vala"
	return result;
#line 1308 "soup-wrapper.c"
}

void
cassette_client_post_content_set_datalist (CassetteClientPostContent *self,
                                           GData** datalist)
{
#line 78 "../src/client/soup-wrapper.vala"
	g_return_if_fail (datalist != NULL);
#line 79 "../src/client/soup-wrapper.vala"
	switch ((*self).content_type) {
#line 79 "../src/client/soup-wrapper.vala"
		case CASSETTE_CLIENT_POST_CONTENT_TYPE_X_WWW_FORM_URLENCODED:
#line 1321 "soup-wrapper.c"
		{
			GData* _tmp0_;
			gchar* _tmp1_;
#line 81 "../src/client/soup-wrapper.vala"
			_tmp0_ = *datalist;
#line 81 "../src/client/soup-wrapper.vala"
			_tmp1_ = soup_form_encode_datalist (&_tmp0_);
#line 81 "../src/client/soup-wrapper.vala"
			_g_free0 ((*self).content);
#line 81 "../src/client/soup-wrapper.vala"
			(*self).content = _tmp1_;
#line 82 "../src/client/soup-wrapper.vala"
			break;
#line 1335 "soup-wrapper.c"
		}
#line 79 "../src/client/soup-wrapper.vala"
		case CASSETTE_CLIENT_POST_CONTENT_TYPE_JSON:
#line 1339 "soup-wrapper.c"
		{
			GData* _tmp2_;
			gchar* _tmp3_;
#line 84 "../src/client/soup-wrapper.vala"
			_tmp2_ = *datalist;
#line 84 "../src/client/soup-wrapper.vala"
			_tmp3_ = cassette_client_jsoner_serialize_datalist (&_tmp2_);
#line 84 "../src/client/soup-wrapper.vala"
			_g_free0 ((*self).content);
#line 84 "../src/client/soup-wrapper.vala"
			(*self).content = _tmp3_;
#line 85 "../src/client/soup-wrapper.vala"
			break;
#line 1353 "soup-wrapper.c"
		}
		default:
		{
#line 87 "../src/client/soup-wrapper.vala"
			g_assert_not_reached ();
#line 1359 "soup-wrapper.c"
		}
	}
}

void
cassette_client_post_content_copy (const CassetteClientPostContent* self,
                                   CassetteClientPostContent* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 59 "../src/client/soup-wrapper.vala"
	(*dest).content_type = (*self).content_type;
#line 59 "../src/client/soup-wrapper.vala"
	_tmp0_ = (*self).content;
#line 59 "../src/client/soup-wrapper.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 59 "../src/client/soup-wrapper.vala"
	_g_free0 ((*dest).content);
#line 59 "../src/client/soup-wrapper.vala"
	(*dest).content = _tmp1_;
#line 1380 "soup-wrapper.c"
}

void
cassette_client_post_content_destroy (CassetteClientPostContent* self)
{
#line 61 "../src/client/soup-wrapper.vala"
	_g_free0 ((*self).content);
#line 1388 "soup-wrapper.c"
}

CassetteClientPostContent*
cassette_client_post_content_dup (const CassetteClientPostContent* self)
{
	CassetteClientPostContent* dup;
#line 59 "../src/client/soup-wrapper.vala"
	dup = g_new0 (CassetteClientPostContent, 1);
#line 59 "../src/client/soup-wrapper.vala"
	cassette_client_post_content_copy (self, dup);
#line 59 "../src/client/soup-wrapper.vala"
	return dup;
#line 1401 "soup-wrapper.c"
}

void
cassette_client_post_content_free (CassetteClientPostContent* self)
{
#line 59 "../src/client/soup-wrapper.vala"
	cassette_client_post_content_destroy (self);
#line 59 "../src/client/soup-wrapper.vala"
	g_free (self);
#line 1411 "soup-wrapper.c"
}

 G_GNUC_NO_INLINE static GType
cassette_client_post_content_get_type_once (void)
{
	GType cassette_client_post_content_type_id;
	cassette_client_post_content_type_id = g_boxed_type_register_static ("CassetteClientPostContent", (GBoxedCopyFunc) cassette_client_post_content_dup, (GBoxedFreeFunc) cassette_client_post_content_free);
	return cassette_client_post_content_type_id;
}

GType
cassette_client_post_content_get_type (void)
{
	static gsize cassette_client_post_content_type_id__once = 0;
	if (g_once_init_enter (&cassette_client_post_content_type_id__once)) {
		GType cassette_client_post_content_type_id;
		cassette_client_post_content_type_id = cassette_client_post_content_get_type_once ();
		g_once_init_leave (&cassette_client_post_content_type_id__once, cassette_client_post_content_type_id);
	}
	return cassette_client_post_content_type_id__once;
}

static inline gpointer
cassette_client_soup_wrapper_get_instance_private (CassetteClientSoupWrapper* self)
{
	return G_STRUCT_MEMBER_P (self, CassetteClientSoupWrapper_private_offset);
}

CassetteClientSoupWrapper*
cassette_client_soup_wrapper_construct (GType object_type,
                                        const gchar* user_agent,
                                        GFile* cookies_file)
{
	CassetteClientSoupWrapper * self = NULL;
#line 118 "../src/client/soup-wrapper.vala"
	self = (CassetteClientSoupWrapper*) g_object_new (object_type, "user-agent", user_agent, "cookies-file", cookies_file, NULL);
#line 117 "../src/client/soup-wrapper.vala"
	return self;
#line 1450 "soup-wrapper.c"
}

CassetteClientSoupWrapper*
cassette_client_soup_wrapper_new (const gchar* user_agent,
                                  GFile* cookies_file)
{
#line 117 "../src/client/soup-wrapper.vala"
	return cassette_client_soup_wrapper_construct (CASSETTE_CLIENT_TYPE_SOUP_WRAPPER, user_agent, cookies_file);
#line 1459 "soup-wrapper.c"
}

void
cassette_client_soup_wrapper_reload_cookies (CassetteClientSoupWrapper* self,
                                             GFile* cookies_file)
{
	SoupSession* _tmp0_;
	SoupCookieJarDB* cookie_jar = NULL;
	const gchar* _tmp2_;
	SoupCookieJarDB* _tmp3_;
	SoupSession* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 141 "../src/client/soup-wrapper.vala"
	g_return_if_fail (self != NULL);
#line 141 "../src/client/soup-wrapper.vala"
	g_return_if_fail (cookies_file != NULL);
#line 142 "../src/client/soup-wrapper.vala"
	_tmp0_ = self->priv->session;
#line 142 "../src/client/soup-wrapper.vala"
	if (soup_session_has_feature (_tmp0_, soup_cookie_jar_db_get_type ())) {
#line 1482 "soup-wrapper.c"
		SoupSession* _tmp1_;
#line 143 "../src/client/soup-wrapper.vala"
		_tmp1_ = self->priv->session;
#line 143 "../src/client/soup-wrapper.vala"
		soup_session_remove_feature_by_type (_tmp1_, soup_cookie_jar_db_get_type ());
#line 1488 "soup-wrapper.c"
	}
#line 146 "../src/client/soup-wrapper.vala"
	_tmp2_ = g_file_peek_path (cookies_file);
#line 146 "../src/client/soup-wrapper.vala"
	_tmp3_ = (SoupCookieJarDB*) soup_cookie_jar_db_new (_tmp2_, TRUE);
#line 146 "../src/client/soup-wrapper.vala"
	cookie_jar = _tmp3_;
#line 147 "../src/client/soup-wrapper.vala"
	_tmp4_ = self->priv->session;
#line 147 "../src/client/soup-wrapper.vala"
	soup_session_add_feature (_tmp4_, (SoupSessionFeature*) cookie_jar);
#line 149 "../src/client/soup-wrapper.vala"
	_tmp5_ = g_file_peek_path (cookies_file);
#line 149 "../src/client/soup-wrapper.vala"
	_tmp6_ = g_strdup_printf ("Cookies was reloaded. New cookiess file %s", _tmp5_);
#line 149 "../src/client/soup-wrapper.vala"
	_tmp7_ = _tmp6_;
#line 149 "../src/client/soup-wrapper.vala"
	cassette_client_logger_debug (_tmp7_);
#line 149 "../src/client/soup-wrapper.vala"
	_g_free0 (_tmp7_);
#line 141 "../src/client/soup-wrapper.vala"
	_g_object_unref0 (cookie_jar);
#line 1512 "soup-wrapper.c"
}

void
cassette_client_soup_wrapper_add_headers_preset (CassetteClientSoupWrapper* self,
                                                 const gchar* preset_name,
                                                 CassetteClientHeader* headers_arr,
                                                 gint headers_arr_length1)
{
	CassetteClientHeaders* headers = NULL;
	CassetteClientHeaders* _tmp0_;
	GeeHashMap* _tmp1_;
#line 154 "../src/client/soup-wrapper.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/client/soup-wrapper.vala"
	g_return_if_fail (preset_name != NULL);
#line 155 "../src/client/soup-wrapper.vala"
	_tmp0_ = cassette_client_headers_new ();
#line 155 "../src/client/soup-wrapper.vala"
	headers = _tmp0_;
#line 156 "../src/client/soup-wrapper.vala"
	cassette_client_headers_set_headers (headers, headers_arr, (gint) headers_arr_length1);
#line 157 "../src/client/soup-wrapper.vala"
	_tmp1_ = self->priv->presets_table;
#line 157 "../src/client/soup-wrapper.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, preset_name, headers);
#line 154 "../src/client/soup-wrapper.vala"
	_cassette_client_headers_unref0 (headers);
#line 1540 "soup-wrapper.c"
}

static void
cassette_client_soup_wrapper_append_headers_with_preset_to (CassetteClientSoupWrapper* self,
                                                            SoupMessage* msg,
                                                            const gchar* preset_name)
{
	CassetteClientHeaders* headers = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	CassetteClientHeaders* _tmp2_;
#line 160 "../src/client/soup-wrapper.vala"
	g_return_if_fail (self != NULL);
#line 160 "../src/client/soup-wrapper.vala"
	g_return_if_fail (msg != NULL);
#line 160 "../src/client/soup-wrapper.vala"
	g_return_if_fail (preset_name != NULL);
#line 161 "../src/client/soup-wrapper.vala"
	_tmp0_ = self->priv->presets_table;
#line 161 "../src/client/soup-wrapper.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, preset_name);
#line 161 "../src/client/soup-wrapper.vala"
	headers = (CassetteClientHeaders*) _tmp1_;
#line 162 "../src/client/soup-wrapper.vala"
	_tmp2_ = headers;
#line 162 "../src/client/soup-wrapper.vala"
	if (_tmp2_ != NULL) {
#line 1568 "soup-wrapper.c"
		CassetteClientHeaders* _tmp3_;
		gint _tmp4_ = 0;
		CassetteClientHeader* _tmp5_;
		CassetteClientHeader* _tmp6_;
		gint _tmp6__length1;
#line 163 "../src/client/soup-wrapper.vala"
		_tmp3_ = headers;
#line 163 "../src/client/soup-wrapper.vala"
		_tmp5_ = cassette_client_headers_get_headers (_tmp3_, &_tmp4_);
#line 163 "../src/client/soup-wrapper.vala"
		_tmp6_ = _tmp5_;
#line 163 "../src/client/soup-wrapper.vala"
		_tmp6__length1 = _tmp4_;
#line 163 "../src/client/soup-wrapper.vala"
		cassette_client_soup_wrapper_append_headers_to (self, msg, _tmp6_, (gint) _tmp4_);
#line 163 "../src/client/soup-wrapper.vala"
		_tmp6_ = (_vala_CassetteClientHeader_array_free (_tmp6_, _tmp6__length1), NULL);
#line 1586 "soup-wrapper.c"
	}
#line 160 "../src/client/soup-wrapper.vala"
	_cassette_client_headers_unref0 (headers);
#line 1590 "soup-wrapper.c"
}

static void
cassette_client_soup_wrapper_append_headers_to (CassetteClientSoupWrapper* self,
                                                SoupMessage* msg,
                                                CassetteClientHeader* headers_arr,
                                                gint headers_arr_length1)
{
#line 167 "../src/client/soup-wrapper.vala"
	g_return_if_fail (self != NULL);
#line 167 "../src/client/soup-wrapper.vala"
	g_return_if_fail (msg != NULL);
#line 1603 "soup-wrapper.c"
	{
		CassetteClientHeader* header_collection = NULL;
		gint header_collection_length1 = 0;
		gint _header_collection_size_ = 0;
		gint header_it = 0;
#line 168 "../src/client/soup-wrapper.vala"
		header_collection = headers_arr;
#line 168 "../src/client/soup-wrapper.vala"
		header_collection_length1 = headers_arr_length1;
#line 168 "../src/client/soup-wrapper.vala"
		for (header_it = 0; header_it < header_collection_length1; header_it = header_it + 1) {
#line 1615 "soup-wrapper.c"
			CassetteClientHeader _tmp0_;
			CassetteClientHeader _tmp1_ = {0};
			CassetteClientHeader header = {0};
#line 168 "../src/client/soup-wrapper.vala"
			_tmp0_ = header_collection[header_it];
#line 168 "../src/client/soup-wrapper.vala"
			cassette_client_header_copy (&_tmp0_, &_tmp1_);
#line 168 "../src/client/soup-wrapper.vala"
			header = _tmp1_;
#line 1625 "soup-wrapper.c"
			{
				SoupMessageHeaders* _tmp2_;
				SoupMessageHeaders* _tmp3_;
				CassetteClientHeader _tmp4_;
				const gchar* _tmp5_;
				CassetteClientHeader _tmp6_;
				const gchar* _tmp7_;
#line 169 "../src/client/soup-wrapper.vala"
				_tmp2_ = soup_message_get_request_headers (msg);
#line 169 "../src/client/soup-wrapper.vala"
				_tmp3_ = _tmp2_;
#line 169 "../src/client/soup-wrapper.vala"
				_tmp4_ = header;
#line 169 "../src/client/soup-wrapper.vala"
				_tmp5_ = _tmp4_.name;
#line 169 "../src/client/soup-wrapper.vala"
				_tmp6_ = header;
#line 169 "../src/client/soup-wrapper.vala"
				_tmp7_ = _tmp6_.value;
#line 169 "../src/client/soup-wrapper.vala"
				soup_message_headers_append (_tmp3_, _tmp5_, _tmp7_);
#line 168 "../src/client/soup-wrapper.vala"
				cassette_client_header_destroy (&header);
#line 1649 "soup-wrapper.c"
			}
		}
	}
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 1666 "soup-wrapper.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 1670 "soup-wrapper.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 1676 "soup-wrapper.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 1681 "soup-wrapper.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 1687 "soup-wrapper.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 1691 "soup-wrapper.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 1695 "soup-wrapper.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 1699 "soup-wrapper.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1703 "soup-wrapper.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1707 "soup-wrapper.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 1722 "soup-wrapper.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 1731 "soup-wrapper.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 1738 "soup-wrapper.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 1744 "soup-wrapper.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 1752 "soup-wrapper.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 1756 "soup-wrapper.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 1762 "soup-wrapper.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 1767 "soup-wrapper.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 1773 "soup-wrapper.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 1777 "soup-wrapper.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 1781 "soup-wrapper.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 1787 "soup-wrapper.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 1793 "soup-wrapper.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 1805 "soup-wrapper.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 1809 "soup-wrapper.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 1813 "soup-wrapper.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 1818 "soup-wrapper.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 1826 "soup-wrapper.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 1844 "soup-wrapper.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 1850 "soup-wrapper.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 1854 "soup-wrapper.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 1862 "soup-wrapper.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 1871 "soup-wrapper.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 1880 "soup-wrapper.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 1886 "soup-wrapper.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 1894 "soup-wrapper.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 1906 "soup-wrapper.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 1912 "soup-wrapper.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 1916 "soup-wrapper.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 1924 "soup-wrapper.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 1935 "soup-wrapper.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 1944 "soup-wrapper.c"
	}
}

static void
cassette_client_soup_wrapper_add_params_to_uri (CassetteClientSoupWrapper* self,
                                                gchar** parameters,
                                                gint parameters_length1,
                                                gint parameters_length2,
                                                gchar** uri)
{
	gchar** parameters_pairs = NULL;
	gint _tmp0_;
	gchar** _tmp1_;
	gint parameters_pairs_length1;
	gint _parameters_pairs_size_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
#line 173 "../src/client/soup-wrapper.vala"
	g_return_if_fail (self != NULL);
#line 173 "../src/client/soup-wrapper.vala"
	g_return_if_fail (*uri != NULL);
#line 174 "../src/client/soup-wrapper.vala"
	_tmp0_ = parameters_length1;
#line 174 "../src/client/soup-wrapper.vala"
	_tmp1_ = g_new0 (gchar*, _tmp0_ + 1);
#line 174 "../src/client/soup-wrapper.vala"
	parameters_pairs = _tmp1_;
#line 174 "../src/client/soup-wrapper.vala"
	parameters_pairs_length1 = _tmp0_;
#line 174 "../src/client/soup-wrapper.vala"
	_parameters_pairs_size_ = parameters_pairs_length1;
#line 1981 "soup-wrapper.c"
	{
		gint i = 0;
#line 175 "../src/client/soup-wrapper.vala"
		i = 0;
#line 1986 "soup-wrapper.c"
		{
			gboolean _tmp2_ = FALSE;
#line 175 "../src/client/soup-wrapper.vala"
			_tmp2_ = TRUE;
#line 175 "../src/client/soup-wrapper.vala"
			while (TRUE) {
#line 1993 "soup-wrapper.c"
				gint _tmp4_;
				gchar** _tmp5_;
				gint _tmp5__length1;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				const gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
#line 175 "../src/client/soup-wrapper.vala"
				if (!_tmp2_) {
#line 2006 "soup-wrapper.c"
					gint _tmp3_;
#line 175 "../src/client/soup-wrapper.vala"
					_tmp3_ = i;
#line 175 "../src/client/soup-wrapper.vala"
					i = _tmp3_ + 1;
#line 2012 "soup-wrapper.c"
				}
#line 175 "../src/client/soup-wrapper.vala"
				_tmp2_ = FALSE;
#line 175 "../src/client/soup-wrapper.vala"
				_tmp4_ = parameters_length1;
#line 175 "../src/client/soup-wrapper.vala"
				if (!(i < _tmp4_)) {
#line 175 "../src/client/soup-wrapper.vala"
					break;
#line 2022 "soup-wrapper.c"
				}
#line 176 "../src/client/soup-wrapper.vala"
				_tmp5_ = parameters_pairs;
#line 176 "../src/client/soup-wrapper.vala"
				_tmp5__length1 = parameters_pairs_length1;
#line 176 "../src/client/soup-wrapper.vala"
				_tmp6_ = parameters[(i * parameters_length2) + 0];
#line 176 "../src/client/soup-wrapper.vala"
				_tmp7_ = g_strconcat (_tmp6_, "=", NULL);
#line 176 "../src/client/soup-wrapper.vala"
				_tmp8_ = _tmp7_;
#line 176 "../src/client/soup-wrapper.vala"
				_tmp9_ = parameters[(i * parameters_length2) + 1];
#line 176 "../src/client/soup-wrapper.vala"
				_tmp10_ = g_uri_escape_string (_tmp9_, NULL, TRUE);
#line 176 "../src/client/soup-wrapper.vala"
				_tmp11_ = _tmp10_;
#line 176 "../src/client/soup-wrapper.vala"
				_tmp12_ = g_strconcat (_tmp8_, _tmp11_, NULL);
#line 176 "../src/client/soup-wrapper.vala"
				_g_free0 (_tmp5_[i]);
#line 176 "../src/client/soup-wrapper.vala"
				_tmp5_[i] = _tmp12_;
#line 176 "../src/client/soup-wrapper.vala"
				_g_free0 (_tmp11_);
#line 176 "../src/client/soup-wrapper.vala"
				_g_free0 (_tmp8_);
#line 2050 "soup-wrapper.c"
			}
		}
	}
#line 178 "../src/client/soup-wrapper.vala"
	_tmp13_ = parameters_pairs;
#line 178 "../src/client/soup-wrapper.vala"
	_tmp13__length1 = parameters_pairs_length1;
#line 178 "../src/client/soup-wrapper.vala"
	_tmp14_ = _vala_g_strjoinv ("&", _tmp13_, (gint) _tmp13__length1);
#line 178 "../src/client/soup-wrapper.vala"
	_tmp15_ = _tmp14_;
#line 178 "../src/client/soup-wrapper.vala"
	_tmp16_ = g_strconcat ("?", _tmp15_, NULL);
#line 178 "../src/client/soup-wrapper.vala"
	_tmp17_ = _tmp16_;
#line 178 "../src/client/soup-wrapper.vala"
	_tmp18_ = g_strconcat (*uri, _tmp17_, NULL);
#line 178 "../src/client/soup-wrapper.vala"
	_g_free0 (*uri);
#line 178 "../src/client/soup-wrapper.vala"
	*uri = _tmp18_;
#line 178 "../src/client/soup-wrapper.vala"
	_g_free0 (_tmp17_);
#line 178 "../src/client/soup-wrapper.vala"
	_g_free0 (_tmp15_);
#line 173 "../src/client/soup-wrapper.vala"
	parameters_pairs = (_vala_array_free (parameters_pairs, parameters_pairs_length1, (GDestroyNotify) g_free), NULL);
#line 2078 "soup-wrapper.c"
}

static SoupMessage*
cassette_client_soup_wrapper_message_get (CassetteClientSoupWrapper* self,
                                          gchar* uri,
                                          gchar** header_preset_names,
                                          gint header_preset_names_length1,
                                          gchar** parameters,
                                          gint parameters_length1,
                                          gint parameters_length2,
                                          CassetteClientHeader* headers,
                                          gint headers_length1)
{
	SoupMessage* msg = NULL;
	SoupMessage* _tmp0_;
	SoupMessage* result;
#line 181 "../src/client/soup-wrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 181 "../src/client/soup-wrapper.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 187 "../src/client/soup-wrapper.vala"
	if (parameters != NULL) {
#line 188 "../src/client/soup-wrapper.vala"
		cassette_client_soup_wrapper_add_params_to_uri (self, parameters, (gint) parameters_length1, (gint) parameters_length2, &uri);
#line 2103 "soup-wrapper.c"
	}
#line 191 "../src/client/soup-wrapper.vala"
	_tmp0_ = soup_message_new ("GET", uri);
#line 191 "../src/client/soup-wrapper.vala"
	msg = _tmp0_;
#line 193 "../src/client/soup-wrapper.vala"
	if (header_preset_names != NULL) {
#line 2111 "soup-wrapper.c"
		{
			gchar** preset_name_collection = NULL;
			gint preset_name_collection_length1 = 0;
			gint _preset_name_collection_size_ = 0;
			gint preset_name_it = 0;
#line 194 "../src/client/soup-wrapper.vala"
			preset_name_collection = header_preset_names;
#line 194 "../src/client/soup-wrapper.vala"
			preset_name_collection_length1 = header_preset_names_length1;
#line 194 "../src/client/soup-wrapper.vala"
			for (preset_name_it = 0; preset_name_it < preset_name_collection_length1; preset_name_it = preset_name_it + 1) {
#line 2123 "soup-wrapper.c"
				gchar* _tmp1_;
				gchar* preset_name = NULL;
#line 194 "../src/client/soup-wrapper.vala"
				_tmp1_ = g_strdup (preset_name_collection[preset_name_it]);
#line 194 "../src/client/soup-wrapper.vala"
				preset_name = _tmp1_;
#line 2130 "soup-wrapper.c"
				{
					SoupMessage* _tmp2_;
					const gchar* _tmp3_;
#line 195 "../src/client/soup-wrapper.vala"
					_tmp2_ = msg;
#line 195 "../src/client/soup-wrapper.vala"
					_tmp3_ = preset_name;
#line 195 "../src/client/soup-wrapper.vala"
					cassette_client_soup_wrapper_append_headers_with_preset_to (self, _tmp2_, _tmp3_);
#line 194 "../src/client/soup-wrapper.vala"
					_g_free0 (preset_name);
#line 2142 "soup-wrapper.c"
				}
			}
		}
	}
#line 198 "../src/client/soup-wrapper.vala"
	if (headers != NULL) {
#line 2149 "soup-wrapper.c"
		SoupMessage* _tmp4_;
#line 199 "../src/client/soup-wrapper.vala"
		_tmp4_ = msg;
#line 199 "../src/client/soup-wrapper.vala"
		cassette_client_soup_wrapper_append_headers_to (self, _tmp4_, headers, (gint) headers_length1);
#line 2155 "soup-wrapper.c"
	}
#line 202 "../src/client/soup-wrapper.vala"
	result = msg;
#line 202 "../src/client/soup-wrapper.vala"
	_g_free0 (uri);
#line 202 "../src/client/soup-wrapper.vala"
	return result;
#line 2163 "soup-wrapper.c"
}

static SoupMessage*
cassette_client_soup_wrapper_message_post (CassetteClientSoupWrapper* self,
                                           gchar* uri,
                                           gchar** header_preset_names,
                                           gint header_preset_names_length1,
                                           CassetteClientPostContent* post_content,
                                           gchar** parameters,
                                           gint parameters_length1,
                                           gint parameters_length2,
                                           CassetteClientHeader* headers,
                                           gint headers_length1)
{
	SoupMessage* msg = NULL;
	SoupMessage* _tmp0_;
	SoupMessage* result;
#line 205 "../src/client/soup-wrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 205 "../src/client/soup-wrapper.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 212 "../src/client/soup-wrapper.vala"
	if (parameters != NULL) {
#line 213 "../src/client/soup-wrapper.vala"
		cassette_client_soup_wrapper_add_params_to_uri (self, parameters, (gint) parameters_length1, (gint) parameters_length2, &uri);
#line 2189 "soup-wrapper.c"
	}
#line 216 "../src/client/soup-wrapper.vala"
	_tmp0_ = soup_message_new ("POST", uri);
#line 216 "../src/client/soup-wrapper.vala"
	msg = _tmp0_;
#line 218 "../src/client/soup-wrapper.vala"
	if (post_content != NULL) {
#line 2197 "soup-wrapper.c"
		SoupMessage* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GBytes* _tmp4_;
		GBytes* _tmp5_;
#line 219 "../src/client/soup-wrapper.vala"
		_tmp1_ = msg;
#line 219 "../src/client/soup-wrapper.vala"
		_tmp2_ = cassette_client_post_content_get_content_type_string (post_content);
#line 219 "../src/client/soup-wrapper.vala"
		_tmp3_ = _tmp2_;
#line 219 "../src/client/soup-wrapper.vala"
		_tmp4_ = cassette_client_post_content_get_bytes (post_content);
#line 219 "../src/client/soup-wrapper.vala"
		_tmp5_ = _tmp4_;
#line 219 "../src/client/soup-wrapper.vala"
		soup_message_set_request_body_from_bytes (_tmp1_, _tmp3_, _tmp5_);
#line 219 "../src/client/soup-wrapper.vala"
		_g_bytes_unref0 (_tmp5_);
#line 219 "../src/client/soup-wrapper.vala"
		_g_free0 (_tmp3_);
#line 2219 "soup-wrapper.c"
	}
#line 225 "../src/client/soup-wrapper.vala"
	if (header_preset_names != NULL) {
#line 2223 "soup-wrapper.c"
		{
			gchar** preset_name_collection = NULL;
			gint preset_name_collection_length1 = 0;
			gint _preset_name_collection_size_ = 0;
			gint preset_name_it = 0;
#line 226 "../src/client/soup-wrapper.vala"
			preset_name_collection = header_preset_names;
#line 226 "../src/client/soup-wrapper.vala"
			preset_name_collection_length1 = header_preset_names_length1;
#line 226 "../src/client/soup-wrapper.vala"
			for (preset_name_it = 0; preset_name_it < preset_name_collection_length1; preset_name_it = preset_name_it + 1) {
#line 2235 "soup-wrapper.c"
				gchar* _tmp6_;
				gchar* preset_name = NULL;
#line 226 "../src/client/soup-wrapper.vala"
				_tmp6_ = g_strdup (preset_name_collection[preset_name_it]);
#line 226 "../src/client/soup-wrapper.vala"
				preset_name = _tmp6_;
#line 2242 "soup-wrapper.c"
				{
					SoupMessage* _tmp7_;
					const gchar* _tmp8_;
#line 227 "../src/client/soup-wrapper.vala"
					_tmp7_ = msg;
#line 227 "../src/client/soup-wrapper.vala"
					_tmp8_ = preset_name;
#line 227 "../src/client/soup-wrapper.vala"
					cassette_client_soup_wrapper_append_headers_with_preset_to (self, _tmp7_, _tmp8_);
#line 226 "../src/client/soup-wrapper.vala"
					_g_free0 (preset_name);
#line 2254 "soup-wrapper.c"
				}
			}
		}
	}
#line 230 "../src/client/soup-wrapper.vala"
	if (headers != NULL) {
#line 2261 "soup-wrapper.c"
		SoupMessage* _tmp9_;
#line 231 "../src/client/soup-wrapper.vala"
		_tmp9_ = msg;
#line 231 "../src/client/soup-wrapper.vala"
		cassette_client_soup_wrapper_append_headers_to (self, _tmp9_, headers, (gint) headers_length1);
#line 2267 "soup-wrapper.c"
	}
#line 234 "../src/client/soup-wrapper.vala"
	result = msg;
#line 234 "../src/client/soup-wrapper.vala"
	_g_free0 (uri);
#line 234 "../src/client/soup-wrapper.vala"
	return result;
#line 2275 "soup-wrapper.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 247 "../src/client/soup-wrapper.vala"
	return self ? g_object_ref (self) : NULL;
#line 2283 "soup-wrapper.c"
}

static void
cassette_client_soup_wrapper_check_status_code (CassetteClientSoupWrapper* self,
                                                SoupMessage* msg,
                                                GBytes* bytes,
                                                GError** error)
{
	guint _tmp0_;
	guint _tmp1_;
	CassetteClientYaMAPIApiError* _error_ = NULL;
	CassetteClientYaMAPIApiError* _tmp2_;
	CassetteClientYaMAPIApiError* _tmp22_;
	guint _tmp23_;
	guint _tmp24_;
	guint _tmp25_;
	guint _tmp26_;
	GError* _inner_error0_ = NULL;
#line 237 "../src/client/soup-wrapper.vala"
	g_return_if_fail (self != NULL);
#line 237 "../src/client/soup-wrapper.vala"
	g_return_if_fail (msg != NULL);
#line 237 "../src/client/soup-wrapper.vala"
	g_return_if_fail (bytes != NULL);
#line 238 "../src/client/soup-wrapper.vala"
	g_object_get (msg, "status-code", &_tmp0_, NULL);
#line 238 "../src/client/soup-wrapper.vala"
	_tmp1_ = _tmp0_;
#line 238 "../src/client/soup-wrapper.vala"
	if (_tmp1_ == ((guint) SOUP_STATUS_OK)) {
#line 239 "../src/client/soup-wrapper.vala"
		return;
#line 2316 "soup-wrapper.c"
	}
#line 242 "../src/client/soup-wrapper.vala"
	_tmp2_ = cassette_client_ya_mapi_api_error_new ();
#line 242 "../src/client/soup-wrapper.vala"
	_error_ = _tmp2_;
#line 2322 "soup-wrapper.c"
	{
		CassetteClientJsoner* jsoner = NULL;
		gchar* _tmp3_;
		gchar** _tmp4_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		CassetteClientJsoner* _tmp6_;
		CassetteClientJsoner* _tmp7_;
		CassetteClientJsoner* _tmp8_;
		JsonNode* _tmp9_;
		JsonNode* _tmp10_;
#line 245 "../src/client/soup-wrapper.vala"
		_tmp3_ = g_strdup ("error");
#line 245 "../src/client/soup-wrapper.vala"
		_tmp4_ = g_new0 (gchar*, 1 + 1);
#line 245 "../src/client/soup-wrapper.vala"
		_tmp4_[0] = _tmp3_;
#line 245 "../src/client/soup-wrapper.vala"
		_tmp5_ = _tmp4_;
#line 245 "../src/client/soup-wrapper.vala"
		_tmp5__length1 = 1;
#line 245 "../src/client/soup-wrapper.vala"
		_tmp6_ = cassette_client_jsoner_from_bytes (bytes, _tmp5_, (gint) 1, CASSETTE_CLIENT_CASE_CAMEL, &_inner_error0_);
#line 245 "../src/client/soup-wrapper.vala"
		_tmp7_ = _tmp6_;
#line 245 "../src/client/soup-wrapper.vala"
		_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 245 "../src/client/soup-wrapper.vala"
		jsoner = _tmp7_;
#line 245 "../src/client/soup-wrapper.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 245 "../src/client/soup-wrapper.vala"
			if (_inner_error0_->domain == CASSETTE_CLIENT_CLIENT_ERROR) {
#line 2356 "soup-wrapper.c"
				goto __catch0_cassette_client_client_error;
			}
#line 245 "../src/client/soup-wrapper.vala"
			_g_object_unref0 (_error_);
#line 245 "../src/client/soup-wrapper.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 245 "../src/client/soup-wrapper.vala"
			g_clear_error (&_inner_error0_);
#line 245 "../src/client/soup-wrapper.vala"
			return;
#line 2367 "soup-wrapper.c"
		}
#line 246 "../src/client/soup-wrapper.vala"
		_tmp8_ = jsoner;
#line 246 "../src/client/soup-wrapper.vala"
		_tmp9_ = cassette_client_jsoner_get_root (_tmp8_);
#line 246 "../src/client/soup-wrapper.vala"
		_tmp10_ = _tmp9_;
#line 246 "../src/client/soup-wrapper.vala"
		if (json_node_get_node_type (_tmp10_) == JSON_NODE_OBJECT) {
#line 2377 "soup-wrapper.c"
			CassetteClientYaMObject* _tmp11_ = NULL;
			CassetteClientJsoner* _tmp12_;
			CassetteClientYaMObject* _tmp13_;
			CassetteClientYaMAPIApiError* _tmp14_;
#line 247 "../src/client/soup-wrapper.vala"
			_tmp12_ = jsoner;
#line 247 "../src/client/soup-wrapper.vala"
			_tmp13_ = cassette_client_jsoner_deserialize_object (_tmp12_, CASSETTE_CLIENT_YA_MAPI_TYPE_API_ERROR, NULL, &_inner_error0_);
#line 247 "../src/client/soup-wrapper.vala"
			_tmp11_ = _tmp13_;
#line 247 "../src/client/soup-wrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 247 "../src/client/soup-wrapper.vala"
				_g_object_unref0 (jsoner);
#line 247 "../src/client/soup-wrapper.vala"
				if (_inner_error0_->domain == CASSETTE_CLIENT_CLIENT_ERROR) {
#line 2394 "soup-wrapper.c"
					goto __catch0_cassette_client_client_error;
				}
#line 247 "../src/client/soup-wrapper.vala"
				_g_object_unref0 (_error_);
#line 247 "../src/client/soup-wrapper.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 247 "../src/client/soup-wrapper.vala"
				g_clear_error (&_inner_error0_);
#line 247 "../src/client/soup-wrapper.vala"
				return;
#line 2405 "soup-wrapper.c"
			}
#line 247 "../src/client/soup-wrapper.vala"
			_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, CASSETTE_CLIENT_YA_MAPI_TYPE_API_ERROR, CassetteClientYaMAPIApiError));
#line 247 "../src/client/soup-wrapper.vala"
			_g_object_unref0 (_error_);
#line 247 "../src/client/soup-wrapper.vala"
			_error_ = _tmp14_;
#line 246 "../src/client/soup-wrapper.vala"
			_g_object_unref0 (_tmp11_);
#line 2415 "soup-wrapper.c"
		} else {
			CassetteClientJsoner* _tmp15_ = NULL;
			CassetteClientJsoner* _tmp16_;
			CassetteClientJsoner* _tmp17_;
			CassetteClientYaMObject* _tmp18_ = NULL;
			CassetteClientJsoner* _tmp19_;
			CassetteClientYaMObject* _tmp20_;
			CassetteClientYaMAPIApiError* _tmp21_;
#line 249 "../src/client/soup-wrapper.vala"
			_tmp16_ = cassette_client_jsoner_from_bytes (bytes, NULL, (gint) 0, CASSETTE_CLIENT_CASE_SNAKE, &_inner_error0_);
#line 249 "../src/client/soup-wrapper.vala"
			_tmp15_ = _tmp16_;
#line 249 "../src/client/soup-wrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 249 "../src/client/soup-wrapper.vala"
				_g_object_unref0 (jsoner);
#line 249 "../src/client/soup-wrapper.vala"
				if (_inner_error0_->domain == CASSETTE_CLIENT_CLIENT_ERROR) {
#line 2434 "soup-wrapper.c"
					goto __catch0_cassette_client_client_error;
				}
#line 249 "../src/client/soup-wrapper.vala"
				_g_object_unref0 (_error_);
#line 249 "../src/client/soup-wrapper.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 249 "../src/client/soup-wrapper.vala"
				g_clear_error (&_inner_error0_);
#line 249 "../src/client/soup-wrapper.vala"
				return;
#line 2445 "soup-wrapper.c"
			}
#line 249 "../src/client/soup-wrapper.vala"
			_tmp17_ = _tmp15_;
#line 249 "../src/client/soup-wrapper.vala"
			_tmp15_ = NULL;
#line 249 "../src/client/soup-wrapper.vala"
			_g_object_unref0 (jsoner);
#line 249 "../src/client/soup-wrapper.vala"
			jsoner = _tmp17_;
#line 250 "../src/client/soup-wrapper.vala"
			_tmp19_ = jsoner;
#line 250 "../src/client/soup-wrapper.vala"
			_tmp20_ = cassette_client_jsoner_deserialize_object (_tmp19_, CASSETTE_CLIENT_YA_MAPI_TYPE_API_ERROR, NULL, &_inner_error0_);
#line 250 "../src/client/soup-wrapper.vala"
			_tmp18_ = _tmp20_;
#line 250 "../src/client/soup-wrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 250 "../src/client/soup-wrapper.vala"
				_g_object_unref0 (_tmp15_);
#line 250 "../src/client/soup-wrapper.vala"
				_g_object_unref0 (jsoner);
#line 250 "../src/client/soup-wrapper.vala"
				if (_inner_error0_->domain == CASSETTE_CLIENT_CLIENT_ERROR) {
#line 2469 "soup-wrapper.c"
					goto __catch0_cassette_client_client_error;
				}
#line 250 "../src/client/soup-wrapper.vala"
				_g_object_unref0 (_error_);
#line 250 "../src/client/soup-wrapper.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 250 "../src/client/soup-wrapper.vala"
				g_clear_error (&_inner_error0_);
#line 250 "../src/client/soup-wrapper.vala"
				return;
#line 2480 "soup-wrapper.c"
			}
#line 250 "../src/client/soup-wrapper.vala"
			_tmp21_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, CASSETTE_CLIENT_YA_MAPI_TYPE_API_ERROR, CassetteClientYaMAPIApiError));
#line 250 "../src/client/soup-wrapper.vala"
			_g_object_unref0 (_error_);
#line 250 "../src/client/soup-wrapper.vala"
			_error_ = _tmp21_;
#line 246 "../src/client/soup-wrapper.vala"
			_g_object_unref0 (_tmp18_);
#line 246 "../src/client/soup-wrapper.vala"
			_g_object_unref0 (_tmp15_);
#line 2492 "soup-wrapper.c"
		}
#line 244 "../src/client/soup-wrapper.vala"
		_g_object_unref0 (jsoner);
#line 2496 "soup-wrapper.c"
	}
	goto __finally0;
	__catch0_cassette_client_client_error:
	{
#line 244 "../src/client/soup-wrapper.vala"
		g_clear_error (&_inner_error0_);
#line 2503 "soup-wrapper.c"
	}
	__finally0:
#line 244 "../src/client/soup-wrapper.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 244 "../src/client/soup-wrapper.vala"
		if ((_inner_error0_->domain == CASSETTE_CLIENT_CLIENT_ERROR) || (_inner_error0_->domain == CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR)) {
#line 244 "../src/client/soup-wrapper.vala"
			g_propagate_error (error, _inner_error0_);
#line 244 "../src/client/soup-wrapper.vala"
			_g_object_unref0 (_error_);
#line 244 "../src/client/soup-wrapper.vala"
			return;
#line 2516 "soup-wrapper.c"
		} else {
#line 244 "../src/client/soup-wrapper.vala"
			_g_object_unref0 (_error_);
#line 244 "../src/client/soup-wrapper.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 244 "../src/client/soup-wrapper.vala"
			g_clear_error (&_inner_error0_);
#line 244 "../src/client/soup-wrapper.vala"
			return;
#line 2526 "soup-wrapper.c"
		}
	}
#line 254 "../src/client/soup-wrapper.vala"
	_tmp22_ = _error_;
#line 254 "../src/client/soup-wrapper.vala"
	g_object_get (msg, "status-code", &_tmp23_, NULL);
#line 254 "../src/client/soup-wrapper.vala"
	_tmp24_ = _tmp23_;
#line 254 "../src/client/soup-wrapper.vala"
	cassette_client_ya_mapi_api_error_set_status_code (_tmp22_, _tmp24_);
#line 256 "../src/client/soup-wrapper.vala"
	g_object_get (msg, "status-code", &_tmp25_, NULL);
#line 256 "../src/client/soup-wrapper.vala"
	_tmp26_ = _tmp25_;
#line 256 "../src/client/soup-wrapper.vala"
	switch (_tmp26_) {
#line 256 "../src/client/soup-wrapper.vala"
		case SOUP_STATUS_BAD_REQUEST:
#line 2545 "soup-wrapper.c"
		{
			CassetteClientYaMAPIApiError* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			GError* _tmp31_;
			GError* _tmp32_;
#line 258 "../src/client/soup-wrapper.vala"
			_tmp27_ = _error_;
#line 258 "../src/client/soup-wrapper.vala"
			_tmp28_ = cassette_client_ya_mapi_api_error_get_msg (_tmp27_);
#line 258 "../src/client/soup-wrapper.vala"
			_tmp29_ = _tmp28_;
#line 258 "../src/client/soup-wrapper.vala"
			_tmp30_ = _tmp29_;
#line 258 "../src/client/soup-wrapper.vala"
			_tmp31_ = g_error_new_literal (CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR, CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR_BAD_REQUEST, _tmp30_);
#line 258 "../src/client/soup-wrapper.vala"
			_tmp32_ = _tmp31_;
#line 258 "../src/client/soup-wrapper.vala"
			_g_free0 (_tmp30_);
#line 258 "../src/client/soup-wrapper.vala"
			_inner_error0_ = _tmp32_;
#line 258 "../src/client/soup-wrapper.vala"
			if ((_inner_error0_->domain == CASSETTE_CLIENT_CLIENT_ERROR) || (_inner_error0_->domain == CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR)) {
#line 258 "../src/client/soup-wrapper.vala"
				g_propagate_error (error, _inner_error0_);
#line 258 "../src/client/soup-wrapper.vala"
				_g_object_unref0 (_error_);
#line 258 "../src/client/soup-wrapper.vala"
				return;
#line 2577 "soup-wrapper.c"
			} else {
#line 258 "../src/client/soup-wrapper.vala"
				_g_object_unref0 (_error_);
#line 258 "../src/client/soup-wrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 258 "../src/client/soup-wrapper.vala"
				g_clear_error (&_inner_error0_);
#line 258 "../src/client/soup-wrapper.vala"
				return;
#line 2587 "soup-wrapper.c"
			}
		}
#line 256 "../src/client/soup-wrapper.vala"
		case SOUP_STATUS_NOT_FOUND:
#line 2592 "soup-wrapper.c"
		{
			CassetteClientYaMAPIApiError* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			GError* _tmp37_;
			GError* _tmp38_;
#line 260 "../src/client/soup-wrapper.vala"
			_tmp33_ = _error_;
#line 260 "../src/client/soup-wrapper.vala"
			_tmp34_ = cassette_client_ya_mapi_api_error_get_msg (_tmp33_);
#line 260 "../src/client/soup-wrapper.vala"
			_tmp35_ = _tmp34_;
#line 260 "../src/client/soup-wrapper.vala"
			_tmp36_ = _tmp35_;
#line 260 "../src/client/soup-wrapper.vala"
			_tmp37_ = g_error_new_literal (CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR, CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR_NOT_FOUND, _tmp36_);
#line 260 "../src/client/soup-wrapper.vala"
			_tmp38_ = _tmp37_;
#line 260 "../src/client/soup-wrapper.vala"
			_g_free0 (_tmp36_);
#line 260 "../src/client/soup-wrapper.vala"
			_inner_error0_ = _tmp38_;
#line 260 "../src/client/soup-wrapper.vala"
			if ((_inner_error0_->domain == CASSETTE_CLIENT_CLIENT_ERROR) || (_inner_error0_->domain == CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR)) {
#line 260 "../src/client/soup-wrapper.vala"
				g_propagate_error (error, _inner_error0_);
#line 260 "../src/client/soup-wrapper.vala"
				_g_object_unref0 (_error_);
#line 260 "../src/client/soup-wrapper.vala"
				return;
#line 2624 "soup-wrapper.c"
			} else {
#line 260 "../src/client/soup-wrapper.vala"
				_g_object_unref0 (_error_);
#line 260 "../src/client/soup-wrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 260 "../src/client/soup-wrapper.vala"
				g_clear_error (&_inner_error0_);
#line 260 "../src/client/soup-wrapper.vala"
				return;
#line 2634 "soup-wrapper.c"
			}
		}
#line 256 "../src/client/soup-wrapper.vala"
		case SOUP_STATUS_FORBIDDEN:
#line 2639 "soup-wrapper.c"
		{
			CassetteClientYaMAPIApiError* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
			GError* _tmp43_;
			GError* _tmp44_;
#line 262 "../src/client/soup-wrapper.vala"
			_tmp39_ = _error_;
#line 262 "../src/client/soup-wrapper.vala"
			_tmp40_ = cassette_client_ya_mapi_api_error_get_msg (_tmp39_);
#line 262 "../src/client/soup-wrapper.vala"
			_tmp41_ = _tmp40_;
#line 262 "../src/client/soup-wrapper.vala"
			_tmp42_ = _tmp41_;
#line 262 "../src/client/soup-wrapper.vala"
			_tmp43_ = g_error_new_literal (CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR, CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR_UNAUTHORIZE_ERROR, _tmp42_);
#line 262 "../src/client/soup-wrapper.vala"
			_tmp44_ = _tmp43_;
#line 262 "../src/client/soup-wrapper.vala"
			_g_free0 (_tmp42_);
#line 262 "../src/client/soup-wrapper.vala"
			_inner_error0_ = _tmp44_;
#line 262 "../src/client/soup-wrapper.vala"
			if ((_inner_error0_->domain == CASSETTE_CLIENT_CLIENT_ERROR) || (_inner_error0_->domain == CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR)) {
#line 262 "../src/client/soup-wrapper.vala"
				g_propagate_error (error, _inner_error0_);
#line 262 "../src/client/soup-wrapper.vala"
				_g_object_unref0 (_error_);
#line 262 "../src/client/soup-wrapper.vala"
				return;
#line 2671 "soup-wrapper.c"
			} else {
#line 262 "../src/client/soup-wrapper.vala"
				_g_object_unref0 (_error_);
#line 262 "../src/client/soup-wrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 262 "../src/client/soup-wrapper.vala"
				g_clear_error (&_inner_error0_);
#line 262 "../src/client/soup-wrapper.vala"
				return;
#line 2681 "soup-wrapper.c"
			}
		}
		default:
		{
			guint _tmp45_;
			guint _tmp46_;
			gchar* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
			gchar* _tmp50_;
			CassetteClientYaMAPIApiError* _tmp51_;
			gchar* _tmp52_;
			gchar* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
			gchar* _tmp56_;
			GError* _tmp57_;
			GError* _tmp58_;
#line 264 "../src/client/soup-wrapper.vala"
			g_object_get (msg, "status-code", &_tmp45_, NULL);
#line 264 "../src/client/soup-wrapper.vala"
			_tmp46_ = _tmp45_;
#line 264 "../src/client/soup-wrapper.vala"
			_tmp47_ = g_strdup_printf ("%u", _tmp46_);
#line 264 "../src/client/soup-wrapper.vala"
			_tmp48_ = _tmp47_;
#line 264 "../src/client/soup-wrapper.vala"
			_tmp49_ = g_strconcat (_tmp48_, ": ", NULL);
#line 264 "../src/client/soup-wrapper.vala"
			_tmp50_ = _tmp49_;
#line 264 "../src/client/soup-wrapper.vala"
			_tmp51_ = _error_;
#line 264 "../src/client/soup-wrapper.vala"
			_tmp52_ = cassette_client_ya_mapi_api_error_get_msg (_tmp51_);
#line 264 "../src/client/soup-wrapper.vala"
			_tmp53_ = _tmp52_;
#line 264 "../src/client/soup-wrapper.vala"
			_tmp54_ = _tmp53_;
#line 264 "../src/client/soup-wrapper.vala"
			_tmp55_ = g_strconcat (_tmp50_, _tmp54_, NULL);
#line 264 "../src/client/soup-wrapper.vala"
			_tmp56_ = _tmp55_;
#line 264 "../src/client/soup-wrapper.vala"
			_tmp57_ = g_error_new_literal (CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR, CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR_UNKNOWN, _tmp56_);
#line 264 "../src/client/soup-wrapper.vala"
			_tmp58_ = _tmp57_;
#line 264 "../src/client/soup-wrapper.vala"
			_g_free0 (_tmp56_);
#line 264 "../src/client/soup-wrapper.vala"
			_g_free0 (_tmp54_);
#line 264 "../src/client/soup-wrapper.vala"
			_g_free0 (_tmp50_);
#line 264 "../src/client/soup-wrapper.vala"
			_g_free0 (_tmp48_);
#line 264 "../src/client/soup-wrapper.vala"
			_inner_error0_ = _tmp58_;
#line 264 "../src/client/soup-wrapper.vala"
			if ((_inner_error0_->domain == CASSETTE_CLIENT_CLIENT_ERROR) || (_inner_error0_->domain == CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR)) {
#line 264 "../src/client/soup-wrapper.vala"
				g_propagate_error (error, _inner_error0_);
#line 264 "../src/client/soup-wrapper.vala"
				_g_object_unref0 (_error_);
#line 264 "../src/client/soup-wrapper.vala"
				return;
#line 2746 "soup-wrapper.c"
			} else {
#line 264 "../src/client/soup-wrapper.vala"
				_g_object_unref0 (_error_);
#line 264 "../src/client/soup-wrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 264 "../src/client/soup-wrapper.vala"
				g_clear_error (&_inner_error0_);
#line 264 "../src/client/soup-wrapper.vala"
				return;
#line 2756 "soup-wrapper.c"
			}
		}
	}
}

static GBytes*
cassette_client_soup_wrapper_run_sync (CassetteClientSoupWrapper* self,
                                       SoupMessage* msg,
                                       GError** error)
{
	GBytes* bytes = NULL;
	GBytes* _tmp16_;
	GError* _inner_error0_ = NULL;
	GBytes* result;
#line 268 "../src/client/soup-wrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 268 "../src/client/soup-wrapper.vala"
	g_return_val_if_fail (msg != NULL, NULL);
#line 269 "../src/client/soup-wrapper.vala"
	bytes = NULL;
#line 2777 "soup-wrapper.c"
	{
		GBytes* _tmp0_ = NULL;
		SoupSession* _tmp1_;
		GBytes* _tmp2_;
		GBytes* _tmp3_;
#line 272 "../src/client/soup-wrapper.vala"
		_tmp1_ = self->priv->session;
#line 272 "../src/client/soup-wrapper.vala"
		_tmp2_ = soup_session_send_and_read (_tmp1_, msg, NULL, &_inner_error0_);
#line 272 "../src/client/soup-wrapper.vala"
		_tmp0_ = _tmp2_;
#line 272 "../src/client/soup-wrapper.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2791 "soup-wrapper.c"
			goto __catch0_g_error;
		}
#line 272 "../src/client/soup-wrapper.vala"
		_tmp3_ = _tmp0_;
#line 272 "../src/client/soup-wrapper.vala"
		_tmp0_ = NULL;
#line 272 "../src/client/soup-wrapper.vala"
		_g_bytes_unref0 (bytes);
#line 272 "../src/client/soup-wrapper.vala"
		bytes = _tmp3_;
#line 271 "../src/client/soup-wrapper.vala"
		_g_bytes_unref0 (_tmp0_);
#line 2804 "soup-wrapper.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		GUri* _tmp6_;
		GUri* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		GError* _tmp14_;
		GError* _tmp15_;
#line 271 "../src/client/soup-wrapper.vala"
		e = _inner_error0_;
#line 271 "../src/client/soup-wrapper.vala"
		_inner_error0_ = NULL;
#line 275 "../src/client/soup-wrapper.vala"
		_tmp4_ = soup_message_get_method (msg);
#line 275 "../src/client/soup-wrapper.vala"
		_tmp5_ = _tmp4_;
#line 275 "../src/client/soup-wrapper.vala"
		_tmp6_ = soup_message_get_uri (msg);
#line 275 "../src/client/soup-wrapper.vala"
		_tmp7_ = _tmp6_;
#line 275 "../src/client/soup-wrapper.vala"
		_tmp8_ = g_uri_to_string (_tmp7_);
#line 275 "../src/client/soup-wrapper.vala"
		_tmp9_ = _tmp8_;
#line 275 "../src/client/soup-wrapper.vala"
		_tmp10_ = e;
#line 275 "../src/client/soup-wrapper.vala"
		_tmp11_ = _tmp10_->message;
#line 275 "../src/client/soup-wrapper.vala"
		_tmp12_ = g_strdup_printf ("%s %s: %s", _tmp5_, _tmp9_, _tmp11_);
#line 275 "../src/client/soup-wrapper.vala"
		_tmp13_ = _tmp12_;
#line 275 "../src/client/soup-wrapper.vala"
		_tmp14_ = g_error_new_literal (CASSETTE_CLIENT_CLIENT_ERROR, CASSETTE_CLIENT_CLIENT_ERROR_SOUP_ERROR, _tmp13_);
#line 275 "../src/client/soup-wrapper.vala"
		_tmp15_ = _tmp14_;
#line 275 "../src/client/soup-wrapper.vala"
		_g_free0 (_tmp13_);
#line 275 "../src/client/soup-wrapper.vala"
		_g_free0 (_tmp9_);
#line 275 "../src/client/soup-wrapper.vala"
		_inner_error0_ = _tmp15_;
#line 275 "../src/client/soup-wrapper.vala"
		_g_error_free0 (e);
#line 2858 "soup-wrapper.c"
		goto __finally0;
	}
	__finally0:
#line 271 "../src/client/soup-wrapper.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 271 "../src/client/soup-wrapper.vala"
		if ((_inner_error0_->domain == CASSETTE_CLIENT_CLIENT_ERROR) || (_inner_error0_->domain == CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR)) {
#line 271 "../src/client/soup-wrapper.vala"
			g_propagate_error (error, _inner_error0_);
#line 271 "../src/client/soup-wrapper.vala"
			_g_bytes_unref0 (bytes);
#line 271 "../src/client/soup-wrapper.vala"
			return NULL;
#line 2872 "soup-wrapper.c"
		} else {
#line 271 "../src/client/soup-wrapper.vala"
			_g_bytes_unref0 (bytes);
#line 271 "../src/client/soup-wrapper.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 271 "../src/client/soup-wrapper.vala"
			g_clear_error (&_inner_error0_);
#line 271 "../src/client/soup-wrapper.vala"
			return NULL;
#line 2882 "soup-wrapper.c"
		}
	}
#line 282 "../src/client/soup-wrapper.vala"
	_tmp16_ = bytes;
#line 282 "../src/client/soup-wrapper.vala"
	cassette_client_soup_wrapper_check_status_code (self, msg, _tmp16_, &_inner_error0_);
#line 282 "../src/client/soup-wrapper.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 282 "../src/client/soup-wrapper.vala"
		if ((_inner_error0_->domain == CASSETTE_CLIENT_CLIENT_ERROR) || (_inner_error0_->domain == CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR)) {
#line 282 "../src/client/soup-wrapper.vala"
			g_propagate_error (error, _inner_error0_);
#line 282 "../src/client/soup-wrapper.vala"
			_g_bytes_unref0 (bytes);
#line 282 "../src/client/soup-wrapper.vala"
			return NULL;
#line 2899 "soup-wrapper.c"
		} else {
#line 282 "../src/client/soup-wrapper.vala"
			_g_bytes_unref0 (bytes);
#line 282 "../src/client/soup-wrapper.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 282 "../src/client/soup-wrapper.vala"
			g_clear_error (&_inner_error0_);
#line 282 "../src/client/soup-wrapper.vala"
			return NULL;
#line 2909 "soup-wrapper.c"
		}
	}
#line 284 "../src/client/soup-wrapper.vala"
	result = bytes;
#line 284 "../src/client/soup-wrapper.vala"
	return result;
#line 2916 "soup-wrapper.c"
}

static void
cassette_client_soup_wrapper_run_async_data_free (gpointer _data)
{
	CassetteClientSoupWrapperRunAsyncData* _data_;
	_data_ = _data;
#line 92 "../src/client/soup-wrapper.vala"
	_g_object_unref0 (_data_->msg);
#line 92 "../src/client/soup-wrapper.vala"
	_g_bytes_unref0 (_data_->result);
#line 92 "../src/client/soup-wrapper.vala"
	_g_object_unref0 (_data_->self);
#line 92 "../src/client/soup-wrapper.vala"
	g_slice_free (CassetteClientSoupWrapperRunAsyncData, _data_);
#line 2932 "soup-wrapper.c"
}

static void
cassette_client_soup_wrapper_run_async (CassetteClientSoupWrapper* self,
                                        SoupMessage* msg,
                                        gint priority,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	CassetteClientSoupWrapperRunAsyncData* _data_;
	CassetteClientSoupWrapper* _tmp0_;
	SoupMessage* _tmp1_;
#line 92 "../src/client/soup-wrapper.vala"
	g_return_if_fail (self != NULL);
#line 92 "../src/client/soup-wrapper.vala"
	g_return_if_fail (msg != NULL);
#line 92 "../src/client/soup-wrapper.vala"
	_data_ = g_slice_new0 (CassetteClientSoupWrapperRunAsyncData);
#line 92 "../src/client/soup-wrapper.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 92 "../src/client/soup-wrapper.vala"
	g_task_set_task_data (_data_->_async_result, _data_, cassette_client_soup_wrapper_run_async_data_free);
#line 92 "../src/client/soup-wrapper.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 92 "../src/client/soup-wrapper.vala"
	_data_->self = _tmp0_;
#line 92 "../src/client/soup-wrapper.vala"
	_tmp1_ = _g_object_ref0 (msg);
#line 92 "../src/client/soup-wrapper.vala"
	_g_object_unref0 (_data_->msg);
#line 92 "../src/client/soup-wrapper.vala"
	_data_->msg = _tmp1_;
#line 92 "../src/client/soup-wrapper.vala"
	_data_->priority = priority;
#line 92 "../src/client/soup-wrapper.vala"
	cassette_client_soup_wrapper_run_async_co (_data_);
#line 2969 "soup-wrapper.c"
}

static GBytes*
cassette_client_soup_wrapper_run_finish (CassetteClientSoupWrapper* self,
                                         GAsyncResult* _res_,
                                         GError** error)
{
	GBytes* result;
	CassetteClientSoupWrapperRunAsyncData* _data_;
#line 92 "../src/client/soup-wrapper.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 92 "../src/client/soup-wrapper.vala"
	if (NULL == _data_) {
#line 92 "../src/client/soup-wrapper.vala"
		return NULL;
#line 2985 "soup-wrapper.c"
	}
#line 92 "../src/client/soup-wrapper.vala"
	result = _data_->result;
#line 92 "../src/client/soup-wrapper.vala"
	_data_->result = NULL;
#line 92 "../src/client/soup-wrapper.vala"
	return result;
#line 2993 "soup-wrapper.c"
}

static void
cassette_client_soup_wrapper_run_async_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_)
{
	CassetteClientSoupWrapperRunAsyncData* _data_;
#line 294 "../src/client/soup-wrapper.vala"
	_data_ = _user_data_;
#line 294 "../src/client/soup-wrapper.vala"
	_data_->_source_object_ = source_object;
#line 294 "../src/client/soup-wrapper.vala"
	_data_->_res_ = _res_;
#line 294 "../src/client/soup-wrapper.vala"
	cassette_client_soup_wrapper_run_async_co (_data_);
#line 3010 "soup-wrapper.c"
}

static gboolean
cassette_client_soup_wrapper_run_async_co (CassetteClientSoupWrapperRunAsyncData* _data_)
{
#line 287 "../src/client/soup-wrapper.vala"
	switch (_data_->_state_) {
#line 287 "../src/client/soup-wrapper.vala"
		case 0:
#line 3020 "soup-wrapper.c"
		goto _state_0;
#line 287 "../src/client/soup-wrapper.vala"
		case 1:
#line 3024 "soup-wrapper.c"
		goto _state_1;
		default:
#line 287 "../src/client/soup-wrapper.vala"
		g_assert_not_reached ();
#line 3029 "soup-wrapper.c"
	}
	_state_0:
#line 291 "../src/client/soup-wrapper.vala"
	_data_->bytes = NULL;
#line 3034 "soup-wrapper.c"
	{
#line 294 "../src/client/soup-wrapper.vala"
		_data_->_tmp1_ = _data_->self->priv->session;
#line 294 "../src/client/soup-wrapper.vala"
		_data_->_state_ = 1;
#line 294 "../src/client/soup-wrapper.vala"
		soup_session_send_and_read_async (_data_->_tmp1_, _data_->msg, _data_->priority, NULL, cassette_client_soup_wrapper_run_async_ready, _data_);
#line 294 "../src/client/soup-wrapper.vala"
		return FALSE;
#line 3044 "soup-wrapper.c"
		_state_1:
#line 294 "../src/client/soup-wrapper.vala"
		_data_->_tmp2_ = soup_session_send_and_read_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
#line 294 "../src/client/soup-wrapper.vala"
		_data_->_tmp0_ = _data_->_tmp2_;
#line 294 "../src/client/soup-wrapper.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3052 "soup-wrapper.c"
			goto __catch0_g_error;
		}
#line 294 "../src/client/soup-wrapper.vala"
		_data_->_tmp3_ = _data_->_tmp0_;
#line 294 "../src/client/soup-wrapper.vala"
		_data_->_tmp0_ = NULL;
#line 294 "../src/client/soup-wrapper.vala"
		_g_bytes_unref0 (_data_->bytes);
#line 294 "../src/client/soup-wrapper.vala"
		_data_->bytes = _data_->_tmp3_;
#line 293 "../src/client/soup-wrapper.vala"
		_g_bytes_unref0 (_data_->_tmp0_);
#line 3065 "soup-wrapper.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 293 "../src/client/soup-wrapper.vala"
		_data_->e = _data_->_inner_error0_;
#line 293 "../src/client/soup-wrapper.vala"
		_data_->_inner_error0_ = NULL;
#line 297 "../src/client/soup-wrapper.vala"
		_data_->_tmp4_ = soup_message_get_method (_data_->msg);
#line 297 "../src/client/soup-wrapper.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 297 "../src/client/soup-wrapper.vala"
		_data_->_tmp6_ = soup_message_get_uri (_data_->msg);
#line 297 "../src/client/soup-wrapper.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 297 "../src/client/soup-wrapper.vala"
		_data_->_tmp8_ = g_uri_to_string (_data_->_tmp7_);
#line 297 "../src/client/soup-wrapper.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 297 "../src/client/soup-wrapper.vala"
		_data_->_tmp10_ = _data_->e;
#line 297 "../src/client/soup-wrapper.vala"
		_data_->_tmp11_ = _data_->_tmp10_->message;
#line 297 "../src/client/soup-wrapper.vala"
		_data_->_tmp12_ = g_strdup_printf ("%s %s: %s", _data_->_tmp5_, _data_->_tmp9_, _data_->_tmp11_);
#line 297 "../src/client/soup-wrapper.vala"
		_data_->_tmp13_ = _data_->_tmp12_;
#line 297 "../src/client/soup-wrapper.vala"
		_data_->_tmp14_ = g_error_new_literal (CASSETTE_CLIENT_CLIENT_ERROR, CASSETTE_CLIENT_CLIENT_ERROR_SOUP_ERROR, _data_->_tmp13_);
#line 297 "../src/client/soup-wrapper.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 297 "../src/client/soup-wrapper.vala"
		_g_free0 (_data_->_tmp13_);
#line 297 "../src/client/soup-wrapper.vala"
		_g_free0 (_data_->_tmp9_);
#line 297 "../src/client/soup-wrapper.vala"
		_data_->_inner_error0_ = _data_->_tmp15_;
#line 297 "../src/client/soup-wrapper.vala"
		_g_error_free0 (_data_->e);
#line 3106 "soup-wrapper.c"
		goto __finally0;
	}
	__finally0:
#line 293 "../src/client/soup-wrapper.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 293 "../src/client/soup-wrapper.vala"
		if ((_data_->_inner_error0_->domain == CASSETTE_CLIENT_CLIENT_ERROR) || (_data_->_inner_error0_->domain == CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR)) {
#line 293 "../src/client/soup-wrapper.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 293 "../src/client/soup-wrapper.vala"
			_g_bytes_unref0 (_data_->bytes);
#line 293 "../src/client/soup-wrapper.vala"
			g_object_unref (_data_->_async_result);
#line 293 "../src/client/soup-wrapper.vala"
			return FALSE;
#line 3122 "soup-wrapper.c"
		} else {
#line 293 "../src/client/soup-wrapper.vala"
			_g_bytes_unref0 (_data_->bytes);
#line 293 "../src/client/soup-wrapper.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 293 "../src/client/soup-wrapper.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 293 "../src/client/soup-wrapper.vala"
			g_object_unref (_data_->_async_result);
#line 293 "../src/client/soup-wrapper.vala"
			return FALSE;
#line 3134 "soup-wrapper.c"
		}
	}
#line 304 "../src/client/soup-wrapper.vala"
	_data_->_tmp16_ = _data_->bytes;
#line 304 "../src/client/soup-wrapper.vala"
	cassette_client_soup_wrapper_check_status_code (_data_->self, _data_->msg, _data_->_tmp16_, &_data_->_inner_error0_);
#line 304 "../src/client/soup-wrapper.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 304 "../src/client/soup-wrapper.vala"
		if ((_data_->_inner_error0_->domain == CASSETTE_CLIENT_CLIENT_ERROR) || (_data_->_inner_error0_->domain == CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR)) {
#line 304 "../src/client/soup-wrapper.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 304 "../src/client/soup-wrapper.vala"
			_g_bytes_unref0 (_data_->bytes);
#line 304 "../src/client/soup-wrapper.vala"
			g_object_unref (_data_->_async_result);
#line 304 "../src/client/soup-wrapper.vala"
			return FALSE;
#line 3153 "soup-wrapper.c"
		} else {
#line 304 "../src/client/soup-wrapper.vala"
			_g_bytes_unref0 (_data_->bytes);
#line 304 "../src/client/soup-wrapper.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 304 "../src/client/soup-wrapper.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 304 "../src/client/soup-wrapper.vala"
			g_object_unref (_data_->_async_result);
#line 304 "../src/client/soup-wrapper.vala"
			return FALSE;
#line 3165 "soup-wrapper.c"
		}
	}
#line 306 "../src/client/soup-wrapper.vala"
	_data_->result = _data_->bytes;
#line 306 "../src/client/soup-wrapper.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 306 "../src/client/soup-wrapper.vala"
	if (_data_->_state_ != 0) {
#line 306 "../src/client/soup-wrapper.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 306 "../src/client/soup-wrapper.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3178 "soup-wrapper.c"
		}
	}
#line 306 "../src/client/soup-wrapper.vala"
	g_object_unref (_data_->_async_result);
#line 306 "../src/client/soup-wrapper.vala"
	return FALSE;
#line 3185 "soup-wrapper.c"
}

GBytes*
cassette_client_soup_wrapper_get_sync (CassetteClientSoupWrapper* self,
                                       gchar* uri,
                                       gchar** header_preset_names,
                                       gint header_preset_names_length1,
                                       gchar** parameters,
                                       gint parameters_length1,
                                       gint parameters_length2,
                                       CassetteClientHeader* headers,
                                       gint headers_length1,
                                       GError** error)
{
	SoupMessage* msg = NULL;
	gchar* _tmp0_;
	SoupMessage* _tmp1_;
	GBytes* _tmp2_ = NULL;
	GBytes* _tmp3_;
	GBytes* _tmp4_;
	GError* _inner_error0_ = NULL;
	GBytes* result;
#line 309 "../src/client/soup-wrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 309 "../src/client/soup-wrapper.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 315 "../src/client/soup-wrapper.vala"
	_tmp0_ = g_strdup (uri);
#line 315 "../src/client/soup-wrapper.vala"
	_tmp1_ = cassette_client_soup_wrapper_message_get (self, _tmp0_, header_preset_names, (gint) header_preset_names_length1, parameters, (gint) parameters_length1, (gint) parameters_length2, headers, (gint) headers_length1);
#line 315 "../src/client/soup-wrapper.vala"
	msg = _tmp1_;
#line 317 "../src/client/soup-wrapper.vala"
	_tmp3_ = cassette_client_soup_wrapper_run_sync (self, msg, &_inner_error0_);
#line 317 "../src/client/soup-wrapper.vala"
	_tmp2_ = _tmp3_;
#line 317 "../src/client/soup-wrapper.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 317 "../src/client/soup-wrapper.vala"
		if ((_inner_error0_->domain == CASSETTE_CLIENT_CLIENT_ERROR) || (_inner_error0_->domain == CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR)) {
#line 317 "../src/client/soup-wrapper.vala"
			g_propagate_error (error, _inner_error0_);
#line 317 "../src/client/soup-wrapper.vala"
			_g_object_unref0 (msg);
#line 317 "../src/client/soup-wrapper.vala"
			_g_free0 (uri);
#line 317 "../src/client/soup-wrapper.vala"
			return NULL;
#line 3234 "soup-wrapper.c"
		} else {
#line 317 "../src/client/soup-wrapper.vala"
			_g_object_unref0 (msg);
#line 317 "../src/client/soup-wrapper.vala"
			_g_free0 (uri);
#line 317 "../src/client/soup-wrapper.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 317 "../src/client/soup-wrapper.vala"
			g_clear_error (&_inner_error0_);
#line 317 "../src/client/soup-wrapper.vala"
			return NULL;
#line 3246 "soup-wrapper.c"
		}
	}
#line 317 "../src/client/soup-wrapper.vala"
	_tmp4_ = _tmp2_;
#line 317 "../src/client/soup-wrapper.vala"
	_tmp2_ = NULL;
#line 317 "../src/client/soup-wrapper.vala"
	result = _tmp4_;
#line 317 "../src/client/soup-wrapper.vala"
	_g_bytes_unref0 (_tmp2_);
#line 317 "../src/client/soup-wrapper.vala"
	_g_object_unref0 (msg);
#line 317 "../src/client/soup-wrapper.vala"
	_g_free0 (uri);
#line 317 "../src/client/soup-wrapper.vala"
	return result;
#line 3263 "soup-wrapper.c"
}

static void
cassette_client_soup_wrapper_get_async_data_free (gpointer _data)
{
	CassetteClientSoupWrapperGetAsyncData* _data_;
	_data_ = _data;
#line 92 "../src/client/soup-wrapper.vala"
	_g_free0 (_data_->uri);
#line 92 "../src/client/soup-wrapper.vala"
	_g_bytes_unref0 (_data_->result);
#line 92 "../src/client/soup-wrapper.vala"
	_g_object_unref0 (_data_->self);
#line 92 "../src/client/soup-wrapper.vala"
	g_slice_free (CassetteClientSoupWrapperGetAsyncData, _data_);
#line 3279 "soup-wrapper.c"
}

void
cassette_client_soup_wrapper_get_async (CassetteClientSoupWrapper* self,
                                        gchar* uri,
                                        gchar** header_preset_names,
                                        gint header_preset_names_length1,
                                        gchar** parameters,
                                        gint parameters_length1,
                                        gint parameters_length2,
                                        CassetteClientHeader* headers,
                                        gint headers_length1,
                                        gint priority,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	CassetteClientSoupWrapperGetAsyncData* _data_;
	CassetteClientSoupWrapper* _tmp0_;
#line 92 "../src/client/soup-wrapper.vala"
	g_return_if_fail (self != NULL);
#line 92 "../src/client/soup-wrapper.vala"
	g_return_if_fail (uri != NULL);
#line 92 "../src/client/soup-wrapper.vala"
	_data_ = g_slice_new0 (CassetteClientSoupWrapperGetAsyncData);
#line 92 "../src/client/soup-wrapper.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 92 "../src/client/soup-wrapper.vala"
	g_task_set_task_data (_data_->_async_result, _data_, cassette_client_soup_wrapper_get_async_data_free);
#line 92 "../src/client/soup-wrapper.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 92 "../src/client/soup-wrapper.vala"
	_data_->self = _tmp0_;
#line 92 "../src/client/soup-wrapper.vala"
	_g_free0 (_data_->uri);
#line 92 "../src/client/soup-wrapper.vala"
	_data_->uri = uri;
#line 92 "../src/client/soup-wrapper.vala"
	_data_->header_preset_names = header_preset_names;
#line 92 "../src/client/soup-wrapper.vala"
	_data_->header_preset_names_length1 = header_preset_names_length1;
#line 92 "../src/client/soup-wrapper.vala"
	_data_->parameters = parameters;
#line 92 "../src/client/soup-wrapper.vala"
	_data_->parameters_length1 = parameters_length1;
#line 92 "../src/client/soup-wrapper.vala"
	_data_->parameters_length2 = parameters_length2;
#line 92 "../src/client/soup-wrapper.vala"
	_data_->headers = headers;
#line 92 "../src/client/soup-wrapper.vala"
	_data_->headers_length1 = headers_length1;
#line 92 "../src/client/soup-wrapper.vala"
	_data_->priority = priority;
#line 92 "../src/client/soup-wrapper.vala"
	cassette_client_soup_wrapper_get_async_co (_data_);
#line 3334 "soup-wrapper.c"
}

GBytes*
cassette_client_soup_wrapper_get_finish (CassetteClientSoupWrapper* self,
                                         GAsyncResult* _res_,
                                         GError** error)
{
	GBytes* result;
	CassetteClientSoupWrapperGetAsyncData* _data_;
#line 92 "../src/client/soup-wrapper.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 92 "../src/client/soup-wrapper.vala"
	if (NULL == _data_) {
#line 92 "../src/client/soup-wrapper.vala"
		return NULL;
#line 3350 "soup-wrapper.c"
	}
#line 92 "../src/client/soup-wrapper.vala"
	result = _data_->result;
#line 92 "../src/client/soup-wrapper.vala"
	_data_->result = NULL;
#line 92 "../src/client/soup-wrapper.vala"
	return result;
#line 3358 "soup-wrapper.c"
}

static void
cassette_client_soup_wrapper_get_async_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_)
{
	CassetteClientSoupWrapperGetAsyncData* _data_;
#line 329 "../src/client/soup-wrapper.vala"
	_data_ = _user_data_;
#line 329 "../src/client/soup-wrapper.vala"
	_data_->_source_object_ = source_object;
#line 329 "../src/client/soup-wrapper.vala"
	_data_->_res_ = _res_;
#line 329 "../src/client/soup-wrapper.vala"
	cassette_client_soup_wrapper_get_async_co (_data_);
#line 3375 "soup-wrapper.c"
}

static gboolean
cassette_client_soup_wrapper_get_async_co (CassetteClientSoupWrapperGetAsyncData* _data_)
{
#line 320 "../src/client/soup-wrapper.vala"
	switch (_data_->_state_) {
#line 320 "../src/client/soup-wrapper.vala"
		case 0:
#line 3385 "soup-wrapper.c"
		goto _state_0;
#line 320 "../src/client/soup-wrapper.vala"
		case 1:
#line 3389 "soup-wrapper.c"
		goto _state_1;
		default:
#line 320 "../src/client/soup-wrapper.vala"
		g_assert_not_reached ();
#line 3394 "soup-wrapper.c"
	}
	_state_0:
#line 327 "../src/client/soup-wrapper.vala"
	_data_->_tmp0_ = g_strdup (_data_->uri);
#line 327 "../src/client/soup-wrapper.vala"
	_data_->_tmp1_ = cassette_client_soup_wrapper_message_get (_data_->self, _data_->_tmp0_, _data_->header_preset_names, (gint) _data_->header_preset_names_length1, _data_->parameters, (gint) _data_->parameters_length1, (gint) _data_->parameters_length2, _data_->headers, (gint) _data_->headers_length1);
#line 327 "../src/client/soup-wrapper.vala"
	_data_->msg = _data_->_tmp1_;
#line 329 "../src/client/soup-wrapper.vala"
	_data_->_state_ = 1;
#line 329 "../src/client/soup-wrapper.vala"
	cassette_client_soup_wrapper_run_async (_data_->self, _data_->msg, _data_->priority, cassette_client_soup_wrapper_get_async_ready, _data_);
#line 329 "../src/client/soup-wrapper.vala"
	return FALSE;
#line 3409 "soup-wrapper.c"
	_state_1:
#line 329 "../src/client/soup-wrapper.vala"
	_data_->_tmp3_ = cassette_client_soup_wrapper_run_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 329 "../src/client/soup-wrapper.vala"
	_data_->_tmp2_ = _data_->_tmp3_;
#line 329 "../src/client/soup-wrapper.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 329 "../src/client/soup-wrapper.vala"
		if ((_data_->_inner_error0_->domain == CASSETTE_CLIENT_CLIENT_ERROR) || (_data_->_inner_error0_->domain == CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR)) {
#line 329 "../src/client/soup-wrapper.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 329 "../src/client/soup-wrapper.vala"
			_g_object_unref0 (_data_->msg);
#line 329 "../src/client/soup-wrapper.vala"
			_g_free0 (_data_->uri);
#line 329 "../src/client/soup-wrapper.vala"
			g_object_unref (_data_->_async_result);
#line 329 "../src/client/soup-wrapper.vala"
			return FALSE;
#line 3429 "soup-wrapper.c"
		} else {
#line 329 "../src/client/soup-wrapper.vala"
			_g_object_unref0 (_data_->msg);
#line 329 "../src/client/soup-wrapper.vala"
			_g_free0 (_data_->uri);
#line 329 "../src/client/soup-wrapper.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 329 "../src/client/soup-wrapper.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 329 "../src/client/soup-wrapper.vala"
			g_object_unref (_data_->_async_result);
#line 329 "../src/client/soup-wrapper.vala"
			return FALSE;
#line 3443 "soup-wrapper.c"
		}
	}
#line 329 "../src/client/soup-wrapper.vala"
	_data_->_tmp4_ = _data_->_tmp2_;
#line 329 "../src/client/soup-wrapper.vala"
	_data_->_tmp2_ = NULL;
#line 329 "../src/client/soup-wrapper.vala"
	_data_->result = _data_->_tmp4_;
#line 329 "../src/client/soup-wrapper.vala"
	_g_bytes_unref0 (_data_->_tmp2_);
#line 329 "../src/client/soup-wrapper.vala"
	_g_object_unref0 (_data_->msg);
#line 329 "../src/client/soup-wrapper.vala"
	_g_free0 (_data_->uri);
#line 329 "../src/client/soup-wrapper.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 329 "../src/client/soup-wrapper.vala"
	if (_data_->_state_ != 0) {
#line 329 "../src/client/soup-wrapper.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 329 "../src/client/soup-wrapper.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3466 "soup-wrapper.c"
		}
	}
#line 329 "../src/client/soup-wrapper.vala"
	g_object_unref (_data_->_async_result);
#line 329 "../src/client/soup-wrapper.vala"
	return FALSE;
#line 3473 "soup-wrapper.c"
}

GBytes*
cassette_client_soup_wrapper_post_sync (CassetteClientSoupWrapper* self,
                                        gchar* uri,
                                        gchar** header_preset_names,
                                        gint header_preset_names_length1,
                                        CassetteClientPostContent* post_content,
                                        gchar** parameters,
                                        gint parameters_length1,
                                        gint parameters_length2,
                                        CassetteClientHeader* headers,
                                        gint headers_length1,
                                        GError** error)
{
	SoupMessage* msg = NULL;
	gchar* _tmp0_;
	SoupMessage* _tmp1_;
	GBytes* _tmp2_ = NULL;
	GBytes* _tmp3_;
	GBytes* _tmp4_;
	GError* _inner_error0_ = NULL;
	GBytes* result;
#line 332 "../src/client/soup-wrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 332 "../src/client/soup-wrapper.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 339 "../src/client/soup-wrapper.vala"
	_tmp0_ = g_strdup (uri);
#line 339 "../src/client/soup-wrapper.vala"
	_tmp1_ = cassette_client_soup_wrapper_message_post (self, _tmp0_, header_preset_names, (gint) header_preset_names_length1, post_content, parameters, (gint) parameters_length1, (gint) parameters_length2, headers, (gint) headers_length1);
#line 339 "../src/client/soup-wrapper.vala"
	msg = _tmp1_;
#line 341 "../src/client/soup-wrapper.vala"
	_tmp3_ = cassette_client_soup_wrapper_run_sync (self, msg, &_inner_error0_);
#line 341 "../src/client/soup-wrapper.vala"
	_tmp2_ = _tmp3_;
#line 341 "../src/client/soup-wrapper.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 341 "../src/client/soup-wrapper.vala"
		if ((_inner_error0_->domain == CASSETTE_CLIENT_CLIENT_ERROR) || (_inner_error0_->domain == CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR)) {
#line 341 "../src/client/soup-wrapper.vala"
			g_propagate_error (error, _inner_error0_);
#line 341 "../src/client/soup-wrapper.vala"
			_g_object_unref0 (msg);
#line 341 "../src/client/soup-wrapper.vala"
			_g_free0 (uri);
#line 341 "../src/client/soup-wrapper.vala"
			return NULL;
#line 3523 "soup-wrapper.c"
		} else {
#line 341 "../src/client/soup-wrapper.vala"
			_g_object_unref0 (msg);
#line 341 "../src/client/soup-wrapper.vala"
			_g_free0 (uri);
#line 341 "../src/client/soup-wrapper.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 341 "../src/client/soup-wrapper.vala"
			g_clear_error (&_inner_error0_);
#line 341 "../src/client/soup-wrapper.vala"
			return NULL;
#line 3535 "soup-wrapper.c"
		}
	}
#line 341 "../src/client/soup-wrapper.vala"
	_tmp4_ = _tmp2_;
#line 341 "../src/client/soup-wrapper.vala"
	_tmp2_ = NULL;
#line 341 "../src/client/soup-wrapper.vala"
	result = _tmp4_;
#line 341 "../src/client/soup-wrapper.vala"
	_g_bytes_unref0 (_tmp2_);
#line 341 "../src/client/soup-wrapper.vala"
	_g_object_unref0 (msg);
#line 341 "../src/client/soup-wrapper.vala"
	_g_free0 (uri);
#line 341 "../src/client/soup-wrapper.vala"
	return result;
#line 3552 "soup-wrapper.c"
}

static void
cassette_client_soup_wrapper_post_async_data_free (gpointer _data)
{
	CassetteClientSoupWrapperPostAsyncData* _data_;
	_data_ = _data;
#line 92 "../src/client/soup-wrapper.vala"
	_g_free0 (_data_->uri);
#line 92 "../src/client/soup-wrapper.vala"
	_cassette_client_post_content_free0 (_data_->post_content);
#line 92 "../src/client/soup-wrapper.vala"
	_g_bytes_unref0 (_data_->result);
#line 92 "../src/client/soup-wrapper.vala"
	_g_object_unref0 (_data_->self);
#line 92 "../src/client/soup-wrapper.vala"
	g_slice_free (CassetteClientSoupWrapperPostAsyncData, _data_);
#line 3570 "soup-wrapper.c"
}

static gpointer
_cassette_client_post_content_dup0 (gpointer self)
{
#line 92 "../src/client/soup-wrapper.vala"
	return self ? cassette_client_post_content_dup (self) : NULL;
#line 3578 "soup-wrapper.c"
}

void
cassette_client_soup_wrapper_post_async (CassetteClientSoupWrapper* self,
                                         gchar* uri,
                                         gchar** header_preset_names,
                                         gint header_preset_names_length1,
                                         CassetteClientPostContent* post_content,
                                         gchar** parameters,
                                         gint parameters_length1,
                                         gint parameters_length2,
                                         CassetteClientHeader* headers,
                                         gint headers_length1,
                                         gint priority,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	CassetteClientSoupWrapperPostAsyncData* _data_;
	CassetteClientSoupWrapper* _tmp0_;
	CassetteClientPostContent* _tmp1_;
#line 92 "../src/client/soup-wrapper.vala"
	g_return_if_fail (self != NULL);
#line 92 "../src/client/soup-wrapper.vala"
	g_return_if_fail (uri != NULL);
#line 92 "../src/client/soup-wrapper.vala"
	_data_ = g_slice_new0 (CassetteClientSoupWrapperPostAsyncData);
#line 92 "../src/client/soup-wrapper.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 92 "../src/client/soup-wrapper.vala"
	g_task_set_task_data (_data_->_async_result, _data_, cassette_client_soup_wrapper_post_async_data_free);
#line 92 "../src/client/soup-wrapper.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 92 "../src/client/soup-wrapper.vala"
	_data_->self = _tmp0_;
#line 92 "../src/client/soup-wrapper.vala"
	_g_free0 (_data_->uri);
#line 92 "../src/client/soup-wrapper.vala"
	_data_->uri = uri;
#line 92 "../src/client/soup-wrapper.vala"
	_data_->header_preset_names = header_preset_names;
#line 92 "../src/client/soup-wrapper.vala"
	_data_->header_preset_names_length1 = header_preset_names_length1;
#line 92 "../src/client/soup-wrapper.vala"
	_tmp1_ = _cassette_client_post_content_dup0 (post_content);
#line 92 "../src/client/soup-wrapper.vala"
	_cassette_client_post_content_free0 (_data_->post_content);
#line 92 "../src/client/soup-wrapper.vala"
	_data_->post_content = _tmp1_;
#line 92 "../src/client/soup-wrapper.vala"
	_data_->parameters = parameters;
#line 92 "../src/client/soup-wrapper.vala"
	_data_->parameters_length1 = parameters_length1;
#line 92 "../src/client/soup-wrapper.vala"
	_data_->parameters_length2 = parameters_length2;
#line 92 "../src/client/soup-wrapper.vala"
	_data_->headers = headers;
#line 92 "../src/client/soup-wrapper.vala"
	_data_->headers_length1 = headers_length1;
#line 92 "../src/client/soup-wrapper.vala"
	_data_->priority = priority;
#line 92 "../src/client/soup-wrapper.vala"
	cassette_client_soup_wrapper_post_async_co (_data_);
#line 3641 "soup-wrapper.c"
}

GBytes*
cassette_client_soup_wrapper_post_finish (CassetteClientSoupWrapper* self,
                                          GAsyncResult* _res_,
                                          GError** error)
{
	GBytes* result;
	CassetteClientSoupWrapperPostAsyncData* _data_;
#line 92 "../src/client/soup-wrapper.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 92 "../src/client/soup-wrapper.vala"
	if (NULL == _data_) {
#line 92 "../src/client/soup-wrapper.vala"
		return NULL;
#line 3657 "soup-wrapper.c"
	}
#line 92 "../src/client/soup-wrapper.vala"
	result = _data_->result;
#line 92 "../src/client/soup-wrapper.vala"
	_data_->result = NULL;
#line 92 "../src/client/soup-wrapper.vala"
	return result;
#line 3665 "soup-wrapper.c"
}

static void
cassette_client_soup_wrapper_post_async_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_)
{
	CassetteClientSoupWrapperPostAsyncData* _data_;
#line 354 "../src/client/soup-wrapper.vala"
	_data_ = _user_data_;
#line 354 "../src/client/soup-wrapper.vala"
	_data_->_source_object_ = source_object;
#line 354 "../src/client/soup-wrapper.vala"
	_data_->_res_ = _res_;
#line 354 "../src/client/soup-wrapper.vala"
	cassette_client_soup_wrapper_post_async_co (_data_);
#line 3682 "soup-wrapper.c"
}

static gboolean
cassette_client_soup_wrapper_post_async_co (CassetteClientSoupWrapperPostAsyncData* _data_)
{
#line 344 "../src/client/soup-wrapper.vala"
	switch (_data_->_state_) {
#line 344 "../src/client/soup-wrapper.vala"
		case 0:
#line 3692 "soup-wrapper.c"
		goto _state_0;
#line 344 "../src/client/soup-wrapper.vala"
		case 1:
#line 3696 "soup-wrapper.c"
		goto _state_1;
		default:
#line 344 "../src/client/soup-wrapper.vala"
		g_assert_not_reached ();
#line 3701 "soup-wrapper.c"
	}
	_state_0:
#line 352 "../src/client/soup-wrapper.vala"
	_data_->_tmp0_ = g_strdup (_data_->uri);
#line 352 "../src/client/soup-wrapper.vala"
	_data_->_tmp1_ = cassette_client_soup_wrapper_message_post (_data_->self, _data_->_tmp0_, _data_->header_preset_names, (gint) _data_->header_preset_names_length1, _data_->post_content, _data_->parameters, (gint) _data_->parameters_length1, (gint) _data_->parameters_length2, _data_->headers, (gint) _data_->headers_length1);
#line 352 "../src/client/soup-wrapper.vala"
	_data_->msg = _data_->_tmp1_;
#line 354 "../src/client/soup-wrapper.vala"
	_data_->_state_ = 1;
#line 354 "../src/client/soup-wrapper.vala"
	cassette_client_soup_wrapper_run_async (_data_->self, _data_->msg, _data_->priority, cassette_client_soup_wrapper_post_async_ready, _data_);
#line 354 "../src/client/soup-wrapper.vala"
	return FALSE;
#line 3716 "soup-wrapper.c"
	_state_1:
#line 354 "../src/client/soup-wrapper.vala"
	_data_->_tmp3_ = cassette_client_soup_wrapper_run_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 354 "../src/client/soup-wrapper.vala"
	_data_->_tmp2_ = _data_->_tmp3_;
#line 354 "../src/client/soup-wrapper.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 354 "../src/client/soup-wrapper.vala"
		if ((_data_->_inner_error0_->domain == CASSETTE_CLIENT_CLIENT_ERROR) || (_data_->_inner_error0_->domain == CASSETTE_CLIENT_BAD_STATUS_CODE_ERROR)) {
#line 354 "../src/client/soup-wrapper.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 354 "../src/client/soup-wrapper.vala"
			_g_object_unref0 (_data_->msg);
#line 354 "../src/client/soup-wrapper.vala"
			_g_free0 (_data_->uri);
#line 354 "../src/client/soup-wrapper.vala"
			g_object_unref (_data_->_async_result);
#line 354 "../src/client/soup-wrapper.vala"
			return FALSE;
#line 3736 "soup-wrapper.c"
		} else {
#line 354 "../src/client/soup-wrapper.vala"
			_g_object_unref0 (_data_->msg);
#line 354 "../src/client/soup-wrapper.vala"
			_g_free0 (_data_->uri);
#line 354 "../src/client/soup-wrapper.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 354 "../src/client/soup-wrapper.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 354 "../src/client/soup-wrapper.vala"
			g_object_unref (_data_->_async_result);
#line 354 "../src/client/soup-wrapper.vala"
			return FALSE;
#line 3750 "soup-wrapper.c"
		}
	}
#line 354 "../src/client/soup-wrapper.vala"
	_data_->_tmp4_ = _data_->_tmp2_;
#line 354 "../src/client/soup-wrapper.vala"
	_data_->_tmp2_ = NULL;
#line 354 "../src/client/soup-wrapper.vala"
	_data_->result = _data_->_tmp4_;
#line 354 "../src/client/soup-wrapper.vala"
	_g_bytes_unref0 (_data_->_tmp2_);
#line 354 "../src/client/soup-wrapper.vala"
	_g_object_unref0 (_data_->msg);
#line 354 "../src/client/soup-wrapper.vala"
	_g_free0 (_data_->uri);
#line 354 "../src/client/soup-wrapper.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 354 "../src/client/soup-wrapper.vala"
	if (_data_->_state_ != 0) {
#line 354 "../src/client/soup-wrapper.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 354 "../src/client/soup-wrapper.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3773 "soup-wrapper.c"
		}
	}
#line 354 "../src/client/soup-wrapper.vala"
	g_object_unref (_data_->_async_result);
#line 354 "../src/client/soup-wrapper.vala"
	return FALSE;
#line 3780 "soup-wrapper.c"
}

static void
cassette_client_soup_wrapper_set_user_agent (CassetteClientSoupWrapper* self,
                                             const gchar* value)
{
#line 100 "../src/client/soup-wrapper.vala"
	g_return_if_fail (self != NULL);
#line 101 "../src/client/soup-wrapper.vala"
	if (value != NULL) {
#line 3791 "soup-wrapper.c"
		SoupSession* _tmp0_;
#line 102 "../src/client/soup-wrapper.vala"
		_tmp0_ = self->priv->session;
#line 102 "../src/client/soup-wrapper.vala"
		soup_session_set_user_agent (_tmp0_, value);
#line 3797 "soup-wrapper.c"
	}
#line 100 "../src/client/soup-wrapper.vala"
	g_object_notify_by_pspec ((GObject *) self, cassette_client_soup_wrapper_properties[CASSETTE_CLIENT_SOUP_WRAPPER_USER_AGENT_PROPERTY]);
#line 3801 "soup-wrapper.c"
}

void
cassette_client_soup_wrapper_set_cookies_file (CassetteClientSoupWrapper* self,
                                               GFile* value)
{
#line 108 "../src/client/soup-wrapper.vala"
	g_return_if_fail (self != NULL);
#line 109 "../src/client/soup-wrapper.vala"
	if (value == NULL) {
#line 110 "../src/client/soup-wrapper.vala"
		return;
#line 3814 "soup-wrapper.c"
	}
#line 113 "../src/client/soup-wrapper.vala"
	cassette_client_soup_wrapper_reload_cookies (self, value);
#line 108 "../src/client/soup-wrapper.vala"
	g_object_notify_by_pspec ((GObject *) self, cassette_client_soup_wrapper_properties[CASSETTE_CLIENT_SOUP_WRAPPER_COOKIES_FILE_PROPERTY]);
#line 3820 "soup-wrapper.c"
}

static void
_cassette_client_soup_wrapper____lambda23_ (CassetteClientSoupWrapper* self,
                                            SoupLogger* logger,
                                            SoupLoggerLogLevel level,
                                            gchar direction,
                                            const gchar* data)
{
#line 124 "../src/client/soup-wrapper.vala"
	g_return_if_fail (logger != NULL);
#line 124 "../src/client/soup-wrapper.vala"
	g_return_if_fail (data != NULL);
#line 125 "../src/client/soup-wrapper.vala"
	switch (direction) {
#line 125 "../src/client/soup-wrapper.vala"
		case '<':
#line 3838 "soup-wrapper.c"
		{
#line 127 "../src/client/soup-wrapper.vala"
			cassette_client_logger_net_in (level, data);
#line 128 "../src/client/soup-wrapper.vala"
			break;
#line 3844 "soup-wrapper.c"
		}
#line 125 "../src/client/soup-wrapper.vala"
		case '>':
#line 3848 "soup-wrapper.c"
		{
#line 130 "../src/client/soup-wrapper.vala"
			cassette_client_logger_net_out (level, data);
#line 131 "../src/client/soup-wrapper.vala"
			break;
#line 3854 "soup-wrapper.c"
		}
		default:
		{
#line 133 "../src/client/soup-wrapper.vala"
			cassette_client_logger_time ();
#line 134 "../src/client/soup-wrapper.vala"
			break;
#line 3862 "soup-wrapper.c"
		}
	}
}

static void
__cassette_client_soup_wrapper____lambda23__soup_logger_printer (SoupLogger* logger,
                                                                 SoupLoggerLogLevel level,
                                                                 gchar direction,
                                                                 const gchar* data,
                                                                 gpointer self)
{
#line 124 "../src/client/soup-wrapper.vala"
	_cassette_client_soup_wrapper____lambda23_ ((CassetteClientSoupWrapper*) self, logger, level, direction, data);
#line 3876 "soup-wrapper.c"
}

static GObject *
cassette_client_soup_wrapper_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CassetteClientSoupWrapper * self;
	CassetteClientLogLevel _tmp0_;
	CassetteClientLogLevel _tmp1_;
#line 121 "../src/client/soup-wrapper.vala"
	parent_class = G_OBJECT_CLASS (cassette_client_soup_wrapper_parent_class);
#line 121 "../src/client/soup-wrapper.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 121 "../src/client/soup-wrapper.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CASSETTE_CLIENT_TYPE_SOUP_WRAPPER, CassetteClientSoupWrapper);
#line 122 "../src/client/soup-wrapper.vala"
	_tmp0_ = cassette_client_logger_get_log_level ();
#line 122 "../src/client/soup-wrapper.vala"
	_tmp1_ = _tmp0_;
#line 122 "../src/client/soup-wrapper.vala"
	if (_tmp1_ == CASSETTE_CLIENT_LOG_LEVEL_DEVEL) {
#line 3901 "soup-wrapper.c"
		SoupLogger* logger = NULL;
		SoupLogger* _tmp2_;
		SoupLogger* _tmp3_;
		SoupSession* _tmp4_;
		SoupLogger* _tmp5_;
#line 123 "../src/client/soup-wrapper.vala"
		_tmp2_ = soup_logger_new (SOUP_LOGGER_LOG_BODY);
#line 123 "../src/client/soup-wrapper.vala"
		logger = _tmp2_;
#line 124 "../src/client/soup-wrapper.vala"
		_tmp3_ = logger;
#line 124 "../src/client/soup-wrapper.vala"
		soup_logger_set_printer (_tmp3_, __cassette_client_soup_wrapper____lambda23__soup_logger_printer, g_object_ref (self), g_object_unref);
#line 137 "../src/client/soup-wrapper.vala"
		_tmp4_ = self->priv->session;
#line 137 "../src/client/soup-wrapper.vala"
		_tmp5_ = logger;
#line 137 "../src/client/soup-wrapper.vala"
		soup_session_add_feature (_tmp4_, (SoupSessionFeature*) _tmp5_);
#line 122 "../src/client/soup-wrapper.vala"
		_g_object_unref0 (logger);
#line 3923 "soup-wrapper.c"
	}
#line 121 "../src/client/soup-wrapper.vala"
	return obj;
#line 3927 "soup-wrapper.c"
}

static void
cassette_client_soup_wrapper_class_init (CassetteClientSoupWrapperClass * klass,
                                         gpointer klass_data)
{
#line 92 "../src/client/soup-wrapper.vala"
	cassette_client_soup_wrapper_parent_class = g_type_class_peek_parent (klass);
#line 92 "../src/client/soup-wrapper.vala"
	g_type_class_adjust_private_offset (klass, &CassetteClientSoupWrapper_private_offset);
#line 92 "../src/client/soup-wrapper.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_cassette_client_soup_wrapper_set_property;
#line 92 "../src/client/soup-wrapper.vala"
	G_OBJECT_CLASS (klass)->constructor = cassette_client_soup_wrapper_constructor;
#line 92 "../src/client/soup-wrapper.vala"
	G_OBJECT_CLASS (klass)->finalize = cassette_client_soup_wrapper_finalize;
#line 92 "../src/client/soup-wrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_CLIENT_SOUP_WRAPPER_USER_AGENT_PROPERTY, cassette_client_soup_wrapper_properties[CASSETTE_CLIENT_SOUP_WRAPPER_USER_AGENT_PROPERTY] = g_param_spec_string ("user-agent", "user-agent", "user-agent", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 92 "../src/client/soup-wrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_CLIENT_SOUP_WRAPPER_COOKIES_FILE_PROPERTY, cassette_client_soup_wrapper_properties[CASSETTE_CLIENT_SOUP_WRAPPER_COOKIES_FILE_PROPERTY] = g_param_spec_object ("cookies-file", "cookies-file", "cookies-file", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 3948 "soup-wrapper.c"
}

static void
cassette_client_soup_wrapper_instance_init (CassetteClientSoupWrapper * self,
                                            gpointer klass)
{
	GeeHashMap* _tmp0_;
	SoupSession* _tmp1_ = NULL;
#line 92 "../src/client/soup-wrapper.vala"
	self->priv = cassette_client_soup_wrapper_get_instance_private (self);
#line 94 "../src/client/soup-wrapper.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, CASSETTE_CLIENT_TYPE_HEADERS, (GBoxedCopyFunc) cassette_client_headers_ref, (GDestroyNotify) cassette_client_headers_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 94 "../src/client/soup-wrapper.vala"
	self->priv->presets_table = _tmp0_;
#line 96 "../src/client/soup-wrapper.vala"
	_tmp1_ = soup_session_new ();
#line 96 "../src/client/soup-wrapper.vala"
	soup_session_set_timeout (_tmp1_, (guint) CASSETTE_CLIENT_TIMEOUT);
#line 96 "../src/client/soup-wrapper.vala"
	self->priv->session = _tmp1_;
#line 3969 "soup-wrapper.c"
}

static void
cassette_client_soup_wrapper_finalize (GObject * obj)
{
	CassetteClientSoupWrapper * self;
#line 92 "../src/client/soup-wrapper.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CASSETTE_CLIENT_TYPE_SOUP_WRAPPER, CassetteClientSoupWrapper);
#line 94 "../src/client/soup-wrapper.vala"
	_g_object_unref0 (self->priv->presets_table);
#line 96 "../src/client/soup-wrapper.vala"
	_g_object_unref0 (self->priv->session);
#line 92 "../src/client/soup-wrapper.vala"
	G_OBJECT_CLASS (cassette_client_soup_wrapper_parent_class)->finalize (obj);
#line 3984 "soup-wrapper.c"
}

 G_GNUC_NO_INLINE static GType
cassette_client_soup_wrapper_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CassetteClientSoupWrapperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cassette_client_soup_wrapper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CassetteClientSoupWrapper), 0, (GInstanceInitFunc) cassette_client_soup_wrapper_instance_init, NULL };
	GType cassette_client_soup_wrapper_type_id;
	cassette_client_soup_wrapper_type_id = g_type_register_static (G_TYPE_OBJECT, "CassetteClientSoupWrapper", &g_define_type_info, 0);
	CassetteClientSoupWrapper_private_offset = g_type_add_instance_private (cassette_client_soup_wrapper_type_id, sizeof (CassetteClientSoupWrapperPrivate));
	return cassette_client_soup_wrapper_type_id;
}

GType
cassette_client_soup_wrapper_get_type (void)
{
	static gsize cassette_client_soup_wrapper_type_id__once = 0;
	if (g_once_init_enter (&cassette_client_soup_wrapper_type_id__once)) {
		GType cassette_client_soup_wrapper_type_id;
		cassette_client_soup_wrapper_type_id = cassette_client_soup_wrapper_get_type_once ();
		g_once_init_leave (&cassette_client_soup_wrapper_type_id__once, cassette_client_soup_wrapper_type_id);
	}
	return cassette_client_soup_wrapper_type_id__once;
}

static void
_vala_cassette_client_soup_wrapper_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	CassetteClientSoupWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CASSETTE_CLIENT_TYPE_SOUP_WRAPPER, CassetteClientSoupWrapper);
#line 92 "../src/client/soup-wrapper.vala"
	switch (property_id) {
#line 92 "../src/client/soup-wrapper.vala"
		case CASSETTE_CLIENT_SOUP_WRAPPER_USER_AGENT_PROPERTY:
#line 92 "../src/client/soup-wrapper.vala"
		cassette_client_soup_wrapper_set_user_agent (self, g_value_get_string (value));
#line 92 "../src/client/soup-wrapper.vala"
		break;
#line 92 "../src/client/soup-wrapper.vala"
		case CASSETTE_CLIENT_SOUP_WRAPPER_COOKIES_FILE_PROPERTY:
#line 92 "../src/client/soup-wrapper.vala"
		cassette_client_soup_wrapper_set_cookies_file (self, g_value_get_object (value));
#line 92 "../src/client/soup-wrapper.vala"
		break;
#line 4031 "soup-wrapper.c"
		default:
#line 92 "../src/client/soup-wrapper.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 92 "../src/client/soup-wrapper.vala"
		break;
#line 4037 "soup-wrapper.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 36 "../src/client/jsoner.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 4048 "soup-wrapper.c"
		gssize i;
#line 36 "../src/client/jsoner.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 36 "../src/client/jsoner.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 36 "../src/client/jsoner.vala"
				destroy_func (((gpointer*) array)[i]);
#line 4056 "soup-wrapper.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 36 "../src/client/jsoner.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 36 "../src/client/jsoner.vala"
	g_free (array);
#line 4071 "soup-wrapper.c"
}

