/* loadable-widget.c generated by valac 0.56.18, the Vala compiler
 * generated from loadable-widget.vala, do not modify */

/* Copyright 2023-2024 Vladimir Vaskov
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CASSETTE_TYPE_LOADABLE_WIDGET (cassette_loadable_widget_get_type ())
#define CASSETTE_LOADABLE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_TYPE_LOADABLE_WIDGET, CassetteLoadableWidget))
#define CASSETTE_LOADABLE_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_TYPE_LOADABLE_WIDGET, CassetteLoadableWidgetClass))
#define CASSETTE_IS_LOADABLE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_TYPE_LOADABLE_WIDGET))
#define CASSETTE_IS_LOADABLE_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_TYPE_LOADABLE_WIDGET))
#define CASSETTE_LOADABLE_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_TYPE_LOADABLE_WIDGET, CassetteLoadableWidgetClass))

typedef struct _CassetteLoadableWidget CassetteLoadableWidget;
typedef struct _CassetteLoadableWidgetClass CassetteLoadableWidgetClass;
typedef struct _CassetteLoadableWidgetPrivate CassetteLoadableWidgetPrivate;
enum  {
	CASSETTE_LOADABLE_WIDGET_0_PROPERTY,
	CASSETTE_LOADABLE_WIDGET_RESULT_WIDGET_PROPERTY,
	CASSETTE_LOADABLE_WIDGET_ERROR_WIDGET_PROPERTY,
	CASSETTE_LOADABLE_WIDGET_NUM_PROPERTIES
};
static GParamSpec* cassette_loadable_widget_properties[CASSETTE_LOADABLE_WIDGET_NUM_PROPERTIES];

struct _CassetteLoadableWidget {
	AdwBin parent_instance;
	CassetteLoadableWidgetPrivate * priv;
};

struct _CassetteLoadableWidgetClass {
	AdwBinClass parent_class;
};

struct _CassetteLoadableWidgetPrivate {
	GtkStack* main_stack;
	AdwBin* result_bin;
	AdwBin* error_bin;
};

static gint CassetteLoadableWidget_private_offset;
static gpointer cassette_loadable_widget_parent_class = NULL;

VALA_EXTERN GType cassette_loadable_widget_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteLoadableWidget, g_object_unref)
VALA_EXTERN void cassette_loadable_widget_show_loading (CassetteLoadableWidget* self);
VALA_EXTERN void cassette_loadable_widget_show_result (CassetteLoadableWidget* self);
VALA_EXTERN void cassette_loadable_widget_show_error (CassetteLoadableWidget* self);
VALA_EXTERN CassetteLoadableWidget* cassette_loadable_widget_new (void);
VALA_EXTERN CassetteLoadableWidget* cassette_loadable_widget_construct (GType object_type);
VALA_EXTERN GtkWidget* cassette_loadable_widget_get_result_widget (CassetteLoadableWidget* self);
VALA_EXTERN void cassette_loadable_widget_set_result_widget (CassetteLoadableWidget* self,
                                                 GtkWidget* value);
VALA_EXTERN GtkWidget* cassette_loadable_widget_get_error_widget (CassetteLoadableWidget* self);
VALA_EXTERN void cassette_loadable_widget_set_error_widget (CassetteLoadableWidget* self,
                                                GtkWidget* value);
static void cassette_loadable_widget_finalize (GObject * obj);
static GType cassette_loadable_widget_get_type_once (void);
static void _vala_cassette_loadable_widget_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_cassette_loadable_widget_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);

static inline gpointer
cassette_loadable_widget_get_instance_private (CassetteLoadableWidget* self)
{
	return G_STRUCT_MEMBER_P (self, CassetteLoadableWidget_private_offset);
}

void
cassette_loadable_widget_show_loading (CassetteLoadableWidget* self)
{
	GtkStack* _tmp0_;
#line 47 "../src/widgets/loadable-widget.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/widgets/loadable-widget.vala"
	_tmp0_ = self->priv->main_stack;
#line 48 "../src/widgets/loadable-widget.vala"
	gtk_stack_set_visible_child_name (_tmp0_, "loading");
#line 122 "loadable-widget.c"
}

void
cassette_loadable_widget_show_result (CassetteLoadableWidget* self)
{
	GtkStack* _tmp0_;
#line 51 "../src/widgets/loadable-widget.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/widgets/loadable-widget.vala"
	_tmp0_ = self->priv->main_stack;
#line 52 "../src/widgets/loadable-widget.vala"
	gtk_stack_set_visible_child_name (_tmp0_, "result");
#line 135 "loadable-widget.c"
}

void
cassette_loadable_widget_show_error (CassetteLoadableWidget* self)
{
	GtkStack* _tmp0_;
#line 55 "../src/widgets/loadable-widget.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/widgets/loadable-widget.vala"
	_tmp0_ = self->priv->main_stack;
#line 56 "../src/widgets/loadable-widget.vala"
	gtk_stack_set_visible_child_name (_tmp0_, "error");
#line 148 "loadable-widget.c"
}

CassetteLoadableWidget*
cassette_loadable_widget_construct (GType object_type)
{
	CassetteLoadableWidget * self = NULL;
#line 20 "../src/widgets/loadable-widget.vala"
	self = (CassetteLoadableWidget*) g_object_new (object_type, NULL);
#line 20 "../src/widgets/loadable-widget.vala"
	return self;
#line 159 "loadable-widget.c"
}

CassetteLoadableWidget*
cassette_loadable_widget_new (void)
{
#line 20 "../src/widgets/loadable-widget.vala"
	return cassette_loadable_widget_construct (CASSETTE_TYPE_LOADABLE_WIDGET);
#line 167 "loadable-widget.c"
}

GtkWidget*
cassette_loadable_widget_get_result_widget (CassetteLoadableWidget* self)
{
	GtkWidget* result;
	AdwBin* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
#line 30 "../src/widgets/loadable-widget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/widgets/loadable-widget.vala"
	_tmp0_ = self->priv->result_bin;
#line 31 "../src/widgets/loadable-widget.vala"
	_tmp1_ = adw_bin_get_child (_tmp0_);
#line 31 "../src/widgets/loadable-widget.vala"
	_tmp2_ = _tmp1_;
#line 31 "../src/widgets/loadable-widget.vala"
	result = _tmp2_;
#line 31 "../src/widgets/loadable-widget.vala"
	return result;
#line 189 "loadable-widget.c"
}

void
cassette_loadable_widget_set_result_widget (CassetteLoadableWidget* self,
                                            GtkWidget* value)
{
	AdwBin* _tmp0_;
#line 33 "../src/widgets/loadable-widget.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/widgets/loadable-widget.vala"
	_tmp0_ = self->priv->result_bin;
#line 34 "../src/widgets/loadable-widget.vala"
	adw_bin_set_child (_tmp0_, value);
#line 33 "../src/widgets/loadable-widget.vala"
	g_object_notify_by_pspec ((GObject *) self, cassette_loadable_widget_properties[CASSETTE_LOADABLE_WIDGET_RESULT_WIDGET_PROPERTY]);
#line 205 "loadable-widget.c"
}

GtkWidget*
cassette_loadable_widget_get_error_widget (CassetteLoadableWidget* self)
{
	GtkWidget* result;
	AdwBin* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
#line 39 "../src/widgets/loadable-widget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../src/widgets/loadable-widget.vala"
	_tmp0_ = self->priv->error_bin;
#line 40 "../src/widgets/loadable-widget.vala"
	_tmp1_ = adw_bin_get_child (_tmp0_);
#line 40 "../src/widgets/loadable-widget.vala"
	_tmp2_ = _tmp1_;
#line 40 "../src/widgets/loadable-widget.vala"
	result = _tmp2_;
#line 40 "../src/widgets/loadable-widget.vala"
	return result;
#line 227 "loadable-widget.c"
}

void
cassette_loadable_widget_set_error_widget (CassetteLoadableWidget* self,
                                           GtkWidget* value)
{
	AdwBin* _tmp0_;
#line 42 "../src/widgets/loadable-widget.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/widgets/loadable-widget.vala"
	_tmp0_ = self->priv->error_bin;
#line 43 "../src/widgets/loadable-widget.vala"
	adw_bin_set_child (_tmp0_, value);
#line 42 "../src/widgets/loadable-widget.vala"
	g_object_notify_by_pspec ((GObject *) self, cassette_loadable_widget_properties[CASSETTE_LOADABLE_WIDGET_ERROR_WIDGET_PROPERTY]);
#line 243 "loadable-widget.c"
}

static void
cassette_loadable_widget_class_init (CassetteLoadableWidgetClass * klass,
                                     gpointer klass_data)
{
#line 20 "../src/widgets/loadable-widget.vala"
	cassette_loadable_widget_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/widgets/loadable-widget.vala"
	g_type_class_adjust_private_offset (klass, &CassetteLoadableWidget_private_offset);
#line 20 "../src/widgets/loadable-widget.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_cassette_loadable_widget_get_property;
#line 20 "../src/widgets/loadable-widget.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_cassette_loadable_widget_set_property;
#line 20 "../src/widgets/loadable-widget.vala"
	G_OBJECT_CLASS (klass)->finalize = cassette_loadable_widget_finalize;
#line 20 "../src/widgets/loadable-widget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_LOADABLE_WIDGET_RESULT_WIDGET_PROPERTY, cassette_loadable_widget_properties[CASSETTE_LOADABLE_WIDGET_RESULT_WIDGET_PROPERTY] = g_param_spec_object ("result-widget", "result-widget", "result-widget", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20 "../src/widgets/loadable-widget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_LOADABLE_WIDGET_ERROR_WIDGET_PROPERTY, cassette_loadable_widget_properties[CASSETTE_LOADABLE_WIDGET_ERROR_WIDGET_PROPERTY] = g_param_spec_object ("error-widget", "error-widget", "error-widget", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20 "../src/widgets/loadable-widget.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/space/rirusha/Cassette/ui/loadable-widget.ui");
#line 20 "../src/widgets/loadable-widget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "main_stack", FALSE, CassetteLoadableWidget_private_offset + G_STRUCT_OFFSET (CassetteLoadableWidgetPrivate, main_stack));
#line 20 "../src/widgets/loadable-widget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "result_bin", FALSE, CassetteLoadableWidget_private_offset + G_STRUCT_OFFSET (CassetteLoadableWidgetPrivate, result_bin));
#line 20 "../src/widgets/loadable-widget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "error_bin", FALSE, CassetteLoadableWidget_private_offset + G_STRUCT_OFFSET (CassetteLoadableWidgetPrivate, error_bin));
#line 272 "loadable-widget.c"
}

static void
cassette_loadable_widget_instance_init (CassetteLoadableWidget * self,
                                        gpointer klass)
{
#line 20 "../src/widgets/loadable-widget.vala"
	self->priv = cassette_loadable_widget_get_instance_private (self);
#line 20 "../src/widgets/loadable-widget.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 283 "loadable-widget.c"
}

static void
cassette_loadable_widget_finalize (GObject * obj)
{
	CassetteLoadableWidget * self;
#line 20 "../src/widgets/loadable-widget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CASSETTE_TYPE_LOADABLE_WIDGET, CassetteLoadableWidget);
#line 20 "../src/widgets/loadable-widget.vala"
	G_OBJECT_CLASS (cassette_loadable_widget_parent_class)->finalize (obj);
#line 294 "loadable-widget.c"
}

 G_GNUC_NO_INLINE static GType
cassette_loadable_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CassetteLoadableWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cassette_loadable_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CassetteLoadableWidget), 0, (GInstanceInitFunc) cassette_loadable_widget_instance_init, NULL };
	GType cassette_loadable_widget_type_id;
	cassette_loadable_widget_type_id = g_type_register_static (adw_bin_get_type (), "CassetteLoadableWidget", &g_define_type_info, 0);
	CassetteLoadableWidget_private_offset = g_type_add_instance_private (cassette_loadable_widget_type_id, sizeof (CassetteLoadableWidgetPrivate));
	return cassette_loadable_widget_type_id;
}

GType
cassette_loadable_widget_get_type (void)
{
	static gsize cassette_loadable_widget_type_id__once = 0;
	if (g_once_init_enter (&cassette_loadable_widget_type_id__once)) {
		GType cassette_loadable_widget_type_id;
		cassette_loadable_widget_type_id = cassette_loadable_widget_get_type_once ();
		g_once_init_leave (&cassette_loadable_widget_type_id__once, cassette_loadable_widget_type_id);
	}
	return cassette_loadable_widget_type_id__once;
}

static void
_vala_cassette_loadable_widget_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	CassetteLoadableWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CASSETTE_TYPE_LOADABLE_WIDGET, CassetteLoadableWidget);
#line 20 "../src/widgets/loadable-widget.vala"
	switch (property_id) {
#line 20 "../src/widgets/loadable-widget.vala"
		case CASSETTE_LOADABLE_WIDGET_RESULT_WIDGET_PROPERTY:
#line 20 "../src/widgets/loadable-widget.vala"
		g_value_set_object (value, cassette_loadable_widget_get_result_widget (self));
#line 20 "../src/widgets/loadable-widget.vala"
		break;
#line 20 "../src/widgets/loadable-widget.vala"
		case CASSETTE_LOADABLE_WIDGET_ERROR_WIDGET_PROPERTY:
#line 20 "../src/widgets/loadable-widget.vala"
		g_value_set_object (value, cassette_loadable_widget_get_error_widget (self));
#line 20 "../src/widgets/loadable-widget.vala"
		break;
#line 341 "loadable-widget.c"
		default:
#line 20 "../src/widgets/loadable-widget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/widgets/loadable-widget.vala"
		break;
#line 347 "loadable-widget.c"
	}
}

static void
_vala_cassette_loadable_widget_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	CassetteLoadableWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CASSETTE_TYPE_LOADABLE_WIDGET, CassetteLoadableWidget);
#line 20 "../src/widgets/loadable-widget.vala"
	switch (property_id) {
#line 20 "../src/widgets/loadable-widget.vala"
		case CASSETTE_LOADABLE_WIDGET_RESULT_WIDGET_PROPERTY:
#line 20 "../src/widgets/loadable-widget.vala"
		cassette_loadable_widget_set_result_widget (self, g_value_get_object (value));
#line 20 "../src/widgets/loadable-widget.vala"
		break;
#line 20 "../src/widgets/loadable-widget.vala"
		case CASSETTE_LOADABLE_WIDGET_ERROR_WIDGET_PROPERTY:
#line 20 "../src/widgets/loadable-widget.vala"
		cassette_loadable_widget_set_error_widget (self, g_value_get_object (value));
#line 20 "../src/widgets/loadable-widget.vala"
		break;
#line 373 "loadable-widget.c"
		default:
#line 20 "../src/widgets/loadable-widget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/widgets/loadable-widget.vala"
		break;
#line 379 "loadable-widget.c"
	}
}

