/* application-window.c generated by valac 0.56.18, the Vala compiler
 * generated from application-window.vala, do not modify */

/* Copyright 2023-2024 Vladimir Vaskov
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */
/*
 * Not using ``Adw.Breakpoint`` because
 * every breakpoint pass triggers map/unmap
 * that break some logic and laggy interface
 */

#include <adwaita.h>
#include <glib-object.h>
#include <glib.h>
#include <gtk/gtk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CASSETTE_TYPE_APPLICATION_WINDOW (cassette_application_window_get_type ())
#define CASSETTE_APPLICATION_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_TYPE_APPLICATION_WINDOW, CassetteApplicationWindow))
#define CASSETTE_APPLICATION_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_TYPE_APPLICATION_WINDOW, CassetteApplicationWindowClass))
#define CASSETTE_IS_APPLICATION_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_TYPE_APPLICATION_WINDOW))
#define CASSETTE_IS_APPLICATION_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_TYPE_APPLICATION_WINDOW))
#define CASSETTE_APPLICATION_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_TYPE_APPLICATION_WINDOW, CassetteApplicationWindowClass))

typedef struct _CassetteApplicationWindow CassetteApplicationWindow;
typedef struct _CassetteApplicationWindowClass CassetteApplicationWindowClass;
typedef struct _CassetteApplicationWindowPrivate CassetteApplicationWindowPrivate;
enum  {
	CASSETTE_APPLICATION_WINDOW_0_PROPERTY,
	CASSETTE_APPLICATION_WINDOW_SHRINK_EDGE_WIDTH_PROPERTY,
	CASSETTE_APPLICATION_WINDOW_IS_SHRINKED_PROPERTY,
	CASSETTE_APPLICATION_WINDOW_NUM_PROPERTIES
};
static GParamSpec* cassette_application_window_properties[CASSETTE_APPLICATION_WINDOW_NUM_PROPERTIES];
enum  {
	CASSETTE_APPLICATION_WINDOW_RESIZED_SIGNAL,
	CASSETTE_APPLICATION_WINDOW_NUM_SIGNALS
};
static guint cassette_application_window_signals[CASSETTE_APPLICATION_WINDOW_NUM_SIGNALS] = {0};

struct _CassetteApplicationWindow {
	AdwApplicationWindow parent_instance;
	CassetteApplicationWindowPrivate * priv;
};

struct _CassetteApplicationWindowClass {
	AdwApplicationWindowClass parent_class;
};

struct _CassetteApplicationWindowPrivate {
	gint _shrink_edge_width;
	gboolean _is_shrinked;
	gboolean first_resize;
};

static gint CassetteApplicationWindow_private_offset;
static gpointer cassette_application_window_parent_class = NULL;

VALA_EXTERN GType cassette_application_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteApplicationWindow, g_object_unref)
static void cassette_application_window_real_size_allocate (GtkWidget* base,
                                                     gint width,
                                                     gint height,
                                                     gint baseline);
VALA_EXTERN gint cassette_application_window_get_shrink_edge_width (CassetteApplicationWindow* self);
VALA_EXTERN gboolean cassette_application_window_get_is_shrinked (CassetteApplicationWindow* self);
VALA_EXTERN void cassette_application_window_set_is_shrinked (CassetteApplicationWindow* self,
                                                  gboolean value);
VALA_EXTERN CassetteApplicationWindow* cassette_application_window_new (void);
VALA_EXTERN CassetteApplicationWindow* cassette_application_window_construct (GType object_type);
VALA_EXTERN void cassette_application_window_set_shrink_edge_width (CassetteApplicationWindow* self,
                                                        gint value);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static void cassette_application_window_finalize (GObject * obj);
static GType cassette_application_window_get_type_once (void);
static void _vala_cassette_application_window_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_cassette_application_window_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);

static inline gpointer
cassette_application_window_get_instance_private (CassetteApplicationWindow* self)
{
	return G_STRUCT_MEMBER_P (self, CassetteApplicationWindow_private_offset);
}

static void
cassette_application_window_real_size_allocate (GtkWidget* base,
                                                gint width,
                                                gint height,
                                                gint baseline)
{
	CassetteApplicationWindow * self;
	gint _tmp0_;
#line 47 "../src/widgets/shrinkable/application-window.vala"
	self = (CassetteApplicationWindow*) base;
#line 48 "../src/widgets/shrinkable/application-window.vala"
	GTK_WIDGET_CLASS (cassette_application_window_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_application_window_get_type (), AdwApplicationWindow), width, height, baseline);
#line 50 "../src/widgets/shrinkable/application-window.vala"
	_tmp0_ = self->priv->_shrink_edge_width;
#line 50 "../src/widgets/shrinkable/application-window.vala"
	if (_tmp0_ != -1) {
#line 145 "application-window.c"
		gint _tmp1_;
#line 51 "../src/widgets/shrinkable/application-window.vala"
		_tmp1_ = self->priv->_shrink_edge_width;
#line 51 "../src/widgets/shrinkable/application-window.vala"
		if (width >= _tmp1_) {
#line 151 "application-window.c"
			gboolean _tmp2_ = FALSE;
			gboolean _tmp3_;
#line 52 "../src/widgets/shrinkable/application-window.vala"
			_tmp3_ = self->priv->_is_shrinked;
#line 52 "../src/widgets/shrinkable/application-window.vala"
			if (_tmp3_) {
#line 52 "../src/widgets/shrinkable/application-window.vala"
				_tmp2_ = TRUE;
#line 160 "application-window.c"
			} else {
#line 52 "../src/widgets/shrinkable/application-window.vala"
				_tmp2_ = self->priv->first_resize;
#line 164 "application-window.c"
			}
#line 52 "../src/widgets/shrinkable/application-window.vala"
			if (_tmp2_) {
#line 53 "../src/widgets/shrinkable/application-window.vala"
				cassette_application_window_set_is_shrinked (self, FALSE);
#line 170 "application-window.c"
			}
		} else {
			gboolean _tmp4_ = FALSE;
			gboolean _tmp5_;
#line 57 "../src/widgets/shrinkable/application-window.vala"
			_tmp5_ = self->priv->_is_shrinked;
#line 57 "../src/widgets/shrinkable/application-window.vala"
			if (!_tmp5_) {
#line 57 "../src/widgets/shrinkable/application-window.vala"
				_tmp4_ = TRUE;
#line 181 "application-window.c"
			} else {
#line 57 "../src/widgets/shrinkable/application-window.vala"
				_tmp4_ = self->priv->first_resize;
#line 185 "application-window.c"
			}
#line 57 "../src/widgets/shrinkable/application-window.vala"
			if (_tmp4_) {
#line 58 "../src/widgets/shrinkable/application-window.vala"
				cassette_application_window_set_is_shrinked (self, TRUE);
#line 191 "application-window.c"
			}
		}
#line 62 "../src/widgets/shrinkable/application-window.vala"
		self->priv->first_resize = FALSE;
#line 196 "application-window.c"
	}
#line 65 "../src/widgets/shrinkable/application-window.vala"
	g_signal_emit (self, cassette_application_window_signals[CASSETTE_APPLICATION_WINDOW_RESIZED_SIGNAL], 0, width, height);
#line 200 "application-window.c"
}

CassetteApplicationWindow*
cassette_application_window_construct (GType object_type)
{
	CassetteApplicationWindow * self = NULL;
#line 25 "../src/widgets/shrinkable/application-window.vala"
	self = (CassetteApplicationWindow*) g_object_new (object_type, NULL);
#line 25 "../src/widgets/shrinkable/application-window.vala"
	return self;
#line 211 "application-window.c"
}

CassetteApplicationWindow*
cassette_application_window_new (void)
{
#line 25 "../src/widgets/shrinkable/application-window.vala"
	return cassette_application_window_construct (CASSETTE_TYPE_APPLICATION_WINDOW);
#line 219 "application-window.c"
}

gint
cassette_application_window_get_shrink_edge_width (CassetteApplicationWindow* self)
{
	gint result;
#line 38 "../src/widgets/shrinkable/application-window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 38 "../src/widgets/shrinkable/application-window.vala"
	result = self->priv->_shrink_edge_width;
#line 38 "../src/widgets/shrinkable/application-window.vala"
	return result;
#line 232 "application-window.c"
}

void
cassette_application_window_set_shrink_edge_width (CassetteApplicationWindow* self,
                                                   gint value)
{
	gint old_value;
#line 38 "../src/widgets/shrinkable/application-window.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/widgets/shrinkable/application-window.vala"
	old_value = cassette_application_window_get_shrink_edge_width (self);
#line 38 "../src/widgets/shrinkable/application-window.vala"
	if (old_value != value) {
#line 38 "../src/widgets/shrinkable/application-window.vala"
		self->priv->_shrink_edge_width = value;
#line 38 "../src/widgets/shrinkable/application-window.vala"
		g_object_notify_by_pspec ((GObject *) self, cassette_application_window_properties[CASSETTE_APPLICATION_WINDOW_SHRINK_EDGE_WIDTH_PROPERTY]);
#line 250 "application-window.c"
	}
}

gboolean
cassette_application_window_get_is_shrinked (CassetteApplicationWindow* self)
{
	gboolean result;
#line 43 "../src/widgets/shrinkable/application-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 43 "../src/widgets/shrinkable/application-window.vala"
	result = self->priv->_is_shrinked;
#line 43 "../src/widgets/shrinkable/application-window.vala"
	return result;
#line 264 "application-window.c"
}

void
cassette_application_window_set_is_shrinked (CassetteApplicationWindow* self,
                                             gboolean value)
{
	gboolean old_value;
#line 43 "../src/widgets/shrinkable/application-window.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/widgets/shrinkable/application-window.vala"
	old_value = cassette_application_window_get_is_shrinked (self);
#line 43 "../src/widgets/shrinkable/application-window.vala"
	if (old_value != value) {
#line 43 "../src/widgets/shrinkable/application-window.vala"
		self->priv->_is_shrinked = value;
#line 43 "../src/widgets/shrinkable/application-window.vala"
		g_object_notify_by_pspec ((GObject *) self, cassette_application_window_properties[CASSETTE_APPLICATION_WINDOW_IS_SHRINKED_PROPERTY]);
#line 282 "application-window.c"
	}
}

static void
g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 25 "../src/widgets/shrinkable/application-window.vala"
	g_return_if_fail (n_param_values == 3);
#line 25 "../src/widgets/shrinkable/application-window.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 25 "../src/widgets/shrinkable/application-window.vala"
		data1 = closure->data;
#line 25 "../src/widgets/shrinkable/application-window.vala"
		data2 = param_values->data[0].v_pointer;
#line 308 "application-window.c"
	} else {
#line 25 "../src/widgets/shrinkable/application-window.vala"
		data1 = param_values->data[0].v_pointer;
#line 25 "../src/widgets/shrinkable/application-window.vala"
		data2 = closure->data;
#line 314 "application-window.c"
	}
#line 25 "../src/widgets/shrinkable/application-window.vala"
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 25 "../src/widgets/shrinkable/application-window.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 320 "application-window.c"
}

static void
cassette_application_window_class_init (CassetteApplicationWindowClass * klass,
                                        gpointer klass_data)
{
#line 25 "../src/widgets/shrinkable/application-window.vala"
	cassette_application_window_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/widgets/shrinkable/application-window.vala"
	g_type_class_adjust_private_offset (klass, &CassetteApplicationWindow_private_offset);
#line 25 "../src/widgets/shrinkable/application-window.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) cassette_application_window_real_size_allocate;
#line 25 "../src/widgets/shrinkable/application-window.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_cassette_application_window_get_property;
#line 25 "../src/widgets/shrinkable/application-window.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_cassette_application_window_set_property;
#line 25 "../src/widgets/shrinkable/application-window.vala"
	G_OBJECT_CLASS (klass)->finalize = cassette_application_window_finalize;
#line 339 "application-window.c"
	/**
	     * Width value, that triggers ``is-shrinked`` changes
	     */
#line 25 "../src/widgets/shrinkable/application-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_APPLICATION_WINDOW_SHRINK_EDGE_WIDTH_PROPERTY, cassette_application_window_properties[CASSETTE_APPLICATION_WINDOW_SHRINK_EDGE_WIDTH_PROPERTY] = g_param_spec_int ("shrink-edge-width", "shrink-edge-width", "shrink-edge-width", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 345 "application-window.c"
	/**
	     * Is widget should shrinked or not
	     */
#line 25 "../src/widgets/shrinkable/application-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_APPLICATION_WINDOW_IS_SHRINKED_PROPERTY, cassette_application_window_properties[CASSETTE_APPLICATION_WINDOW_IS_SHRINKED_PROPERTY] = g_param_spec_boolean ("is-shrinked", "is-shrinked", "is-shrinked", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 351 "application-window.c"
	/**
	     * Size changed.
	     *
	     * @param width     new width of window
	     * @param height    new height of window
	     */
#line 25 "../src/widgets/shrinkable/application-window.vala"
	cassette_application_window_signals[CASSETTE_APPLICATION_WINDOW_RESIZED_SIGNAL] = g_signal_new ("resized", CASSETTE_TYPE_APPLICATION_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
#line 360 "application-window.c"
}

static void
cassette_application_window_instance_init (CassetteApplicationWindow * self,
                                           gpointer klass)
{
#line 25 "../src/widgets/shrinkable/application-window.vala"
	self->priv = cassette_application_window_get_instance_private (self);
#line 38 "../src/widgets/shrinkable/application-window.vala"
	self->priv->_shrink_edge_width = -1;
#line 43 "../src/widgets/shrinkable/application-window.vala"
	self->priv->_is_shrinked = FALSE;
#line 45 "../src/widgets/shrinkable/application-window.vala"
	self->priv->first_resize = TRUE;
#line 375 "application-window.c"
}

static void
cassette_application_window_finalize (GObject * obj)
{
	CassetteApplicationWindow * self;
#line 25 "../src/widgets/shrinkable/application-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CASSETTE_TYPE_APPLICATION_WINDOW, CassetteApplicationWindow);
#line 25 "../src/widgets/shrinkable/application-window.vala"
	G_OBJECT_CLASS (cassette_application_window_parent_class)->finalize (obj);
#line 386 "application-window.c"
}

 G_GNUC_NO_INLINE static GType
cassette_application_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CassetteApplicationWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cassette_application_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CassetteApplicationWindow), 0, (GInstanceInitFunc) cassette_application_window_instance_init, NULL };
	GType cassette_application_window_type_id;
	cassette_application_window_type_id = g_type_register_static (adw_application_window_get_type (), "CassetteApplicationWindow", &g_define_type_info, 0);
	CassetteApplicationWindow_private_offset = g_type_add_instance_private (cassette_application_window_type_id, sizeof (CassetteApplicationWindowPrivate));
	return cassette_application_window_type_id;
}

GType
cassette_application_window_get_type (void)
{
	static gsize cassette_application_window_type_id__once = 0;
	if (g_once_init_enter (&cassette_application_window_type_id__once)) {
		GType cassette_application_window_type_id;
		cassette_application_window_type_id = cassette_application_window_get_type_once ();
		g_once_init_leave (&cassette_application_window_type_id__once, cassette_application_window_type_id);
	}
	return cassette_application_window_type_id__once;
}

static void
_vala_cassette_application_window_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	CassetteApplicationWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CASSETTE_TYPE_APPLICATION_WINDOW, CassetteApplicationWindow);
#line 25 "../src/widgets/shrinkable/application-window.vala"
	switch (property_id) {
#line 25 "../src/widgets/shrinkable/application-window.vala"
		case CASSETTE_APPLICATION_WINDOW_SHRINK_EDGE_WIDTH_PROPERTY:
#line 25 "../src/widgets/shrinkable/application-window.vala"
		g_value_set_int (value, cassette_application_window_get_shrink_edge_width (self));
#line 25 "../src/widgets/shrinkable/application-window.vala"
		break;
#line 25 "../src/widgets/shrinkable/application-window.vala"
		case CASSETTE_APPLICATION_WINDOW_IS_SHRINKED_PROPERTY:
#line 25 "../src/widgets/shrinkable/application-window.vala"
		g_value_set_boolean (value, cassette_application_window_get_is_shrinked (self));
#line 25 "../src/widgets/shrinkable/application-window.vala"
		break;
#line 433 "application-window.c"
		default:
#line 25 "../src/widgets/shrinkable/application-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/widgets/shrinkable/application-window.vala"
		break;
#line 439 "application-window.c"
	}
}

static void
_vala_cassette_application_window_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	CassetteApplicationWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CASSETTE_TYPE_APPLICATION_WINDOW, CassetteApplicationWindow);
#line 25 "../src/widgets/shrinkable/application-window.vala"
	switch (property_id) {
#line 25 "../src/widgets/shrinkable/application-window.vala"
		case CASSETTE_APPLICATION_WINDOW_SHRINK_EDGE_WIDTH_PROPERTY:
#line 25 "../src/widgets/shrinkable/application-window.vala"
		cassette_application_window_set_shrink_edge_width (self, g_value_get_int (value));
#line 25 "../src/widgets/shrinkable/application-window.vala"
		break;
#line 25 "../src/widgets/shrinkable/application-window.vala"
		case CASSETTE_APPLICATION_WINDOW_IS_SHRINKED_PROPERTY:
#line 25 "../src/widgets/shrinkable/application-window.vala"
		cassette_application_window_set_is_shrinked (self, g_value_get_boolean (value));
#line 25 "../src/widgets/shrinkable/application-window.vala"
		break;
#line 465 "application-window.c"
		default:
#line 25 "../src/widgets/shrinkable/application-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/widgets/shrinkable/application-window.vala"
		break;
#line 471 "application-window.c"
	}
}

