/* abstract-base.c generated by valac 0.56.18, the Vala compiler
 * generated from abstract-base.vala, do not modify */

/* Copyright 2023-2024 Vladimir Vaskov
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CASSETTE_TYPE_BASE_VIEW (cassette_base_view_get_type ())
#define CASSETTE_BASE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_TYPE_BASE_VIEW, CassetteBaseView))
#define CASSETTE_BASE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_TYPE_BASE_VIEW, CassetteBaseViewClass))
#define CASSETTE_IS_BASE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_TYPE_BASE_VIEW))
#define CASSETTE_IS_BASE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_TYPE_BASE_VIEW))
#define CASSETTE_BASE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_TYPE_BASE_VIEW, CassetteBaseViewClass))

typedef struct _CassetteBaseView CassetteBaseView;
typedef struct _CassetteBaseViewClass CassetteBaseViewClass;
typedef struct _CassetteBaseViewPrivate CassetteBaseViewPrivate;

#define CASSETTE_TYPE_ABSTRACT_LOADABLE_PAGE (cassette_abstract_loadable_page_get_type ())
#define CASSETTE_ABSTRACT_LOADABLE_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_TYPE_ABSTRACT_LOADABLE_PAGE, CassetteAbstractLoadablePage))
#define CASSETTE_ABSTRACT_LOADABLE_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_TYPE_ABSTRACT_LOADABLE_PAGE, CassetteAbstractLoadablePageClass))
#define CASSETTE_IS_ABSTRACT_LOADABLE_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_TYPE_ABSTRACT_LOADABLE_PAGE))
#define CASSETTE_IS_ABSTRACT_LOADABLE_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_TYPE_ABSTRACT_LOADABLE_PAGE))
#define CASSETTE_ABSTRACT_LOADABLE_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_TYPE_ABSTRACT_LOADABLE_PAGE, CassetteAbstractLoadablePageClass))

typedef struct _CassetteAbstractLoadablePage CassetteAbstractLoadablePage;
typedef struct _CassetteAbstractLoadablePageClass CassetteAbstractLoadablePageClass;

#define CASSETTE_TYPE_PAGE_ROOT (cassette_page_root_get_type ())
#define CASSETTE_PAGE_ROOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_TYPE_PAGE_ROOT, CassettePageRoot))
#define CASSETTE_PAGE_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_TYPE_PAGE_ROOT, CassettePageRootClass))
#define CASSETTE_IS_PAGE_ROOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_TYPE_PAGE_ROOT))
#define CASSETTE_IS_PAGE_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_TYPE_PAGE_ROOT))
#define CASSETTE_PAGE_ROOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_TYPE_PAGE_ROOT, CassettePageRootClass))

typedef struct _CassettePageRoot CassettePageRoot;
typedef struct _CassettePageRootClass CassettePageRootClass;
enum  {
	CASSETTE_BASE_VIEW_0_PROPERTY,
	CASSETTE_BASE_VIEW_CAN_REFRESH_PROPERTY,
	CASSETTE_BASE_VIEW_ROOT_VIEW_PROPERTY,
	CASSETTE_BASE_VIEW_NUM_PROPERTIES
};
static GParamSpec* cassette_base_view_properties[CASSETTE_BASE_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _CassetteBaseViewFirstShowData CassetteBaseViewFirstShowData;
typedef struct _CassetteBaseViewRefreshData CassetteBaseViewRefreshData;
enum  {
	CASSETTE_BASE_VIEW_SHOW_READY_SIGNAL,
	CASSETTE_BASE_VIEW_NUM_SIGNALS
};
static guint cassette_base_view_signals[CASSETTE_BASE_VIEW_NUM_SIGNALS] = {0};

struct _CassetteBaseView {
	AdwBin parent_instance;
	CassetteBaseViewPrivate * priv;
};

struct _CassetteBaseViewClass {
	AdwBinClass parent_class;
	void (*try_load_from_web) (CassetteBaseView* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gint (*try_load_from_web_finish) (CassetteBaseView* self, GAsyncResult* _res_);
	void (*try_load_from_cache) (CassetteBaseView* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*try_load_from_cache_finish) (CassetteBaseView* self, GAsyncResult* _res_);
	void (*first_show) (CassetteBaseView* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*first_show_finish) (CassetteBaseView* self, GAsyncResult* _res_);
	void (*refresh) (CassetteBaseView* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*refresh_finish) (CassetteBaseView* self, GAsyncResult* _res_);
	gboolean (*get_can_refresh) (CassetteBaseView* self);
};

struct _CassetteBaseViewPrivate {
	gboolean _can_refresh;
	CassettePageRoot* _root_view;
};

struct _CassetteBaseViewFirstShowData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	CassetteBaseView* self;
	gboolean cache_is_success;
	gint soup_code;
	CassettePageRoot* _tmp0_;
};

struct _CassetteBaseViewRefreshData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	CassetteBaseView* self;
	gint soup_code;
	gboolean cache_is_success;
	CassettePageRoot* _tmp0_;
};

static gint CassetteBaseView_private_offset;
static gpointer cassette_base_view_parent_class = NULL;

VALA_EXTERN GType cassette_base_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteBaseView, g_object_unref)
VALA_EXTERN GType cassette_abstract_loadable_page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteAbstractLoadablePage, g_object_unref)
VALA_EXTERN GType cassette_page_root_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassettePageRoot, g_object_unref)
VALA_EXTERN void cassette_base_view_first_show (CassetteBaseView* self,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
VALA_EXTERN void cassette_base_view_first_show_finish (CassetteBaseView* self,
                                           GAsyncResult* _res_);
VALA_EXTERN void cassette_base_view_refresh (CassetteBaseView* self,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
VALA_EXTERN void cassette_base_view_refresh_finish (CassetteBaseView* self,
                                        GAsyncResult* _res_);
VALA_EXTERN gboolean cassette_base_view_get_can_refresh (CassetteBaseView* self);
VALA_EXTERN void cassette_base_view_try_load_from_web (CassetteBaseView* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
VALA_EXTERN gint cassette_base_view_try_load_from_web_finish (CassetteBaseView* self,
                                                  GAsyncResult* _res_);
VALA_EXTERN void cassette_base_view_try_load_from_cache (CassetteBaseView* self,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
VALA_EXTERN gboolean cassette_base_view_try_load_from_cache_finish (CassetteBaseView* self,
                                                        GAsyncResult* _res_);
static void cassette_base_view_real_first_show_data_free (gpointer _data);
static void cassette_base_view_real_first_show (CassetteBaseView* self,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
static gboolean cassette_base_view_real_first_show_co (CassetteBaseViewFirstShowData* _data_);
static void cassette_base_view_first_show_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_);
VALA_EXTERN CassettePageRoot* cassette_base_view_get_root_view (CassetteBaseView* self);
VALA_EXTERN void cassette_page_root_show_error (CassettePageRoot* self,
                                    CassetteBaseView* base_view,
                                    gint code);
static void cassette_base_view_real_refresh_data_free (gpointer _data);
static void cassette_base_view_real_refresh (CassetteBaseView* self,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static gboolean cassette_base_view_real_refresh_co (CassetteBaseViewRefreshData* _data_);
static void cassette_base_view_refresh_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_);
VALA_EXTERN CassetteBaseView* cassette_base_view_construct (GType object_type);
VALA_EXTERN void cassette_base_view_set_root_view (CassetteBaseView* self,
                                       CassettePageRoot* value);
static void cassette_base_view_finalize (GObject * obj);
static GType cassette_base_view_get_type_once (void);
static void _vala_cassette_base_view_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_cassette_base_view_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);

static inline gpointer
cassette_base_view_get_instance_private (CassetteBaseView* self)
{
	return G_STRUCT_MEMBER_P (self, CassetteBaseView_private_offset);
}

void
cassette_base_view_try_load_from_web (CassetteBaseView* self,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	CassetteBaseViewClass* _klass_;
#line 20 "../src/widgets/views/abstract-base.vala"
	_klass_ = CASSETTE_BASE_VIEW_GET_CLASS (self);
#line 20 "../src/widgets/views/abstract-base.vala"
	if (_klass_->try_load_from_web) {
#line 20 "../src/widgets/views/abstract-base.vala"
		_klass_->try_load_from_web (self, _callback_, _user_data_);
#line 219 "abstract-base.c"
	}
}

gint
cassette_base_view_try_load_from_web_finish (CassetteBaseView* self,
                                             GAsyncResult* _res_)
{
	CassetteBaseViewClass* _klass_;
#line 20 "../src/widgets/views/abstract-base.vala"
	_klass_ = CASSETTE_BASE_VIEW_GET_CLASS (self);
#line 20 "../src/widgets/views/abstract-base.vala"
	if (_klass_->try_load_from_web_finish) {
#line 20 "../src/widgets/views/abstract-base.vala"
		return _klass_->try_load_from_web_finish (self, _res_);
#line 234 "abstract-base.c"
	}
#line 20 "../src/widgets/views/abstract-base.vala"
	return -1;
#line 238 "abstract-base.c"
}

void
cassette_base_view_try_load_from_cache (CassetteBaseView* self,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	CassetteBaseViewClass* _klass_;
#line 20 "../src/widgets/views/abstract-base.vala"
	_klass_ = CASSETTE_BASE_VIEW_GET_CLASS (self);
#line 20 "../src/widgets/views/abstract-base.vala"
	if (_klass_->try_load_from_cache) {
#line 20 "../src/widgets/views/abstract-base.vala"
		_klass_->try_load_from_cache (self, _callback_, _user_data_);
#line 253 "abstract-base.c"
	}
}

gboolean
cassette_base_view_try_load_from_cache_finish (CassetteBaseView* self,
                                               GAsyncResult* _res_)
{
	CassetteBaseViewClass* _klass_;
#line 20 "../src/widgets/views/abstract-base.vala"
	_klass_ = CASSETTE_BASE_VIEW_GET_CLASS (self);
#line 20 "../src/widgets/views/abstract-base.vala"
	if (_klass_->try_load_from_cache_finish) {
#line 20 "../src/widgets/views/abstract-base.vala"
		return _klass_->try_load_from_cache_finish (self, _res_);
#line 268 "abstract-base.c"
	}
#line 20 "../src/widgets/views/abstract-base.vala"
	return FALSE;
#line 272 "abstract-base.c"
}

static void
cassette_base_view_real_first_show_data_free (gpointer _data)
{
	CassetteBaseViewFirstShowData* _data_;
	_data_ = _data;
#line 20 "../src/widgets/views/abstract-base.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/widgets/views/abstract-base.vala"
	g_slice_free (CassetteBaseViewFirstShowData, _data_);
#line 284 "abstract-base.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 20 "../src/widgets/views/abstract-base.vala"
	return self ? g_object_ref (self) : NULL;
#line 292 "abstract-base.c"
}

static void
cassette_base_view_real_first_show (CassetteBaseView* self,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	CassetteBaseViewFirstShowData* _data_;
	CassetteBaseView* _tmp0_;
#line 20 "../src/widgets/views/abstract-base.vala"
	_data_ = g_slice_new0 (CassetteBaseViewFirstShowData);
#line 20 "../src/widgets/views/abstract-base.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/widgets/views/abstract-base.vala"
	g_task_set_task_data (_data_->_async_result, _data_, cassette_base_view_real_first_show_data_free);
#line 20 "../src/widgets/views/abstract-base.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/widgets/views/abstract-base.vala"
	_data_->self = _tmp0_;
#line 20 "../src/widgets/views/abstract-base.vala"
	cassette_base_view_real_first_show_co (_data_);
#line 314 "abstract-base.c"
}

static void
cassette_base_view_real_first_show_finish (CassetteBaseView* self,
                                           GAsyncResult* _res_)
{
	CassetteBaseViewFirstShowData* _data_;
#line 20 "../src/widgets/views/abstract-base.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 324 "abstract-base.c"
}

static void
cassette_base_view_first_show_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_)
{
	CassetteBaseViewFirstShowData* _data_;
#line 33 "../src/widgets/views/abstract-base.vala"
	_data_ = _user_data_;
#line 33 "../src/widgets/views/abstract-base.vala"
	_data_->_source_object_ = source_object;
#line 33 "../src/widgets/views/abstract-base.vala"
	_data_->_res_ = _res_;
#line 33 "../src/widgets/views/abstract-base.vala"
	cassette_base_view_real_first_show_co (_data_);
#line 341 "abstract-base.c"
}

static gboolean
cassette_base_view_real_first_show_co (CassetteBaseViewFirstShowData* _data_)
{
#line 32 "../src/widgets/views/abstract-base.vala"
	switch (_data_->_state_) {
#line 32 "../src/widgets/views/abstract-base.vala"
		case 0:
#line 351 "abstract-base.c"
		goto _state_0;
#line 32 "../src/widgets/views/abstract-base.vala"
		case 1:
#line 355 "abstract-base.c"
		goto _state_1;
#line 32 "../src/widgets/views/abstract-base.vala"
		case 2:
#line 359 "abstract-base.c"
		goto _state_2;
		default:
#line 32 "../src/widgets/views/abstract-base.vala"
		g_assert_not_reached ();
#line 364 "abstract-base.c"
	}
	_state_0:
#line 33 "../src/widgets/views/abstract-base.vala"
	_data_->_state_ = 1;
#line 33 "../src/widgets/views/abstract-base.vala"
	cassette_base_view_try_load_from_cache (_data_->self, cassette_base_view_first_show_ready, _data_);
#line 33 "../src/widgets/views/abstract-base.vala"
	return FALSE;
#line 373 "abstract-base.c"
	_state_1:
#line 33 "../src/widgets/views/abstract-base.vala"
	_data_->cache_is_success = cassette_base_view_try_load_from_cache_finish (_data_->self, _data_->_res_);
#line 34 "../src/widgets/views/abstract-base.vala"
	_data_->_state_ = 2;
#line 34 "../src/widgets/views/abstract-base.vala"
	cassette_base_view_try_load_from_web (_data_->self, cassette_base_view_first_show_ready, _data_);
#line 34 "../src/widgets/views/abstract-base.vala"
	return FALSE;
#line 383 "abstract-base.c"
	_state_2:
#line 34 "../src/widgets/views/abstract-base.vala"
	_data_->soup_code = cassette_base_view_try_load_from_web_finish (_data_->self, _data_->_res_);
#line 35 "../src/widgets/views/abstract-base.vala"
	if (!_data_->cache_is_success) {
#line 36 "../src/widgets/views/abstract-base.vala"
		if (_data_->soup_code != -1) {
#line 37 "../src/widgets/views/abstract-base.vala"
			_data_->_tmp0_ = _data_->self->priv->_root_view;
#line 37 "../src/widgets/views/abstract-base.vala"
			cassette_page_root_show_error (_data_->_tmp0_, _data_->self, _data_->soup_code);
#line 395 "abstract-base.c"
		}
	}
#line 32 "../src/widgets/views/abstract-base.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 32 "../src/widgets/views/abstract-base.vala"
	if (_data_->_state_ != 0) {
#line 32 "../src/widgets/views/abstract-base.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 32 "../src/widgets/views/abstract-base.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 406 "abstract-base.c"
		}
	}
#line 32 "../src/widgets/views/abstract-base.vala"
	g_object_unref (_data_->_async_result);
#line 32 "../src/widgets/views/abstract-base.vala"
	return FALSE;
#line 413 "abstract-base.c"
}

void
cassette_base_view_first_show (CassetteBaseView* self,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	CassetteBaseViewClass* _klass_;
#line 20 "../src/widgets/views/abstract-base.vala"
	_klass_ = CASSETTE_BASE_VIEW_GET_CLASS (self);
#line 20 "../src/widgets/views/abstract-base.vala"
	if (_klass_->first_show) {
#line 20 "../src/widgets/views/abstract-base.vala"
		_klass_->first_show (self, _callback_, _user_data_);
#line 428 "abstract-base.c"
	}
}

void
cassette_base_view_first_show_finish (CassetteBaseView* self,
                                      GAsyncResult* _res_)
{
	CassetteBaseViewClass* _klass_;
#line 20 "../src/widgets/views/abstract-base.vala"
	_klass_ = CASSETTE_BASE_VIEW_GET_CLASS (self);
#line 20 "../src/widgets/views/abstract-base.vala"
	if (_klass_->first_show_finish) {
#line 20 "../src/widgets/views/abstract-base.vala"
		_klass_->first_show_finish (self, _res_);
#line 443 "abstract-base.c"
	}
}

static void
cassette_base_view_real_refresh_data_free (gpointer _data)
{
	CassetteBaseViewRefreshData* _data_;
	_data_ = _data;
#line 20 "../src/widgets/views/abstract-base.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/widgets/views/abstract-base.vala"
	g_slice_free (CassetteBaseViewRefreshData, _data_);
#line 456 "abstract-base.c"
}

static void
cassette_base_view_real_refresh (CassetteBaseView* self,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	CassetteBaseViewRefreshData* _data_;
	CassetteBaseView* _tmp0_;
#line 20 "../src/widgets/views/abstract-base.vala"
	_data_ = g_slice_new0 (CassetteBaseViewRefreshData);
#line 20 "../src/widgets/views/abstract-base.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/widgets/views/abstract-base.vala"
	g_task_set_task_data (_data_->_async_result, _data_, cassette_base_view_real_refresh_data_free);
#line 20 "../src/widgets/views/abstract-base.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/widgets/views/abstract-base.vala"
	_data_->self = _tmp0_;
#line 20 "../src/widgets/views/abstract-base.vala"
	cassette_base_view_real_refresh_co (_data_);
#line 478 "abstract-base.c"
}

static void
cassette_base_view_real_refresh_finish (CassetteBaseView* self,
                                        GAsyncResult* _res_)
{
	CassetteBaseViewRefreshData* _data_;
#line 20 "../src/widgets/views/abstract-base.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 488 "abstract-base.c"
}

static void
cassette_base_view_refresh_ready (GObject* source_object,
                                  GAsyncResult* _res_,
                                  gpointer _user_data_)
{
	CassetteBaseViewRefreshData* _data_;
#line 43 "../src/widgets/views/abstract-base.vala"
	_data_ = _user_data_;
#line 43 "../src/widgets/views/abstract-base.vala"
	_data_->_source_object_ = source_object;
#line 43 "../src/widgets/views/abstract-base.vala"
	_data_->_res_ = _res_;
#line 43 "../src/widgets/views/abstract-base.vala"
	cassette_base_view_real_refresh_co (_data_);
#line 505 "abstract-base.c"
}

static gboolean
cassette_base_view_real_refresh_co (CassetteBaseViewRefreshData* _data_)
{
#line 42 "../src/widgets/views/abstract-base.vala"
	switch (_data_->_state_) {
#line 42 "../src/widgets/views/abstract-base.vala"
		case 0:
#line 515 "abstract-base.c"
		goto _state_0;
#line 42 "../src/widgets/views/abstract-base.vala"
		case 1:
#line 519 "abstract-base.c"
		goto _state_1;
#line 42 "../src/widgets/views/abstract-base.vala"
		case 2:
#line 523 "abstract-base.c"
		goto _state_2;
		default:
#line 42 "../src/widgets/views/abstract-base.vala"
		g_assert_not_reached ();
#line 528 "abstract-base.c"
	}
	_state_0:
#line 43 "../src/widgets/views/abstract-base.vala"
	_data_->_state_ = 1;
#line 43 "../src/widgets/views/abstract-base.vala"
	cassette_base_view_try_load_from_web (_data_->self, cassette_base_view_refresh_ready, _data_);
#line 43 "../src/widgets/views/abstract-base.vala"
	return FALSE;
#line 537 "abstract-base.c"
	_state_1:
#line 43 "../src/widgets/views/abstract-base.vala"
	_data_->soup_code = cassette_base_view_try_load_from_web_finish (_data_->self, _data_->_res_);
#line 44 "../src/widgets/views/abstract-base.vala"
	if (_data_->soup_code != -1) {
#line 45 "../src/widgets/views/abstract-base.vala"
		_data_->_state_ = 2;
#line 45 "../src/widgets/views/abstract-base.vala"
		cassette_base_view_try_load_from_cache (_data_->self, cassette_base_view_refresh_ready, _data_);
#line 45 "../src/widgets/views/abstract-base.vala"
		return FALSE;
#line 549 "abstract-base.c"
		_state_2:
#line 45 "../src/widgets/views/abstract-base.vala"
		_data_->cache_is_success = cassette_base_view_try_load_from_cache_finish (_data_->self, _data_->_res_);
#line 46 "../src/widgets/views/abstract-base.vala"
		if (!_data_->cache_is_success) {
#line 47 "../src/widgets/views/abstract-base.vala"
			_data_->_tmp0_ = _data_->self->priv->_root_view;
#line 47 "../src/widgets/views/abstract-base.vala"
			cassette_page_root_show_error (_data_->_tmp0_, _data_->self, _data_->soup_code);
#line 559 "abstract-base.c"
		}
	}
#line 42 "../src/widgets/views/abstract-base.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 42 "../src/widgets/views/abstract-base.vala"
	if (_data_->_state_ != 0) {
#line 42 "../src/widgets/views/abstract-base.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 42 "../src/widgets/views/abstract-base.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 570 "abstract-base.c"
		}
	}
#line 42 "../src/widgets/views/abstract-base.vala"
	g_object_unref (_data_->_async_result);
#line 42 "../src/widgets/views/abstract-base.vala"
	return FALSE;
#line 577 "abstract-base.c"
}

void
cassette_base_view_refresh (CassetteBaseView* self,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	CassetteBaseViewClass* _klass_;
#line 20 "../src/widgets/views/abstract-base.vala"
	_klass_ = CASSETTE_BASE_VIEW_GET_CLASS (self);
#line 20 "../src/widgets/views/abstract-base.vala"
	if (_klass_->refresh) {
#line 20 "../src/widgets/views/abstract-base.vala"
		_klass_->refresh (self, _callback_, _user_data_);
#line 592 "abstract-base.c"
	}
}

void
cassette_base_view_refresh_finish (CassetteBaseView* self,
                                   GAsyncResult* _res_)
{
	CassetteBaseViewClass* _klass_;
#line 20 "../src/widgets/views/abstract-base.vala"
	_klass_ = CASSETTE_BASE_VIEW_GET_CLASS (self);
#line 20 "../src/widgets/views/abstract-base.vala"
	if (_klass_->refresh_finish) {
#line 20 "../src/widgets/views/abstract-base.vala"
		_klass_->refresh_finish (self, _res_);
#line 607 "abstract-base.c"
	}
}

CassetteBaseView*
cassette_base_view_construct (GType object_type)
{
	CassetteBaseView * self = NULL;
#line 20 "../src/widgets/views/abstract-base.vala"
	self = (CassetteBaseView*) g_object_new (object_type, NULL);
#line 20 "../src/widgets/views/abstract-base.vala"
	return self;
#line 619 "abstract-base.c"
}

gboolean
cassette_base_view_get_can_refresh (CassetteBaseView* self)
{
	CassetteBaseViewClass* _klass_;
#line 22 "../src/widgets/views/abstract-base.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 22 "../src/widgets/views/abstract-base.vala"
	_klass_ = CASSETTE_BASE_VIEW_GET_CLASS (self);
#line 22 "../src/widgets/views/abstract-base.vala"
	if (_klass_->get_can_refresh) {
#line 22 "../src/widgets/views/abstract-base.vala"
		return _klass_->get_can_refresh (self);
#line 634 "abstract-base.c"
	}
#line 22 "../src/widgets/views/abstract-base.vala"
	return FALSE;
#line 638 "abstract-base.c"
}

static gboolean
cassette_base_view_real_get_can_refresh (CassetteBaseView* base)
{
	gboolean result;
	CassetteBaseView* self;
#line 22 "../src/widgets/views/abstract-base.vala"
	self = base;
#line 22 "../src/widgets/views/abstract-base.vala"
	result = self->priv->_can_refresh;
#line 22 "../src/widgets/views/abstract-base.vala"
	return result;
#line 652 "abstract-base.c"
}

CassettePageRoot*
cassette_base_view_get_root_view (CassetteBaseView* self)
{
	CassettePageRoot* result;
	CassettePageRoot* _tmp0_;
#line 30 "../src/widgets/views/abstract-base.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/widgets/views/abstract-base.vala"
	_tmp0_ = self->priv->_root_view;
#line 30 "../src/widgets/views/abstract-base.vala"
	result = _tmp0_;
#line 30 "../src/widgets/views/abstract-base.vala"
	return result;
#line 668 "abstract-base.c"
}

void
cassette_base_view_set_root_view (CassetteBaseView* self,
                                  CassettePageRoot* value)
{
	CassettePageRoot* old_value;
#line 30 "../src/widgets/views/abstract-base.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/widgets/views/abstract-base.vala"
	old_value = cassette_base_view_get_root_view (self);
#line 30 "../src/widgets/views/abstract-base.vala"
	if (old_value != value) {
#line 682 "abstract-base.c"
		CassettePageRoot* _tmp0_;
#line 30 "../src/widgets/views/abstract-base.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 30 "../src/widgets/views/abstract-base.vala"
		_g_object_unref0 (self->priv->_root_view);
#line 30 "../src/widgets/views/abstract-base.vala"
		self->priv->_root_view = _tmp0_;
#line 30 "../src/widgets/views/abstract-base.vala"
		g_object_notify_by_pspec ((GObject *) self, cassette_base_view_properties[CASSETTE_BASE_VIEW_ROOT_VIEW_PROPERTY]);
#line 692 "abstract-base.c"
	}
}

static void
cassette_base_view_class_init (CassetteBaseViewClass * klass,
                               gpointer klass_data)
{
#line 20 "../src/widgets/views/abstract-base.vala"
	cassette_base_view_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/widgets/views/abstract-base.vala"
	g_type_class_adjust_private_offset (klass, &CassetteBaseView_private_offset);
#line 20 "../src/widgets/views/abstract-base.vala"
	((CassetteBaseViewClass *) klass)->first_show = (void (*) (CassetteBaseView*, GAsyncReadyCallback, gpointer)) cassette_base_view_real_first_show;
#line 20 "../src/widgets/views/abstract-base.vala"
	((CassetteBaseViewClass *) klass)->first_show_finish = (void (*) (CassetteBaseView*, GAsyncResult*)) cassette_base_view_real_first_show_finish;
#line 20 "../src/widgets/views/abstract-base.vala"
	((CassetteBaseViewClass *) klass)->refresh = (void (*) (CassetteBaseView*, GAsyncReadyCallback, gpointer)) cassette_base_view_real_refresh;
#line 20 "../src/widgets/views/abstract-base.vala"
	((CassetteBaseViewClass *) klass)->refresh_finish = (void (*) (CassetteBaseView*, GAsyncResult*)) cassette_base_view_real_refresh_finish;
#line 20 "../src/widgets/views/abstract-base.vala"
	CASSETTE_BASE_VIEW_CLASS (klass)->get_can_refresh = (gboolean (*) (CassetteBaseView*)) cassette_base_view_real_get_can_refresh;
#line 20 "../src/widgets/views/abstract-base.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_cassette_base_view_get_property;
#line 20 "../src/widgets/views/abstract-base.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_cassette_base_view_set_property;
#line 20 "../src/widgets/views/abstract-base.vala"
	G_OBJECT_CLASS (klass)->finalize = cassette_base_view_finalize;
#line 20 "../src/widgets/views/abstract-base.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_BASE_VIEW_CAN_REFRESH_PROPERTY, cassette_base_view_properties[CASSETTE_BASE_VIEW_CAN_REFRESH_PROPERTY] = g_param_spec_boolean ("can-refresh", "can-refresh", "can-refresh", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/widgets/views/abstract-base.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CASSETTE_BASE_VIEW_ROOT_VIEW_PROPERTY, cassette_base_view_properties[CASSETTE_BASE_VIEW_ROOT_VIEW_PROPERTY] = g_param_spec_object ("root-view", "root-view", "root-view", CASSETTE_TYPE_PAGE_ROOT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20 "../src/widgets/views/abstract-base.vala"
	cassette_base_view_signals[CASSETTE_BASE_VIEW_SHOW_READY_SIGNAL] = g_signal_new ("show-ready", CASSETTE_TYPE_BASE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 726 "abstract-base.c"
}

static void
cassette_base_view_instance_init (CassetteBaseView * self,
                                  gpointer klass)
{
#line 20 "../src/widgets/views/abstract-base.vala"
	self->priv = cassette_base_view_get_instance_private (self);
#line 22 "../src/widgets/views/abstract-base.vala"
	self->priv->_can_refresh = FALSE;
#line 737 "abstract-base.c"
}

static void
cassette_base_view_finalize (GObject * obj)
{
	CassetteBaseView * self;
#line 20 "../src/widgets/views/abstract-base.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CASSETTE_TYPE_BASE_VIEW, CassetteBaseView);
#line 30 "../src/widgets/views/abstract-base.vala"
	_g_object_unref0 (self->priv->_root_view);
#line 20 "../src/widgets/views/abstract-base.vala"
	G_OBJECT_CLASS (cassette_base_view_parent_class)->finalize (obj);
#line 750 "abstract-base.c"
}

 G_GNUC_NO_INLINE static GType
cassette_base_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CassetteBaseViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cassette_base_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CassetteBaseView), 0, (GInstanceInitFunc) cassette_base_view_instance_init, NULL };
	GType cassette_base_view_type_id;
	cassette_base_view_type_id = g_type_register_static (adw_bin_get_type (), "CassetteBaseView", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	CassetteBaseView_private_offset = g_type_add_instance_private (cassette_base_view_type_id, sizeof (CassetteBaseViewPrivate));
	return cassette_base_view_type_id;
}

GType
cassette_base_view_get_type (void)
{
	static gsize cassette_base_view_type_id__once = 0;
	if (g_once_init_enter (&cassette_base_view_type_id__once)) {
		GType cassette_base_view_type_id;
		cassette_base_view_type_id = cassette_base_view_get_type_once ();
		g_once_init_leave (&cassette_base_view_type_id__once, cassette_base_view_type_id);
	}
	return cassette_base_view_type_id__once;
}

static void
_vala_cassette_base_view_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	CassetteBaseView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CASSETTE_TYPE_BASE_VIEW, CassetteBaseView);
#line 20 "../src/widgets/views/abstract-base.vala"
	switch (property_id) {
#line 20 "../src/widgets/views/abstract-base.vala"
		case CASSETTE_BASE_VIEW_CAN_REFRESH_PROPERTY:
#line 20 "../src/widgets/views/abstract-base.vala"
		g_value_set_boolean (value, cassette_base_view_get_can_refresh (self));
#line 20 "../src/widgets/views/abstract-base.vala"
		break;
#line 20 "../src/widgets/views/abstract-base.vala"
		case CASSETTE_BASE_VIEW_ROOT_VIEW_PROPERTY:
#line 20 "../src/widgets/views/abstract-base.vala"
		g_value_set_object (value, cassette_base_view_get_root_view (self));
#line 20 "../src/widgets/views/abstract-base.vala"
		break;
#line 797 "abstract-base.c"
		default:
#line 20 "../src/widgets/views/abstract-base.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/widgets/views/abstract-base.vala"
		break;
#line 803 "abstract-base.c"
	}
}

static void
_vala_cassette_base_view_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	CassetteBaseView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CASSETTE_TYPE_BASE_VIEW, CassetteBaseView);
#line 20 "../src/widgets/views/abstract-base.vala"
	switch (property_id) {
#line 20 "../src/widgets/views/abstract-base.vala"
		case CASSETTE_BASE_VIEW_ROOT_VIEW_PROPERTY:
#line 20 "../src/widgets/views/abstract-base.vala"
		cassette_base_view_set_root_view (self, g_value_get_object (value));
#line 20 "../src/widgets/views/abstract-base.vala"
		break;
#line 823 "abstract-base.c"
		default:
#line 20 "../src/widgets/views/abstract-base.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/widgets/views/abstract-base.vala"
		break;
#line 829 "abstract-base.c"
	}
}

